/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 ************************************************************************/

/* function definition*/
extern struct httpform *parseargs(char *input);
extern void freeform(char *ptr);
extern int nvram_set(char *name, char *value);
extern char *ram_get(char *name);
extern int log_split();
extern void unescape(char *string);
extern int fw_header_check(char *path, int *type);

//copy from rt61 Utility sha1.h
#define A_SHA_DIGEST_LEN 20

typedef struct 
{
    UINT	H[5];
    UINT   W[80];
    int             lenW;
    UINT   sizeHi,sizeLo;
} A_SHA_CTX;

void A_SHAInit(A_SHA_CTX *ctx);
void A_SHAUpdate(A_SHA_CTX *ctx, unsigned char *dataIn, int len);
void A_SHAFinal(A_SHA_CTX *ctx, unsigned char hashout[20]);


//== SSI ================================================================
void ssi_example(FILE *out, char *ssi_arg);
char *convSpecialCharToJs(char *str);
char *convSpecialCharToHtml(char *str);
char *convSpecialChar(char *str, char *convType);

//kathy, for sta, 2006_0926
void ssi_getStaProfile(FILE *out, char *ssi_arg);
void ssi_initStaProfile(FILE *out, char *ssi_arg);
void ssi_getStaProfileName(FILE *out, char *ssi_arg);
void ssi_getStaAdhocChannel(FILE *out, char *ssi_arg);
void ssi_getStaAllProfileName(FILE *out, char *ssi_arg);
void ssi_getStaNewProfileName(FILE *out, char *ssi_arg);
void ssi_getStaSSID(FILE *out, char *ssi_arg);
void ssi_getStaNetworkType(FILE *out, char *ssi_arg);
void ssi_getStaPowerSavingMode(FILE *out, char *ssi_arg);
void ssi_getStaRTSCheck(FILE *out, char *ssi_arg);
void ssi_getStaFragmentCheck(FILE *out, char *ssi_arg);
void ssi_getStaRTS(FILE *out, char *ssi_arg);
void ssi_getStaFragment(FILE *out, char *ssi_arg);
//void ssi_getStaAdhocMode(FILE *out, char *ssi_arg);
void ssi_getStaChannel(FILE *out, char *ssi_arg);
void ssi_getStaPremableType(FILE *out, char *ssi_arg);
void ssi_getStaAuth(FILE *out, char *ssi_arg);
void ssi_getStaEncryp(FILE *out, char *ssi_arg);
void ssi_getStaKey1(FILE *out, char *ssi_arg);
void ssi_getStaKey2(FILE *out, char *ssi_arg);
void ssi_getStaKey3(FILE *out, char *ssi_arg);
void ssi_getStaKey4(FILE *out, char *ssi_arg);
void ssi_getStaKey1Type(FILE *out, char *ssi_arg);
void ssi_getStaKey2Type(FILE *out, char *ssi_arg);
void ssi_getStaKey3Type(FILE *out, char *ssi_arg);
void ssi_getStaKey4Type(FILE *out, char *ssi_arg);
void ssi_getStaKey1Length(FILE *out, char *ssi_arg);
void ssi_getStaKey2Length(FILE *out, char *ssi_arg);
void ssi_getStaKey3Length(FILE *out, char *ssi_arg);
void ssi_getStaKey4Length(FILE *out, char *ssi_arg);

void ssi_getStaKeyDefaultID(FILE *out, char *ssi_arg);
void ssi_getStaWPAPSK(FILE *out, char *ssi_arg);
//site survy
void ssi_getStaConnectionSSID(FILE *out, char *ssi_arg);
void ssi_getStaConnectionStatus(FILE *out, char *ssi_arg);
void ssi_getStaBSSIDScanList(FILE *out, char *ssi_arg);
void ssi_refreshStaSiteSurvey(FILE *out, char *ssi_arg);
void ssi_refreshStaProfile(FILE *out, char *ssi_arg);
void ssi_getStaSupportAMode(FILE *out, char *ssi_arg);
void ssi_getStaWirelessMode(FILE *out, char *ssi_arg);
void ssi_getStaCountryRegionA(FILE *out, char *ssi_arg);
void ssi_getStaCountryRegionBG(FILE *out, char *ssi_arg);
void ssi_getStaBGProtection(FILE *out, char *ssi_arg);
void ssi_getStaTxRate(FILE *out, char *ssi_arg);
void ssi_getStaTxBurst(FILE *out, char *ssi_arg);
void ssi_getStaShortSlotTime(FILE *out, char *ssi_arg);
void ssi_getStaRadioStatus(FILE *out, char *ssi_arg);
//Statistics
void ssi_getStaStatisicsTx(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxOk(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxNoBuf(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxCRCError(FILE *out, char *ssi_arg);
void ssi_getStaStatisicsRxDuplication(FILE *out, char *ssi_arg);
//Link Status
void ssi_getStaLinkStatus(FILE *out, char *ssi_arg);
void ssi_getStaConnectionStatusForLinkStatus(FILE *out, char *ssi_arg);
void ssi_getStaExtraInfo(FILE *out, char *ssi_arg);
void ssi_getStaLinkChannel(FILE *out, char *ssi_arg);
void ssi_getStaLinkTxRate(FILE *out, char *ssi_arg);
void ssi_getStaLinkRxRate(FILE *out, char *ssi_arg);
void ssi_getStaTxThroughput(FILE *out, char *ssi_arg);
void ssi_getStaRxThroughput(FILE *out, char *ssi_arg);
void ssi_getStaLinkQuality(FILE *out, char *ssi_arg);
void ssi_getStaSignalStrength(FILE *out, char *ssi_arg);
void ssi_getStaSignalStrength_1(FILE *out, char *ssi_arg);
void ssi_getStaSignalStrength_2(FILE *out, char *ssi_arg);
void ssi_getStaHT(FILE *out, char *ssi_arg);
void ssi_getStaNoiseLevel(FILE *out, char *ssi_arg);
void ssi_getStadBmisCheck(FILE *out, char *ssi_arg);
void ssi_getStaSNR0(FILE *out, char *ssi_arg);
void ssi_getStaSNR1(FILE *out, char *ssi_arg);
//about
void ssi_getStaDriverVersion(FILE *out, char *ssi_arg);
void ssi_getStaUIVersion(FILE *out, char *ssi_arg);
void ssi_getStaEEPROMVersion(FILE *out, char *ssi_arg);
void ssi_getStaFirmwareVersion(FILE *out, char *ssi_arg);
void ssi_getStaMacAddress(FILE *out, char *ssi_arg);
void ssi_getStaConnectedBSSID(FILE *out, char *ssi_arg);
void ssi_refreshSta11nConfiguration(FILE *out, char *ssi_arg);
void ssi_setRefreshSta11nConfiguration(FILE *out, char *ssi_arg);
void ssi_getHTMode(FILE *out, char *ssi_arg);
void ssi_getHTBandWidth(FILE *out, char *ssi_arg);
void ssi_getHTGI(FILE *out, char *ssi_arg);
void ssi_getHTMCS(FILE *out, char *ssi_arg);

//802.1x
#ifdef WPA_SUPPLICANT_SUPPORT
void ssi_getSta8021xKeyMgmt(FILE *out, char *ssi_arg);
void ssi_getSta8021xEAP(FILE *out, char *ssi_arg);
void ssi_getSta8021xIdentity(FILE *out, char *ssi_arg);
void ssi_getSta8021xCACert(FILE *out, char *ssi_arg);
void ssi_getSta8021xClientCert(FILE *out, char *ssi_arg);
void ssi_getSta8021xPrivateKey(FILE *out, char *ssi_arg);
void ssi_getSta8021xPrivateKeyPassword(FILE *out, char *ssi_arg);
void ssi_getSta8021xPassword(FILE *out, char *ssi_arg);
void ssi_getSta8021xTunnel(FILE *out, char *ssi_arg);
#endif

//== CGI ================================================================
void cgi_example(char *data, FILE *out);
void cgi_apply(char *data, FILE *out);

//kathy , for sta
void cgi_sta_profile(char *data, FILE *out);
void cgi_sta_add_profile_apply(char *data, FILE *out);
void cgi_sta_edit_profile_apply(char *data, FILE *out);
void cgi_sta_site_survey_connection_apply(char *data, FILE *out);
void cgi_sta_advance_apply(char *data, FILE *out);
void cgi_sta_statisics_apply(char *data, FILE *out);
void cgi_sta_link_status_apply(char *data, FILE *out);


#ifdef WPA_SUPPLICANT_SUPPORT
void exec_WPASupplicant(char* ssid, NDIS_802_11_WEP_STATUS encryp, NDIS_802_11_AUTHENTICATION_MODE auth, RT_WPA_SUPPLICANT_KEY_MGMT keymgmt, int keyidx, char* wepkey);

void conf_WPASupplicant(char* ssid, RT_WPA_SUPPLICANT_KEY_MGMT keymgmt, RT_WPA_SUPPLICANT_EAP eap, char* identity, char* password, char* cacert, char* clientcert, char* privatekey, char* privatekeypassword, char* wepkey, int keyidx, NDIS_802_11_WEP_STATUS encryp, RT_WPA_SUPPLICANT_TUNNEL tunnel, NDIS_802_11_AUTHENTICATION_MODE auth);
#endif
void sta_connection(int tmp_networktype, int tmp_auth, int tmp_encry, int tmp_defaultkeyid, PNDIS_802_11_SSID pSsid, NDIS_802_11_MAC_ADDRESS Bssid, char *tmp_wpapsk, char *tmp_key1, char *tmp_key2, char *tmp_key3, char *tmp_key4, RT_802_11_PREAMBLE tmp_preamtype, int tmp_rtscheck, NDIS_802_11_RTS_THRESHOLD tmp_rts, int tmp_fragmentcheck, NDIS_802_11_FRAGMENTATION_THRESHOLD tmp_fragment, NDIS_802_11_POWER_MODE tmp_psmode, int tmp_channel);


//
void process_ssid_map_security(char *pos);
void process_security_mapping(char *var_name, char *pos);
void process_security_item_submit(char *var_name, char *value, int security_idx);
int  init_mbss_value(int, char*);
int  save_mbss_value_to_flash(int);
int  reloadWirelessModule();
void dhcpc_dumpdns();

//-------------------------------------------------------------------------

/* List of "script" names and handlers */
/* See also definition of CGI_ENTRY in httpd.h */
CGI_ENTRY cgi_entries[] =
{
    {"cgi_example", cgi_example, NULL},
    {"/Sta/sta_profile.html", cgi_sta_profile, NULL},
    {"/Sta/add_profile_page.html", cgi_sta_add_profile_apply, NULL},
    {"/Sta/edit_profile_page.html", cgi_sta_edit_profile_apply, NULL},
    {"/Sta/sta_site_survey_connection.html", cgi_sta_site_survey_connection_apply, NULL},
    {"/Sta/sta_advance.html", cgi_sta_advance_apply, NULL},
    {"/Sta/sta_statistics.html", cgi_sta_statisics_apply, NULL},
    {"/Sta/sta_link_status.html", cgi_sta_link_status_apply, NULL},
	/* Array MUST be terminated by empty entry */
    {"", cgi_apply, NULL}
};

SSI_ENTRY ssi_entries[] =
{
    {"ssi_example", ssi_example},
	// for sta, get profile
	{"getStaProfile", ssi_getStaProfile},
   	{"initStaProfile", ssi_initStaProfile},
   	{"getStaProfileName", ssi_getStaProfileName},
	{"getStaAdhocChannel", ssi_getStaAdhocChannel},
	{"getStaAllProfileName", ssi_getStaAllProfileName},
	{"getStaNewProfileName", ssi_getStaNewProfileName},
   	{"getStaSSID", ssi_getStaSSID},
   	{"getStaNetworkType", ssi_getStaNetworkType},
   	{"getStaPowerSavingMode", ssi_getStaPowerSavingMode},
   	{"getStaRTSCheck", ssi_getStaRTSCheck},
   	{"getStaFragmentCheck", ssi_getStaFragmentCheck},
   	{"getStaRTS", ssi_getStaRTS},
   	{"getStaFragment", ssi_getStaFragment},
   	//{"getStaAdhocMode", ssi_getStaAdhocMode},
   	{"getStaChannel", ssi_getStaChannel},
   	{"getStaPremableType", ssi_getStaPremableType},
   	{"getStaAuth", ssi_getStaAuth},
   	{"getStaEncryp", ssi_getStaEncryp},
   	{"getStaKey1", ssi_getStaKey1},
   	{"getStaKey2", ssi_getStaKey2},
   	{"getStaKey3", ssi_getStaKey3},
   	{"getStaKey4", ssi_getStaKey4},
   	{"getStaKey1Type", ssi_getStaKey1Type},
   	{"getStaKey2Type", ssi_getStaKey2Type},
   	{"getStaKey3Type", ssi_getStaKey3Type},
   	{"getStaKey4Type", ssi_getStaKey4Type},
   	{"getStaKey1Length", ssi_getStaKey1Length},
   	{"getStaKey2Length", ssi_getStaKey2Length},
   	{"getStaKey3Length", ssi_getStaKey3Length},
   	{"getStaKey4Length", ssi_getStaKey4Length},
   	{"getStaKeyDefaultID", ssi_getStaKeyDefaultID},
   	{"getStaWPAPSK", ssi_getStaWPAPSK},
	{"getStaConnectionStatus", ssi_getStaConnectionStatus},
	{"getStaConnectionSSID", ssi_getStaConnectionSSID},
   	{"getStaBSSIDScanList", ssi_getStaBSSIDScanList},
	{"refreshStaSiteSurvey", ssi_refreshStaSiteSurvey},
	{"refreshStaProfile", ssi_refreshStaProfile},
	{"getStaSupportAMode", ssi_getStaSupportAMode},
	{"getStaWirelessMode", ssi_getStaWirelessMode},
	{"getStaCountryRegionA", ssi_getStaCountryRegionA},
	{"getStaCountryRegionBG", ssi_getStaCountryRegionBG},
	{"getStaBGProtection", ssi_getStaBGProtection},
	{"getStaTxRate", ssi_getStaTxRate},
	{"getStaTxBurst", ssi_getStaTxBurst},
	{"getStaShortSlotTime", ssi_getStaShortSlotTime},
	{"getStaRadioStatus", ssi_getStaRadioStatus},
	{"getStaStatisicsTx", ssi_getStaStatisicsTx},
	{"getStaStatisicsRxOk", ssi_getStaStatisicsRxOk},
	{"getStaStatisicsRxNoBuf", ssi_getStaStatisicsRxNoBuf},
	{"getStaStatisicsRxCRCError", ssi_getStaStatisicsRxCRCError},
	{"getStaStatisicsRxDuplication", ssi_getStaStatisicsRxDuplication},
	{"getStaLinkStatus", ssi_getStaLinkStatus},
	{"getStaConnectionStatusForLinkStatus", ssi_getStaConnectionStatusForLinkStatus},
	{"getStaExtraInfo", ssi_getStaExtraInfo},
	{"getStaLinkChannel", ssi_getStaLinkChannel},
	{"getStaLinkTxRate", ssi_getStaLinkTxRate},
   	{"getStaLinkRxRate", ssi_getStaLinkRxRate},
	{"getStaTxThroughput", ssi_getStaTxThroughput},
	{"getStaRxThroughput", ssi_getStaRxThroughput},
	{"getStaLinkQuality", ssi_getStaLinkQuality},
	{"getStaSignalStrength", ssi_getStaSignalStrength},
	{"getStaSignalStrength_1", ssi_getStaSignalStrength_1},
	{"getStaSignalStrength_2", ssi_getStaSignalStrength_2},
	{"getStaHT", ssi_getStaHT},
	{"getStaSNR0", ssi_getStaSNR0},
	{"getStaSNR1", ssi_getStaSNR1},
	{"getStaNoiseLevel", ssi_getStaNoiseLevel},
	{"getStadBmisCheck", ssi_getStadBmisCheck},
	{"getStaDriverVersion", ssi_getStaDriverVersion},
	{"getStaUIVersion", ssi_getStaUIVersion},
	{"getStaEEPROMVersion", ssi_getStaEEPROMVersion},
	{"getStaFirmwareVersion", ssi_getStaFirmwareVersion},
	{"getStaMacAddress", ssi_getStaMacAddress},
	{"getStaConnectedBSSID", ssi_getStaConnectedBSSID},
	{"refreshSta11nConfiguration", ssi_refreshSta11nConfiguration},
	{"setRefreshSta11nConfiguration", ssi_setRefreshSta11nConfiguration},
	{"getHTMode", ssi_getHTMode},
	{"getHTBandWidth", ssi_getHTBandWidth},
	{"getHTGI", ssi_getHTGI},
	{"getHTMCS", ssi_getHTMCS},
	
#ifdef WPA_SUPPLICANT_SUPPORT
	//802.1x
	{"getSta8021xKeyMgmt", ssi_getSta8021xKeyMgmt},
	{"getSta8021xEAP", ssi_getSta8021xEAP},
	{"getSta8021xIdentity", ssi_getSta8021xIdentity},
	{"getSta8021xCACert", ssi_getSta8021xCACert},
	{"getSta8021xClientCert", ssi_getSta8021xClientCert},
	{"getSta8021xPrivateKey", ssi_getSta8021xPrivateKey},
	{"getSta8021xPrivateKeyPassword", ssi_getSta8021xPrivateKeyPassword},
	{"getSta8021xPassword", ssi_getSta8021xPassword},
	{"getSta8021xTunnel", ssi_getSta8021xTunnel},
#endif
    /* Array MUST be terminated by empty entry */
    {"",         NULL}
};

//-------------------------------------------------------------------------

/* for 'ssi_dumpleases()' function */
#define REMAINING 0
#define ABSOLUTE 1

struct lease_t {
	unsigned char chaddr[16];
	u_int32_t yiaddr;
	u_int32_t expires;
};
//-------------------------------------------------------------------------

/* for Routing */
#define MAX_STATIC_ROUTE 8

/* for 'ssi_dumproute()' function */
#define RTF_UP          0x0001    /* route usable                */
#define RTF_REJECT      0x0200    /* Reject route                */
#define RTF_GATEWAY     0x0002    /* destination is a gateway    */
#define RTF_HOST        0x0004    /* host entry (net otherwise)  */
#define RTF_REINSTATE   0x0008    /* reinstate route after tmout */
#define RTF_DYNAMIC     0x0010    /* created dyn. (by redirect)  */
#define RTF_MODIFIED    0x0020    /* modified dyn. (by redirect) */

/* the temporary storage path for firmware upload*/
#define IMAGE_UPLOAD "/var/image"
/* the limit of maximum file size for firmware upload*/
#define IMAGE_MAX_LEN 4000000 //4MBytes
/* the limit of minimum free memory for firmware upload*/
#define IMAGE_FREE_MEM 1500 //(KB)

/* the temporary storage path for user's config file upload*/
#define CONF_UPLOAD "/tmp/conf.gdbm"
/* the limit of maximum file size for user's config file upload*/
#define CONF_MAX_LEN 50000 //50KBytes
/* the initialized CRC for checking user's config file*/
#define CONF_CRC_INIT 0x0
//-------------------------------------------------------------------------

/* the limit of maximum wireless site survey entries*/
#define WLAN_MAX_SITE 50
/* the limit of maximum wireless association list entries*/
#define WLAN_MAX_ASSO 32
//-------------------------------------------------------------------------
