/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2005, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 ************************************************************************/

/*
 *  scripts.c - handlers for "cgi && ssi scripts"
 */
#include "boa.h"
#include "nvram.h"
#include "scripts.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <netinet/in.h>    /* for sockaddr_in       */
#include <fcntl.h>
#include <time.h>
#include <sys/times.h>
#include <unistd.h>
#include <sys/socket.h>    /* for connect and socket*/
#include <sys/stat.h>
#include <err.h>
#include <errno.h>
#include <asm/types.h>
#include <linux/if.h>
#include <linux/wireless.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include "oid.h"

static int current_ssid_num = 1;
static	multi_ssid_s mBSSID[4];
int	site_survey_count = 0;
char	if_addr[16] = {0};
char	if_net[16] = {0};
char	if_hw[18] = {0};

unsigned char	Connection_flag=0, Active_flag=0, nConfig_flag=0;
unsigned int	m_nSigQua=0;
unsigned long	m_lTxCount=0;
unsigned long	m_lRxCount=0;
unsigned long	m_lChannelQuality=0;
char	G_bRadio = 1; //TRUE
char	G_bdBm_ischeck=0; //false
char	G_staProfileNum=0;
NDIS_802_11_SSID	G_SSID;
NDIS_802_11_MAC_ADDRESS	G_Bssid;
NDIS_MEDIA_STATE	G_ConnectStatus = NdisMediaStateDisconnected;

//wps, kathy
time_t wps_status_start_time = 0;

PWSC_PROFILE pWscDefaultProfile=NULL, pWscProfile=NULL;
char bk='\004';
//end

CHAR	dev_name[16];

#ifdef WPA_SUPPLICANT_SUPPORT
BOOLEAN WpaSupplicant_flag = FALSE;
#endif

//=====================================================================

//-------kathy, for Web UI , 2006 1011
//copy from rt61 sta driver, rt_tool.c
int OidQueryInformation(unsigned long OidQueryCode, int socket_id, char *DeviceName, void *ptr, unsigned long PtrLength)
{
    struct iwreq wrq;

    strcpy(wrq.ifr_name, DeviceName);
    wrq.u.data.length = PtrLength;
    wrq.u.data.pointer = (caddr_t) ptr;
    wrq.u.data.flags = OidQueryCode;

    //fprintf(stderr, "query oid=0x%08x\n", OidQueryCode);
    return (ioctl(socket_id, RT_PRIV_IOCTL, &wrq));
}

int OidSetInformation(unsigned long OidQueryCode, int socket_id, char *DeviceName, void *ptr, unsigned long PtrLength)
{
    struct iwreq wrq;

    strcpy(wrq.ifr_name, DeviceName);
    wrq.u.data.length = PtrLength;
    wrq.u.data.pointer = (caddr_t) ptr;
    wrq.u.data.flags = OidQueryCode | OID_GET_SET_TOGGLE;

	//fprintf(stderr, "set oid=0x%08x\n", OidQueryCode);
    return (ioctl(socket_id, RT_PRIV_IOCTL, &wrq));
}

unsigned int ConvertRssiToSignalQuality(NDIS_802_11_RSSI RSSI)
{
    unsigned int signal_quality;
    if (RSSI >= -50)
        signal_quality = 100;
    else if (RSSI >= -80)    // between -50 ~ -80dbm
        signal_quality = (unsigned int)(24 + (RSSI + 80) * 2.6);   
    else if (RSSI >= -90)   // between -80 ~ -90dbm
        signal_quality = (unsigned int)((RSSI + 90) * 2.6);   
    else    // < -84 dbm
        signal_quality = 0;
 
    return signal_quality;
}
//
//  FUNCTION: BtoH(char *, char *, int)
//
//  PURPOSE:  Converts ascii byte to numeric
//
//  PARAMETERS:
//    ch - ascii byte to convert
//
//  RETURNS:
//    associated numeric value
//
//  COMMENTS:
//
//    Will convert any hex ascii digit to its numeric counterpart.
//    Puts in 0xff if not a valid hex digit.
//

unsigned char BtoH(char ch)
{
    if (ch >= '0' && ch <= '9') return (ch - '0');        // Handle numerals
    if (ch >= 'A' && ch <= 'F') return (ch - 'A' + 0xA);  // Handle capitol hex digits
    if (ch >= 'a' && ch <= 'f') return (ch - 'a' + 0xA);  // Handle small hex digits
    return(255);
}

//
//  FUNCTION: AtoH(char *, unsigned char *, int)
//
//  PURPOSE:  Converts ascii string to network order hex
//
//  PARAMETERS:
//    src    - pointer to input ascii string
//    dest   - pointer to output hex
//    destlen - size of dest
//
//  COMMENTS:
//
//    2 ascii bytes make a hex byte so must put 1st ascii byte of pair
//    into upper nibble and 2nd ascii byte of pair into lower nibble.
//

void AtoH(char * src, unsigned char * dest, int destlen)
{
    char * srcptr;

    srcptr = src;
    unsigned char* destTemp = dest; 

    while(destlen--)
    {
        *destTemp = BtoH(*srcptr++) << 4;    // Put 1st ascii byte in upper nibble.
        *destTemp += BtoH(*srcptr++);      // Add 2nd ascii byte to above.
        destTemp++;
    }
}

static void hmac_sha1(unsigned char *text, int text_len, unsigned char *key, int key_len, unsigned char *digest) 
{ 
    A_SHA_CTX context; 
    unsigned char k_ipad[65]; /* inner padding - key XORd with ipad */ 
    unsigned char k_opad[65]; /* outer padding - key XORd with opad */ 
    int i; 

    /* if key is longer than 64 bytes reset it to key=SHA1(key) */ 
    if (key_len > 64) 
    { 
        A_SHA_CTX tctx; 

        A_SHAInit(&tctx); 
        A_SHAUpdate(&tctx, key, key_len); 
        A_SHAFinal(&tctx, key); 

        key_len = 20; 
    } 

    /* 
    * the HMAC_SHA1 transform looks like: 
    * 
    * SHA1(K XOR opad, SHA1(K XOR ipad, text)) 
    * 
    * where K is an n byte key 
    * ipad is the byte 0x36 repeated 64 times 
    * opad is the byte 0x5c repeated 64 times 
    * and text is the data being protected 
    */ 

    /* start out by storing key in pads */ 
    memset(k_ipad, 0, sizeof k_ipad); 
    memset(k_opad, 0, sizeof k_opad); 
    memcpy(k_ipad, key, key_len); 
    memcpy(k_opad, key, key_len); 

    /* XOR key with ipad and opad values */ 
    for (i = 0; i < 64; i++) 
    { 
        k_ipad[i] ^= 0x36; 
        k_opad[i] ^= 0x5c; 
    } 

    /* perform inner SHA1*/ 
    A_SHAInit(&context); /* init context for 1st pass */ 
    A_SHAUpdate(&context, k_ipad, 64); /* start with inner pad */ 
    A_SHAUpdate(&context, text, text_len); /* then text of datagram */ 
    A_SHAFinal(&context, digest); /* finish up 1st pass */ 

    /* perform outer SHA1 */ 
    A_SHAInit(&context); /* init context for 2nd pass */ 
    A_SHAUpdate(&context, k_opad, 64); /* start with outer pad */ 
    A_SHAUpdate(&context, digest, 20); /* then results of 1st hash */ 
    A_SHAFinal(&context, digest); /* finish up 2nd pass */ 
} 

/*
* F(P, S, c, i) = U1 xor U2 xor ... Uc 
* U1 = PRF(P, S || Int(i)) 
* U2 = PRF(P, U1) 
* Uc = PRF(P, Uc-1) 
*/ 

static void F(char *password, unsigned char *ssid, int ssidlength, int iterations, int count, unsigned char *output) 
{ 
    unsigned char digest[36], digest1[A_SHA_DIGEST_LEN]; 
    int i, j; 

    /* U1 = PRF(P, S || int(i)) */ 
    memcpy(digest, ssid, ssidlength); 
    digest[ssidlength] = (unsigned char)((count>>24) & 0xff); 
    digest[ssidlength+1] = (unsigned char)((count>>16) & 0xff); 
    digest[ssidlength+2] = (unsigned char)((count>>8) & 0xff); 
    digest[ssidlength+3] = (unsigned char)(count & 0xff); 
    hmac_sha1(digest, ssidlength+4, (unsigned char*) password, (int) strlen(password), digest1); // for WPA update

    /* output = U1 */ 
    memcpy(output, digest1, A_SHA_DIGEST_LEN); 

    for (i = 1; i < iterations; i++) 
    { 
        /* Un = PRF(P, Un-1) */ 
        hmac_sha1(digest1, A_SHA_DIGEST_LEN, (unsigned char*) password, (int) strlen(password), digest); // for WPA update
        memcpy(digest1, digest, A_SHA_DIGEST_LEN); 

        /* output = output xor Un */ 
        for (j = 0; j < A_SHA_DIGEST_LEN; j++) 
        { 
            output[j] ^= digest[j]; 
        } 
    } 
} 
/* 
* password - ascii string up to 63 characters in length 
* ssid - octet string up to 32 octets 
* ssidlength - length of ssid in octets 
* output must be 40 octets in length and outputs 256 bits of key 
*/ 
int PasswordHash(char *password, unsigned char *ssid, int ssidlength, unsigned char *output) 
{ 
    if ((strlen(password) > 63) || (ssidlength > 32)) 
        return 0; 

    F(password, ssid, ssidlength, 4096, 1, output); 
    F(password, ssid, ssidlength, 4096, 2, &output[A_SHA_DIGEST_LEN]); 
    return 1; 
}

//copy from rt61 Utility sha1.cpp, kathy
static void shaHashBlock(A_SHA_CTX *ctx);

void A_SHAInit(A_SHA_CTX *ctx) 
{
    int i;

    ctx->lenW = 0;
    ctx->sizeHi = ctx->sizeLo = 0;

    /* Initialize H with the magic constants (see FIPS180 for constants)
     */
    ctx->H[0] = 0x67452301L;
    ctx->H[1] = 0xefcdab89L;
    ctx->H[2] = 0x98badcfeL;
    ctx->H[3] = 0x10325476L;
    ctx->H[4] = 0xc3d2e1f0L;

    for (i = 0; i < 80; i++)
        ctx->W[i] = 0;
}


void A_SHAUpdate(A_SHA_CTX *ctx, unsigned char *dataIn, int len) 
{
    int i;

    /* Read the data into W and process blocks as they get full */
    for (i = 0; i < len; i++) 
    {
        ctx->W[ctx->lenW / 4] <<= 8;
        ctx->W[ctx->lenW / 4] |= (unsigned long)dataIn[i];
        if ((++ctx->lenW) % 64 == 0) 
        {
            shaHashBlock(ctx);
            ctx->lenW = 0;
        }
        ctx->sizeLo += 8;
        ctx->sizeHi += (ctx->sizeLo < 8);
    }
}


void A_SHAFinal(A_SHA_CTX *ctx, unsigned char hashout[20]) 
{
    unsigned char pad0x80 = 0x80;
    unsigned char pad0x00 = 0x00;
    unsigned char padlen[8];
    int i;

    /* Pad with a binary 1 (e.g. 0x80), then zeroes, then length */
    padlen[0] = (unsigned char)((ctx->sizeHi >> 24) & 255);
    padlen[1] = (unsigned char)((ctx->sizeHi >> 16) & 255);
    padlen[2] = (unsigned char)((ctx->sizeHi >> 8) & 255);
    padlen[3] = (unsigned char)((ctx->sizeHi >> 0) & 255);
    padlen[4] = (unsigned char)((ctx->sizeLo >> 24) & 255);
    padlen[5] = (unsigned char)((ctx->sizeLo >> 16) & 255);
    padlen[6] = (unsigned char)((ctx->sizeLo >> 8) & 255);
    padlen[7] = (unsigned char)((ctx->sizeLo >> 0) & 255);
    A_SHAUpdate(ctx, &pad0x80, 1);
    while (ctx->lenW != 56)
        A_SHAUpdate(ctx, &pad0x00, 1);
    A_SHAUpdate(ctx, padlen, 8);

    /* Output hash
     */
    for (i = 0; i < 20; i++) 
    {
        hashout[i] = (unsigned char)(ctx->H[i / 4] >> 24);
        ctx->H[i / 4] <<= 8;
    }

    /*
     *  Re-initialize the context (also zeroizes contents)
     */
    A_SHAInit(ctx); 
}

#define SHA_ROTL(X,n) ((((X) << (n)) | ((X) >> (32-(n)))) & 0xffffffffL)

static void shaHashBlock(A_SHA_CTX *ctx) 
{
    int t;
    unsigned long A,B,C,D,E,TEMP;

    for (t = 16; t <= 79; t++)
        ctx->W[t] = SHA_ROTL(ctx->W[t-3] ^ ctx->W[t-8] ^ ctx->W[t-14] ^ ctx->W[t-16], 1);

    A = ctx->H[0];
    B = ctx->H[1];
    C = ctx->H[2];
    D = ctx->H[3];
    E = ctx->H[4];

    for (t = 0; t <= 19; t++) 
    {
        TEMP = (SHA_ROTL(A,5) + (((C^D)&B)^D)     + E + ctx->W[t] + 0x5a827999L) & 0xffffffffL;
        E = D; D = C; C = SHA_ROTL(B, 30); B = A; A = TEMP;
    }
    for (t = 20; t <= 39; t++) 
    {
        TEMP = (SHA_ROTL(A,5) + (B^C^D)           + E + ctx->W[t] + 0x6ed9eba1L) & 0xffffffffL;
        E = D; D = C; C = SHA_ROTL(B, 30); B = A; A = TEMP;
    }
    for (t = 40; t <= 59; t++) 
    {
        TEMP = (SHA_ROTL(A,5) + ((B&C)|(D&(B|C))) + E + ctx->W[t] + 0x8f1bbcdcL) & 0xffffffffL;
        E = D; D = C; C = SHA_ROTL(B, 30); B = A; A = TEMP;
    }
    for (t = 60; t <= 79; t++) 
    {
        TEMP = (SHA_ROTL(A,5) + (B^C^D)           + E + ctx->W[t] + 0xca62c1d6L) & 0xffffffffL;
        E = D; D = C; C = SHA_ROTL(B, 30); B = A; A = TEMP;
    }

    ctx->H[0] += A;
    ctx->H[1] += B;
    ctx->H[2] += C;
    ctx->H[3] += D;
    ctx->H[4] += E;
}

// copy from rt61 sta utility, raconfigui.cpp
PAIR_CHANNEL_FREQ_ENTRY ChannelFreqTable[] = 
{
    // channel Frequency
    {1,     2412000},
    {2,     2417000},
    {3,     2422000},
    {4,     2427000},
    {5,     2432000},
    {6,     2437000},
    {7,     2442000},
    {8,     2447000},
    {9,     2452000},
    {10,    2457000},
    {11,    2462000},
    {12,    2467000},
    {13,    2472000},
    {14,    2484000},
    {34,    5170000},
    {36,    5180000},
    {38,    5190000},
    {40,    5200000},
    {42,    5210000},
    {44,    5220000},
    {46,    5230000},
    {48,    5240000},
    {52,    5260000},
    {56,    5280000},
    {60,    5300000},
    {64,    5320000},
    {100,   5500000},
    {104,   5520000},
    {108,   5540000},
    {112,   5560000},
    {116,   5580000},
    {120,   5600000},
    {124,   5620000},
    {128,   5640000},
    {132,   5660000},
    {136,   5680000},
    {140,   5700000},
    {149,   5745000},
    {153,   5765000},
    {157,   5785000},
    {161,   5805000},
};

int G_nChanFreqCount = sizeof (ChannelFreqTable) / sizeof(PAIR_CHANNEL_FREQ_ENTRY);


//-------------------------------end

void web_check_config_file()
{
   char *wordlist = NULL;
   char wlanbuf[128] = {0};
   int  idx, ret, parse_ret;

   wordlist = nvram_get("SSIDNum");

   current_ssid_num = atoi(wordlist);

   bzero(mBSSID, sizeof(multi_ssid_s)*4);
   parse_ret = parse_config_file();

   wordlist = nvram_get("wanConnectionMode");

   for(idx = 0; idx < current_ssid_num; idx++) {
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig ra%d up", idx);
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

      if (mBSSID[idx].SecurityMode != 4) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
      else {
         if (strcmp(wordlist, "BRIDGE") == 0) {
            memset(wlanbuf, 0, 128);
            sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
            ret = system(wlanbuf);
#ifdef USE_DEBUG
            if (ret)
               fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
            else
               fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
         }
      }

      if (mBSSID[idx].VlanId > 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/iwpriv ra%d set VLANID=%d", idx, mBSSID[idx].VlanId);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/iwpriv ra%d set VLANPriority=%d", idx, mBSSID[idx].VlanPriority);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }

   /* 1: normal  2:only start rt61apd  3:only start chilli  4: start rt61apd and chilli */
   if (parse_ret == 1) {
#ifdef USE_DEBUG
      fprintf(stderr, "boa: parse config file finish !!!!!\n");
#endif
   }
   else if (parse_ret == 2) {
#ifdef USE_DEBUG
      fprintf(stderr, "boa: parse config file finish !!!!!\n");
#endif
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/bin/rt61apd\n");
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
   }
   else if (parse_ret == 3) {
#ifdef USE_DEBUG
      fprintf(stderr, "boa: parse config file finish !!!!!\n");
#endif

      if (strcmp(wordlist, "BRIDGE") != 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/bin/chilli");
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }
   else if (parse_ret == 4) {
#ifdef USE_DEBUG
      fprintf(stderr, "boa: parse config file finish !!!!!\n");
#endif

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/bin/rt61apd\n");
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

      if (strcmp(wordlist, "BRIDGE") != 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/bin/chilli\n");
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }

   wordlist = nvram_get("WdsEnable");
   
   if (strcmp(wordlist, "0") != 0) {
      for (idx = current_ssid_num; idx < (current_ssid_num + 4); idx++) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/ifconfig ra%d up", idx);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }

   ATE_ACTION_MODE = 0;
   ATE_ACTION_START = 0;
   bzero(ateda, sizeof(char)*18);
   bzero(atesa, sizeof(char)*18);
   bzero(atebssid, sizeof(char)*18);
   //atetxpow = 0;
   atechannel = 1;

   initATEValue();
   atetxlen = 1024;
   atetxcnt = 1000;
   atetxrate = 1;
   eeprom_read_write = 0;
   eeprom_offset = 0;
   bzero(eeprom_value, sizeof(char)*5);
   mac_read_write = 0;
   mac_offset = 12288;
   bzero(mac_value, sizeof(char)*9);
   bbp_read_write = 0;
   bbp_offset = 0;
   bzero(bbp_value, sizeof(char)*5);
}

void initATEValue()
{
    char   get_ioctl_result[4096];
    char   *p_eeprom_result = NULL;
    struct iwreq pwrq;
    int    s;

   bzero(eeprom_value, sizeof(char)*5);
   s = socket(AF_INET, SOCK_DGRAM, 0);
	
   bzero(get_ioctl_result, sizeof(char)*4096);
   sprintf(get_ioctl_result, "%02x", 94);
   pwrq.u.data.pointer = (caddr_t) &get_ioctl_result[0];
   pwrq.u.data.length = 3;
   strncpy(pwrq.ifr_name, (char *)dev_name, IFNAMSIZ);
   ioctl(s, RTPRIV_IOCTL_E2P, &pwrq);
   close(s);

   p_eeprom_result = &get_ioctl_result[14];
   strncpy(eeprom_value, p_eeprom_result, 2);
   atetxfreqoffset = (int)strtol(eeprom_value, NULL, 16);

   bzero(eeprom_value, sizeof(char)*5);
   s = socket(AF_INET, SOCK_DGRAM, 0);

   bzero(get_ioctl_result, sizeof(char)*4096);
   sprintf(get_ioctl_result, "%02x", 70);
   pwrq.u.data.pointer = (caddr_t) &get_ioctl_result[0];
   pwrq.u.data.length = 3;
   strncpy(pwrq.ifr_name, (char *)dev_name, IFNAMSIZ);
   ioctl(s, RTPRIV_IOCTL_E2P, &pwrq);
   close(s);

   p_eeprom_result = &get_ioctl_result[14];
   strncpy(eeprom_value, p_eeprom_result, 2);
   atetxpow = (int)strtol(eeprom_value, NULL, 16);

   return;
}

int  parse_config_file()
{
   char tmp_buffer[260];
   char *wordlist = NULL;
   char *tok = NULL;
   int  i, wake_up_dot1x = 0;
   int  start_uam = 0;

   /* SSID */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("SSID");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "ralink-demo");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].enable = 1;
      sprintf(mBSSID[i].SSID, "%s", tok);
   }

   /* HideSSID */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("HideSSID");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].HideSSID = atoi(tok);
   }

   /* TxRate */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("TxRate");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].TxRate = atoi(tok);
   }

   /* SecurityMode */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("SecurityMode");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].SecurityMode = atoi(tok);
   	  if (mBSSID[i].SecurityMode == 4)
   	     start_uam = 1;
   }

   /* AuthMode */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("AuthMode");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "OPEN");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
   
   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
      sprintf(mBSSID[i].AuthMode, "%s", tok);
      if ((strcmp(tok, "WPA") == 0) || (strcmp(tok, "WPA2") == 0) || (strcmp(tok, "WPA1WPA2") == 0))
         wake_up_dot1x = 1;
   }
   
   /* EncrypType */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("EncrypType");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "NONE");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
      sprintf(mBSSID[i].EncrypType, "%s", tok);
   }

   /* WPAPSK */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("WPAPSK");
   if (strcmp(wordlist, "") != 0) {
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
      for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
         sprintf(mBSSID[i].WPAPSK, "%s", tok);
   }

   /* DefaultKeyID */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("DefaultKeyID");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "1");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].DefaultKeyID = atoi(tok);
   }

   /* Key1Type */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key1Type");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].Key1Type = atoi(tok);
   }

   /* Key1Str */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key1Str");
   if (strcmp(wordlist, "") != 0) {
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
      for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
         sprintf(mBSSID[i].Key1Str, "%s", tok);
   }

   /* Key2Type */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key2Type");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].Key2Type = atoi(tok);
   }

   /* Key2Str */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key2Str");
   if (strcmp(wordlist, "") != 0) {
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
      for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
         sprintf(mBSSID[i].Key2Str, "%s", tok);
   }

   /* Key3Type */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key3Type");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].Key3Type = atoi(tok);
   }

   /* Key3Str */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key3Str");
   if (strcmp(wordlist, "") != 0) {
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
      for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
         sprintf(mBSSID[i].Key3Str, "%s", tok);
   }

   /* Key4Type */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key4Type");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].Key4Type = atoi(tok);
   }

   /* Key4Str */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("Key4Str");
   if (strcmp(wordlist, "") != 0) {
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
      for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
         sprintf(mBSSID[i].Key4Str, "%s", tok);
   }

   /* IEEE8021X */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("IEEE8021X");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].IEEE8021X = atoi(tok);
   	  if (atoi(tok) == 1)
   	     wake_up_dot1x = 1;
   }

   /* PreAuth */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("PreAuth");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].PreAuth = atoi(tok);
   }

   /* Vlan Name */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("VLANName");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "ralink-vlan0");
   else if (strcmp(wordlist, "") == 0)
      strcpy(tmp_buffer, "ralink-vlan0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));
   
   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
      sprintf(mBSSID[i].VlanName, "%s", tok);
   }

   /* Vlan ID */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("VLANID");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].VlanId = atoi(tok);
   }

   /* Vlan Priority */
   bzero(tmp_buffer, sizeof(char)*260);
   wordlist = nvram_get("VLANPriority");

   if (wordlist == NULL)
      strcpy(tmp_buffer, "0");
   else
      strncpy(tmp_buffer, wordlist, strlen(wordlist));

   for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++) {
   	  mBSSID[i].VlanPriority = atoi(tok);
   }

   if ((wake_up_dot1x == 1) && (start_uam == 1))
      return 4;
   else if ((wake_up_dot1x == 0) && (start_uam == 1))
      return 3;
   else if ((wake_up_dot1x == 1) && (start_uam == 0))
      return 2;
   else
      return 1;
}

#ifdef RT61AP
int reloadWirelessModule()
{
   char *wordlist = NULL;
   char wlanbuf[128] = {0};
   int  idx, ret = 0;
   char uam_dhcp_if[4] = {0};
   int  uam_dhcp_if_idx = 0;
   int  parse_ret = 0;

   wordlist = nvram_get("SSIDNum");
   current_ssid_num = atoi(wordlist);

   for (idx = 4 + current_ssid_num - 1; idx >= 0; idx--) {
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig ra%d down", idx);
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
#endif
   }

   memset(wlanbuf, 0, 128);
   sprintf(wlanbuf, "/sbin/rmmod rt61ap");
   ret = system(wlanbuf);
#ifdef USE_DEBUG
   if (ret)
      fprintf(stderr, "boa:  (%s) fail !!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
   else
      fprintf(stderr, "boa: wlanbuf (%s) !!!!!!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
#endif

   memset(wlanbuf, 0, 128);
   sprintf(wlanbuf, "/sbin/insmod /etc/rt61ap.ko");
   ret = system(wlanbuf);
#ifdef USE_DEBUG
   if (ret)
      fprintf(stderr, "boa:  (%s) fail !!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
   else
      fprintf(stderr, "boa: wlanbuf (%s) !!!!!!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
#endif

   wordlist = nvram_get("UAMDhcpIF");
   if (wordlist == NULL)
      strcpy(uam_dhcp_if, "");
   else
      strcpy(uam_dhcp_if, wordlist);

   if (strcmp(uam_dhcp_if, "") == 0)
      uam_dhcp_if_idx = 99;
   else if (strcmp(uam_dhcp_if, "ra0") == 0)
      uam_dhcp_if_idx = 0;
   else if (strcmp(uam_dhcp_if, "ra1") == 0)
      uam_dhcp_if_idx = 1;
   else if (strcmp(uam_dhcp_if, "ra2") == 0)
      uam_dhcp_if_idx = 2;
   else if (strcmp(uam_dhcp_if, "ra3") == 0)
      uam_dhcp_if_idx = 3;

   bzero(mBSSID, sizeof(multi_ssid_s)*4);

   parse_ret = parse_config_file();

   wordlist = nvram_get("wanConnectionMode");

    /* 1: normal  2:only start rt61apd  3:only start chilli  4: start rt61apd and chilli */

   for (idx = 0; idx < current_ssid_num; idx++) {
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/sbin/ifconfig ra%d up", idx);
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

      if (idx != uam_dhcp_if_idx) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
      else {
         if (parse_ret < 3) {
            memset(wlanbuf, 0, 128);
            sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
            ret = system(wlanbuf);
#ifdef USE_DEBUG
            if (ret)
               fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
            else
               fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
         }
         else {
            if (strcmp(wordlist, "BRIDGE") == 0) {
               memset(wlanbuf, 0, 128);
               sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
               ret = system(wlanbuf);
#ifdef USE_DEBUG
               if (ret)
                  fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
               else
                  fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
            }
         }
      }

      if (mBSSID[idx].VlanId > 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/iwpriv ra%d set VLANID=%d", idx, mBSSID[idx].VlanId);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/iwpriv ra%d set VLANPriority=%d", idx, mBSSID[idx].VlanPriority);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }

   if (parse_ret == 2) {
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/bin/rt61apd\n");
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
   }
   else if (parse_ret == 3) {
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/usr/bin/killall chilli");
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
#endif

      if (strcmp(wordlist, "BRIDGE") != 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/bin/chilli\n");
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }
   else if (parse_ret == 4) {
      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/bin/rt61apd\n");
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

      memset(wlanbuf, 0, 128);
      sprintf(wlanbuf, "/usr/bin/killall chilli");
      ret = system(wlanbuf);
#ifdef USE_DEBUG
      if (ret)
         fprintf(stderr, "boa:  (%s) fail !!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
      else
         fprintf(stderr, "boa: wlanbuf (%s) !!!!!!!!!!!!!!!!!!!!!!!!\n", wlanbuf);
#endif

      if (strcmp(wordlist, "BRIDGE") != 0) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/bin/chilli\n");
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }

   wordlist = nvram_get("WdsEnable");
   
   if (strcmp(wordlist, "0") != 0) {
      for (idx = current_ssid_num; idx < (current_ssid_num + 4); idx++) {
         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/sbin/ifconfig ra%d up", idx);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif

         memset(wlanbuf, 0, 128);
         sprintf(wlanbuf, "/etc/brctl addif br0 ra%d", idx);
         ret = system(wlanbuf);
#ifdef USE_DEBUG
         if (ret)
            fprintf(stderr, "boa:  (%s) fail !!!!!\n", wlanbuf);
         else
            fprintf(stderr, "boa: wlanbuf (%s) !!!!!\n", wlanbuf);
#endif
      }
   }

   return 1;
}
#else  //RT**STA

int reloadWirelessModule()
{
	char tmp[20];
	memset(tmp, 0x00, 20);
	sprintf(tmp, "ifconfig %s down", dev_name);
	system(tmp);
	sleep(1);
	
	memset(tmp, 0x00, 20);
	sprintf(tmp, "ifconfig %s up", dev_name);
	system(tmp);
	sleep(1);
	
   return 1;
}

#endif

void ssi_example(FILE *out, char *ssi_arg)
{
    fprintf(out, "SSI");
}

char *convSpecialCharToJs(char *str)
{
	int  len, i;
	char *js_str=NULL;
	char *pOut=NULL; 

	len = strlen(str);
	js_str = (char *)malloc(sizeof(char)*len*2+1);
	memset(js_str, 0, sizeof(char)*len*2+1);
	
	pOut = &js_str[0];

	for (i=0; i<len; i++) {
	/* check special character */
 
		switch (str[i])
		{
			case 34: // "
			case 38: // &
			case 39: // '
			case 59: // ;
			case 92: // (backslash)
				sprintf(pOut, "\\%c", str[i]);
				pOut += 2;
				break;
			default:
				*pOut = str[i];
				pOut++;				
				break;
		} //end-switch
   	} //end-for
   	
 	*pOut = '\0';
 
 	return(js_str);
}

char *convSpecialCharToHtml(char *str)
{
	int  len, i;
	char *html_str=NULL;
	char *pOut=NULL; 

	len = strlen(str);
	html_str = (char *)malloc(sizeof(char)*len*6+1);
	memset(html_str, 0, sizeof(char)*len*6+1);
	
	pOut = &html_str[0];

	for (i=0; i<len; i++) {
	/* check special character */
 
		switch (str[i])
		{
			case '&': 
				strcpy(pOut, "&amp;");
				pOut += 5;
				break;
			case '<': 
				strcpy(pOut, "&lt;");
				pOut += 4;
				break;
			case '>': 
				strcpy(pOut, "&gt;");
				pOut += 4;
				break;
			case '\"':
				strcpy(pOut, "&quot;");
				pOut += 6;
				break;
			default:
				if ((str[i]>=0) && (str[i]<=31)) {
					//Device Control Characters
					sprintf(pOut, "&#%02d;", str[i]);
					pOut += 5;
				} else if ((str[i]==39) || (str[i]==47) || (str[i]==59) || (str[i]==92)) {
					// ' / ; (backslash)
					sprintf(pOut, "&#%02d;", str[i]);
					pOut += 5;
				} else if (str[i]>=127) {
					//Device Control Characters
					sprintf(pOut, "&#%03d;", str[i]);
					pOut += 6;
				} else {
					*pOut = str[i];
					pOut++;
				}
				break;
		} //end-switch
   	} //end-for
   	
 	*pOut = '\0';
 
 	return(html_str);
}

char *convSpecialChar(char *str, char *convType)
{	
	if (strcmp(convType, "js")==0) {
		//cprintf("\nConvert to Javascript\n");
		return(convSpecialCharToJs(str));
	} else if (strcmp(convType, "html")==0) {
		//cprintf("\nConvert to HTML\n");
		return(convSpecialCharToHtml(str));
	} else {
		char *ori_str=NULL;
		ori_str = (char *)malloc(sizeof(char)*strlen(str));
		memset(ori_str, 0, sizeof(char)*strlen(str));
		strcpy(ori_str, str);
		//cprintf("\nNo Convert(unknown convType)\n");
		return(ori_str);
	}
}

void ConverterToSpecialContentForSSID(char *str)

{
	int  len, i;
	char buffer[193];
	char *pOut;

	memset(buffer,0,193);
	len = strlen(str);
	pOut = &buffer[0];

    for (i = 0; i < len; i++)
	{
		/* check special character */
		switch (str[i])
		{
			case '&': 
				strcpy (pOut, "&amp;");
				pOut += 5;
				break;
			case '<': 
				strcpy (pOut, "&lt;");
				pOut += 4;
				break;
			case '>': 
				strcpy (pOut, "&gt;");
				pOut += 4;
				break;
			case '"':
				/*
					strcpy (pOut, "&#092;");
					pOut += 6;
				*/
				strcpy (pOut, "&quot;");
				pOut += 6;
				break;
			case 39: /* ' */
				/*strcpy (pOut, "&#092;");
				pOut += 6;*/
				strcpy (pOut, "&#092;");
				pOut += 6;
				sprintf (pOut, "&#%03d;", str[i]);
				pOut += 6;
				break;
			default:
				if ((str[i] == '\'') || (str[i] == '\\'))
				{
					/*
					if (str[i] == '\\')
					{
						sprintf (pOut, "&#%03d;", str[i]);
						pOut += 6;
					}
					*/
					strcpy (pOut, "&#092;");
					pOut += 6;
					sprintf (pOut, "&#%03d;", str[i]);
					pOut += 6;
				}
				else
				{
					*pOut = str[i];
					pOut++;
				}
				break;
		}
	}
	
	*pOut = '\0';
	strcpy(str, buffer); 

}


void cgi_apply(char *data, FILE *out)
{
    struct httpform *form=NULL;
    int i;

    fprintf(out, "<html><head><title>Example script</title></head><body>\n");
    form=parseargs(data);

    for(i=0;i<form->nv_ct;i++)
        fprintf(out,"%s == %s <BR>\n", form->nameval[i].name, form->nameval[i].value);

    fprintf(out,"<BR> config count : %d <BR>\n", form->nv_ct);
    fprintf(out, "</body></html>\n");

    freeform((char *)form);
}

void ConverterStringToDisplay(char *str)
{
    int  len, i;
    char buffer[193];
    char *pOut;

    memset(buffer,0,193);
    len = strlen(str);
    pOut = &buffer[0];

    for (i = 0; i < len; i++) {
	/* check special character */

	switch (str[i]) {

	case '&':
            strcpy (pOut, "&amp;");
            pOut += 5;
            break;

	case '<': 
            strcpy (pOut, "&lt;");
            pOut += 4;
            break;

	case '>': 
            strcpy (pOut, "&gt;");
            pOut += 4;
            break;

	case '"':
            strcpy (pOut, "&quot;");
            pOut += 6;
            break;

	//case ' ':
            //strcpy (pOut, "&nbsp;");
            //pOut += 6;
            //break;

	default:
			if ((str[i]>=0) && (str[i]<=31)) {
				//Device Control Characters
				sprintf(pOut, "&#%02d;", str[i]);
				pOut += 5;
			} else if ((str[i]==39) || (str[i]==47) || (str[i]==59) || (str[i]==92)) {
				// ' / ; (backslash)
				sprintf(pOut, "&#%02d;", str[i]);
				pOut += 5;
			} else if (str[i]>=127) {
				//Device Control Characters
				sprintf(pOut, "&#%03d;", str[i]);
				pOut += 6;
			} else {
				*pOut = str[i];
				pOut++;
			}
			break;
	}
    }
    *pOut = '\0';
    strcpy(str, buffer);
}

void ssi_refreshStaSiteSurvey(FILE *out, char *ssi_arg)
{
	char tmp_String[120];
	memset(tmp_String, 0x00, sizeof(tmp_String));
	if (Connection_flag)  //site_survey
		sprintf(tmp_String, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d\">", 30 );
	else
		sprintf(tmp_String, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d\">", 15 );

	//fprintf(stderr, "ssi_refreshStaSiteSurvey, tmp_String=%s\n", tmp_String);
	fprintf(out, "%s", tmp_String);
}

void ssi_refreshStaProfile(FILE *out, char *ssi_arg)
{
	char tmp_String[120];
	memset(tmp_String, 0x00, sizeof(tmp_String));
	if (Active_flag)  // profile
		sprintf(tmp_String, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d; URL=./sta_profile.html\">", 4 );

	Active_flag = 0;
	fprintf(stderr, "ssi_refreshStaProfile, tmp_String=%s\n", tmp_String);
	fprintf(out, "%s", tmp_String);
}

void ssi_refreshSta11nConfiguration(FILE *out, char *ssi_arg)
{
	//fprintf(stderr, "ssi_refreshSta11nConfiguration(), nConfig_flag=%d\n", nConfig_flag);
	NDIS_MEDIA_STATE	ConnectStatus = NdisMediaStateDisconnected;
	int s;

	if (nConfig_flag)
	{
		fprintf(out, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d\">", 1);
		nConfig_flag = 0;
		return;
	}
	
	s = socket(AF_INET, SOCK_DGRAM, 0);
	//step 1
	if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus)) < 0)
	{
		fprintf(stderr, "Query OID_GEN_MEDIA_CONNECT_STATUS error!\n");
		fprintf(out, "Sta Driver isn't exist");
		close(s);
		return;
	}

	//step 2
	if (OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &G_bRadio, sizeof(G_bRadio)) < 0)
	{
		fprintf(stderr, "Query RT_OID_802_11_RADIO error!\n");
		close(s);
		return;
	}

	if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
		fprintf(out, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d\">", 10);
	else
		fprintf(out, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d\">", 20);

	close(s);
}

void ssi_refreshStaWPSStatus(FILE *out, char *ssi_arg)
{

	INT	WscStatus;
	int s, during=0;
	s = socket(AF_INET, SOCK_DGRAM, 0);
	time_t now_time;

	if (wps_status_start_time == 0)
	{
		time(&wps_status_start_time);
		now_time = wps_status_start_time;
	}
	else
	{
		time(&now_time);
		during = now_time - wps_status_start_time;
	}

	OidQueryInformation(RT_OID_WSC_QUERY_STATUS, s, (char *)dev_name, &WscStatus, sizeof(WscStatus));
	close(s);

	if (WscStatus != STATUS_WSC_CONFIGURED && during < 120) // 2 minute
		fprintf(out, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"%d; URL=./sta_wps_status.html\">", 1 );


}


// profile page
void init_StaProfile()
{
	PRT_PROFILE_SETTING nextProfileSetting;
	char tmp_buffer[512];
	char *wordlist=NULL;
	char *tok = NULL;
	int i;

	Connection_flag = 0;

	// staProfile
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staProfile");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Profile has no data.\n");
		return;
	}

	if( headerProfileSetting == NULL )
	{
		headerProfileSetting = malloc(sizeof(RT_PROFILE_SETTING));
		memset(headerProfileSetting, 0x00, sizeof(RT_PROFILE_SETTING));
		headerProfileSetting->Next = NULL;
	}
	currentProfileSetting = headerProfileSetting;

	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";") ; tok ; i++)
	{
		//profile
		sprintf((char *)currentProfileSetting->Profile, "%s", tok);
		tok = strtok(NULL,";");

		if( tok != NULL && currentProfileSetting->Next == NULL)
		{
			nextProfileSetting = malloc(sizeof(RT_PROFILE_SETTING));
			memset(nextProfileSetting, 0x00, sizeof(RT_PROFILE_SETTING));
			nextProfileSetting->Next = NULL;

			currentProfileSetting->Next = nextProfileSetting;
			currentProfileSetting = nextProfileSetting;
		}
		else
			currentProfileSetting = currentProfileSetting->Next;
	}
	G_staProfileNum = i;

	// SSID
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staSSID");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta SSID has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		currentProfileSetting->SsidLen = strlen(tok);
		sprintf((char *)currentProfileSetting->SSID, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}
	// NetworkType
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staNetworkType");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta NetworkType has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->NetworkType = atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;

	}

	// PSMode
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staPSMode");
	if( strcmp(wordlist, "" ) == 0)	
	{
		fprintf(stderr, "Sta PSMode has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->PSmode= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}
	
	// Channel
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staChannel");
	if( strcmp(wordlist, "" ) == 0)	
	{
		fprintf(stderr, "Sta Channel has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Channel= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// PreamType
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staPreamType");
	if( strcmp(wordlist, "" ) == 0)	
	{
		fprintf(stderr, "Sta PreamType has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->PreamType= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// RTSCheck
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staRTSCheck");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta RTSCheck has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->RTSCheck= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// FragmentCheck
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staFragmentCheck");
	if( strcmp(wordlist, "" ) == 0)	
	{
		fprintf(stderr, "Sta FragmentCheck has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->FragmentCheck= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// RTS
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staRTS");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta RTS has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->RTS= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Fragment
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staFragment");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Fragment has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Fragment= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Auth
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staAuth");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Auth has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Authentication= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Encryption
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staEncrypt");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Encryption has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Encryption= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key1	
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey1");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key1 has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->Key1, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key2
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey2");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key2 has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->Key2, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key3
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey3");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key3 has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->Key3, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key4
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey4");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key4 has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->Key4, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key1Type
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey1Type");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key1Type has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key1Type= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key2Type
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey2Type");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key2Type has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key2Type= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key3Type
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey3Type");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key3Type has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key3Type= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key4Type
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey4Type");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key4Type has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key4Type= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key1Length
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey1Length");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key1Lenght has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key1Length= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key2Length
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey2Length");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key2Lenght has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key2Length= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key3Length
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey3Length");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key3Lenght has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key3Length= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// Key4Length
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKey4Length");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta Key4Length has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Key4Length= atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// DefaultKeyID
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staKeyDefaultId");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta DefaultKeyID has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->KeyDefaultId = atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// WPAPSK
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staWpaPsk");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta WPAPSK has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->WpaPsk, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

#ifdef WPA_SUPPLICANT_SUPPORT
	//keymgmt
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xKeyMgmt");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Key Mgmt has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->KeyMgmt = atoi(tok);

		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	// EAP
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xEAP");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x EAP has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->EAP = atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	//Cert ID
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xIdentity");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Identity has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->Identity, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	//Cert Password
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xPassword");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Password has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->Password, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	//Cert Client Cert Path
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xClientCert");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Client Cert has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->ClientCert, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	//Cert Private Key Path
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xPrivateKey");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Private Key has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->PrivateKey, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}
	
	//Cert Private Key Password
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xPrivateKeyPassword");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Private Key Password has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->PrivateKeyPassword, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}
	
	//Cert CA Cert
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xCACert");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x CA Cert has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer, &bk); tok; tok = strtok(NULL, &bk), i++)
	{
		sprintf((char *)currentProfileSetting->CACert, "%s", tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}

	//Tunnel
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("sta8021xTunnel");
	if( strcmp(wordlist, "" ) == 0)
	{
		fprintf(stderr, "Sta 802.1x Tunnel has no data.\n");
		return;
	}
	
	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Tunnel = atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}
	
#endif


	//Active
	bzero(tmp_buffer, sizeof(tmp_buffer));
	wordlist = nvram_get("staActive");
	if( strcmp(wordlist, "" ) == 0)	
	{
		fprintf(stderr, "Sta Active has no data.\n");
		return;
	}

	currentProfileSetting = headerProfileSetting;
	sprintf(tmp_buffer, "%s", wordlist);
	for (i = 0, tok = strtok(tmp_buffer,";"); tok; tok = strtok(NULL,";"), i++)
	{
		currentProfileSetting->Active = atoi(tok);
		if (currentProfileSetting->Next != NULL)
			currentProfileSetting = currentProfileSetting->Next;
	}
}

char* getStaProfile()
{
	char *tmpString=NULL;
	char tmpRadio[128],tmpProfile[32+32],tmpSSID[32+4*NDIS_802_11_LENGTH_SSID],tmpChannel[16], tmpAuth[18], tmpEncry[18], tmpNetworkType[32], tmpImg[32];
	int i=0, s, memsize = 0;
	char tmpConverterSSID[4*NDIS_802_11_LENGTH_SSID];

	NDIS_802_11_SSID		SsidQuery;
	NDIS_MEDIA_STATE		ConnectStatus = NdisMediaStateDisconnected;
	NDIS_802_11_WEP_STATUS		Encryp = Ndis802_11WEPDisabled;
	NDIS_802_11_AUTHENTICATION_MODE	AuthenType = Ndis802_11AuthModeOpen;
	NDIS_802_11_NETWORK_INFRASTRUCTURE	NetworkType = Ndis802_11Infrastructure;

	memsize = (sizeof(tmpRadio) + sizeof(tmpProfile) + sizeof(tmpSSID) + sizeof(tmpChannel) + sizeof(tmpAuth) + sizeof(tmpEncry) + sizeof(tmpNetworkType)) * G_staProfileNum;

	if (G_staProfileNum == 0)
		memsize = 1;

	tmpString = malloc(memsize);
	memset(tmpString, 0x00, memsize);
	bzero(tmpString, memsize);
	
	if( headerProfileSetting != NULL)
	{
		currentProfileSetting = headerProfileSetting;
		do
		{
			// check activate function for the profile
			memset(tmpProfile, 0x00, sizeof(tmpProfile));
			memset(tmpSSID, 0x00, sizeof(tmpSSID));
			memset(tmpChannel, 0x00, sizeof(tmpChannel));
			memset(tmpAuth, 0x00, sizeof(tmpAuth));
			memset(tmpEncry, 0x00, sizeof(tmpEncry));
			memset(tmpNetworkType, 0x00, sizeof(tmpNetworkType));
			memset(tmpRadio, 0x00, sizeof(tmpRadio));
			memset(tmpImg, 0x00, sizeof(tmpImg));
			if ( currentProfileSetting->Active )
			{
				memset(tmpImg, 0x00, sizeof(tmpImg));
				// get connected SSID
				s = socket(AF_INET, SOCK_DGRAM, 0);
				
				//step 1
				if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus)) < 0)
				{
					fprintf(stderr, "Query OID_GEN_MEDIA_CONNECT_STATUS error!\n");
					close(s);
					return "";
				}
			
				//step 2
				if (OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &G_bRadio, sizeof(G_bRadio)) < 0)
				{
					fprintf(stderr, "Query RT_OID_802_11_RADIO error!\n");
					close(s);
					return "";
				}

				if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
				{
					OidQueryInformation(OID_802_11_WEP_STATUS, s, (char *)dev_name, &Encryp, sizeof(Encryp) );
					OidQueryInformation(OID_802_11_AUTHENTICATION_MODE, s, (char *)dev_name, &AuthenType, sizeof(AuthenType));
					OidQueryInformation(OID_802_11_INFRASTRUCTURE_MODE, s, (char *)dev_name, &NetworkType, sizeof(NetworkType));
		
					memset(&SsidQuery, 0x00, sizeof(SsidQuery));
					OidQueryInformation(OID_802_11_SSID, s, (char *)dev_name, &SsidQuery, sizeof(SsidQuery));

					//fprintf(stderr, "currentProfileSetting->Encryption =%d, Encryp=%d, currentProfileSetting->Authentication =%d, AuthenType=%d\n", currentProfileSetting->Encryption ,Encryp, currentProfileSetting->Authentication ,AuthenType);
					if( strcmp((char *)SsidQuery.Ssid, (char *)currentProfileSetting->SSID) == 0 &&
						currentProfileSetting->Encryption == Encryp &&
						( currentProfileSetting->Authentication == Ndis802_11AuthModeMax ? AuthenType == Ndis802_11AuthModeOpen : currentProfileSetting->Authentication == AuthenType) &&
						currentProfileSetting->NetworkType == NetworkType)
					{
						memcpy(&G_SSID, &SsidQuery, sizeof(NDIS_802_11_SSID));
						sprintf(tmpImg, "<img src=\"checkmrk.gif\"> ");
					}
					else
						sprintf(tmpImg, "<img src=\"uncheckmrk.gif\"> ");

					close(s);
				}
				/*else if( G_bRadio)
				{
					int tmp_auth, tmp_encry, tmp_defaultkeyid, tmp_networktype, tmp_preamtype, tmp_channel; //tmp_adhocmode,
					char tmp_wpapsk[64], tmp_key1[27], tmp_key2[27], tmp_key3[27], tmp_key4[27], tmp_bssid[13];
					char tmp_rtscheck=0, tmp_fragmentcheck=0;
					NDIS_802_11_RTS_THRESHOLD	tmp_rts;
					NDIS_802_11_FRAGMENTATION_THRESHOLD	tmp_fragment;
					NDIS_802_11_SSID		SSID;
					NDIS_802_11_POWER_MODE		tmp_psmode;


					memset(&SSID, 0x00, sizeof(SSID));
					bzero(tmp_bssid, sizeof(tmp_bssid));
					bzero(tmp_wpapsk, sizeof(tmp_wpapsk));
					bzero(tmp_key1, sizeof(tmp_key1));
					bzero(tmp_key2, sizeof(tmp_key2));
					bzero(tmp_key3, sizeof(tmp_key3));
					bzero(tmp_key4, sizeof(tmp_key4));
					memset(tmp_wpapsk, 0x00, sizeof(tmp_wpapsk));

					SSID.SsidLength = currentProfileSetting->SsidLen;
					memcpy(SSID.Ssid, (const void *)currentProfileSetting->SSID, currentProfileSetting->SsidLen);

					tmp_networktype = currentProfileSetting->NetworkType;
					tmp_auth  = currentProfileSetting->Authentication;
					tmp_encry = currentProfileSetting->Encryption;
					tmp_preamtype = currentProfileSetting->PreamType;
					tmp_rts = currentProfileSetting->RTS;
					tmp_rtscheck = currentProfileSetting->RTSCheck;
					tmp_fragment = currentProfileSetting->Fragment;
					tmp_fragmentcheck = currentProfileSetting->FragmentCheck;
					tmp_psmode = currentProfileSetting->PSmode;
					tmp_channel = currentProfileSetting->Channel;
					tmp_defaultkeyid = currentProfileSetting->KeyDefaultId;

					sprintf((char *)tmp_wpapsk, "%s", currentProfileSetting->WpaPsk);
					strcpy(tmp_key1, (char *)currentProfileSetting->Key1);
					strcpy(tmp_key2, (char *)currentProfileSetting->Key2);
					strcpy(tmp_key3, (char *)currentProfileSetting->Key3);
					strcpy(tmp_key4, (char *)currentProfileSetting->Key4);

#ifdef WPA_SUPPLICANT_SUPPORT
					if (currentProfileSetting->Authentication == Ndis802_11AuthModeWPA ||
						currentProfileSetting->Authentication == Ndis802_11AuthModeWPA2 ||
						currentProfileSetting->Authentication == Ndis802_11AuthModeMax )//802.1x
					{
						if(ConnectStatus == NdisMediaStateDisconnected)
						{
							sleep(2);
							OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus));						
							if (ConnectStatus == NdisMediaStateConnected)
								break;
							
							char tmp_key[27];
							if (tmp_defaultkeyid == 1) // 1~4
								strcpy(tmp_key, tmp_key1);
							else if (tmp_defaultkeyid == 2)
								strcpy(tmp_key, tmp_key2);
							else if (tmp_defaultkeyid == 3)
								strcpy(tmp_key, tmp_key3);
							else if (tmp_defaultkeyid == 4)
								strcpy(tmp_key, tmp_key4);

							conf_WPASupplicant((char *)currentProfileSetting->SSID, currentProfileSetting->KeyMgmt, currentProfileSetting->EAP, (char *)currentProfileSetting->Identity, (char *)currentProfileSetting->Password, (char *)currentProfileSetting->CACert, (char *)currentProfileSetting->ClientCert, (char *)currentProfileSetting->PrivateKey, (char *)currentProfileSetting->PrivateKeyPassword, tmp_key, currentProfileSetting->KeyDefaultId-1, currentProfileSetting->Encryption, currentProfileSetting->Tunnel, currentProfileSetting->Authentication);
						}
					}
					else
#endif
					sta_connection(tmp_networktype, tmp_auth, tmp_encry, tmp_defaultkeyid, &SSID, NULL, tmp_wpapsk, tmp_key1, tmp_key2, tmp_key3, tmp_key4, tmp_preamtype, tmp_rtscheck, tmp_rts, tmp_fragmentcheck, tmp_fragment, tmp_psmode, tmp_channel);
					sprintf(tmpImg, "<img src=\"uncheckmrk.gif\"> ");
				}*/
				else
					sprintf(tmpImg, "<img src=\"uncheckmrk.gif\"> ");

			}

			// Radio
			sprintf(tmpRadio,"<td><input type=radio name=selectedProfile value=%d onClick=selectedProfileChange()></td>", i+1);

			// Profile 
			sprintf(tmpProfile,"<td>%s</td>",currentProfileSetting->Profile);

			memset(tmpConverterSSID, 0x00, sizeof(tmpConverterSSID));
			sprintf(tmpConverterSSID ,"%s", currentProfileSetting->SSID);
			ConverterStringToDisplay(tmpConverterSSID);
			sprintf(tmpSSID,"<td> %s%s </td>",tmpImg, tmpConverterSSID);
			
			// Channel
			if ( currentProfileSetting->Channel <= 0)
				sprintf(tmpChannel,"<td>%s</td>","Auto");
			else
				sprintf(tmpChannel,"<td>%d</td>", currentProfileSetting->Channel);

			// Auth
			if (currentProfileSetting->Authentication == Ndis802_11AuthModeOpen)
				sprintf(tmpAuth, "<td>%s</td>","OPEN");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeShared)
				sprintf(tmpAuth, "<td>%s</td>", "SHARED");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeWPAPSK)
				sprintf(tmpAuth, "<td>%s</td>", "WPA-PSK");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeWPA2PSK)
				sprintf(tmpAuth, "<td>%s</td>", "WPA2-PSK");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeWPANone)
				sprintf(tmpAuth, "<td>%s</td>", "WPA-NONE");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeWPA)
				sprintf(tmpAuth, "<td>%s</td>", "WPA");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeWPA2)
				sprintf(tmpAuth, "<td>%s</td>", "WPA2");
			else if (currentProfileSetting->Authentication == Ndis802_11AuthModeMax) //802.1x
				sprintf(tmpAuth, "<td>%s</td>", "OPEN");
			else
				sprintf(tmpAuth, "<td>%s</td>", "unknown");

			// Encryption
			if (currentProfileSetting->Encryption == Ndis802_11WEPEnabled)
				sprintf(tmpEncry, "<td>%s</td>", "WEP");
			else if (currentProfileSetting->Encryption == Ndis802_11WEPDisabled)
				sprintf(tmpEncry, "<td>%s</td>", "NONE");
			else if (currentProfileSetting->Encryption == Ndis802_11Encryption2Enabled)
				sprintf(tmpEncry, "<td>%s</td>", "TKIP");
			else if (currentProfileSetting->Encryption == Ndis802_11Encryption3Enabled)
				sprintf(tmpEncry, "<td>%s</td>", "AES");
			else
				sprintf(tmpEncry, "<td>%s</td>", "unknown");

			// NetworkType
			if (currentProfileSetting->NetworkType == Ndis802_11Infrastructure)
				sprintf(tmpNetworkType, "<td>%s</td>", "Infrastructure");
			else
				sprintf(tmpNetworkType, "<td>%s</td>", "Ad Hoc");

			sprintf(tmpString, "%s <tr> %s %s %s %s %s %s %s </tr>",tmpString, tmpRadio, tmpProfile, tmpSSID, tmpChannel,tmpAuth, tmpEncry, tmpNetworkType);

			currentProfileSetting = currentProfileSetting->Next;
			i++;
		}while (currentProfileSetting != NULL );
	}
	return tmpString;
}

void ssi_getStaProfile(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	init_StaProfile();

	wordlist = getStaProfile();
	fprintf(out, "%s", wordlist);
}

void ssi_initStaProfile(FILE *out, char *ssi_arg)
{
	init_StaProfile();
}
void ssi_getStaAllProfileName(FILE *out, char *ssi_arg)
{
	char tmp[256];
	memset(tmp, 0x00, sizeof(tmp));
	if( headerProfileSetting != NULL)
	{
		currentProfileSetting = headerProfileSetting;
		sprintf(tmp, "%s", currentProfileSetting->Profile);
		do
		{
			currentProfileSetting = currentProfileSetting->Next;
			if (currentProfileSetting != NULL)
				sprintf(tmp, "%s;%s", tmp, currentProfileSetting->Profile);
		}while (currentProfileSetting != NULL );

		fprintf(out, "%s", tmp);
	}
	else
		fprintf(out, " ");
}

void ssi_getStaNewProfileName(FILE *out, char *ssi_arg)
{
	if( headerProfileSetting != NULL)
	{
		int count = 1;
		currentProfileSetting = headerProfileSetting;
		do
		{
			if ( strncmp((char *)currentProfileSetting->Profile, "PROF", 4) == 0)
			{
				count = atoi((char *)&currentProfileSetting->Profile[4]);
				count++;
				currentProfileSetting = currentProfileSetting->Next;
			}
			else
			{
				currentProfileSetting = currentProfileSetting->Next;
			}
		}while (currentProfileSetting != NULL );

		fprintf(out, "PROF%03d", count);
	}
	else
		fprintf(out, "PROF001");
}

void ssi_getStaProfileName(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(strlen((char *)selectedProfileSetting->Profile)*6+1);
		sprintf(wordlist, "%s", selectedProfileSetting->Profile);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
		}

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");
	
}

void ssi_getStaAdhocChannel(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	unsigned int country_region_bg=0, country_region_a=0;
	long country_region=0;
	
	wordlist = nvram_get("staCountryRegionBG");
	country_region_bg = atoi(wordlist);

	wordlist = nvram_get("staCountryRegionA");
	country_region_a = atoi(wordlist);

	country_region = country_region_bg | ( country_region_a << 8);

	fprintf(out, "%ld", country_region);
}

void ssi_getStaSSID(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(strlen((char *)selectedProfileSetting->SSID)*6+1);
		strcpy(wordlist, (char *)selectedProfileSetting->SSID);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
		}

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}
void ssi_getStaNetworkType(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	int networktype;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		networktype = selectedProfileSetting->NetworkType;

		sprintf(wordlist, "%d", networktype);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%s", "none");

}
void ssi_getStaPowerSavingMode(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	int psmode;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		if ( selectedProfileSetting->PSmode == Ndis802_11PowerModeCAM )
			psmode = 0;
		else
			psmode = 1;
		
		sprintf(wordlist, "%d", psmode);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%s", "none");

}
void ssi_getStaRTSCheck(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	//fprintf(stderr, "ssi_getStaRTSCheck()\n");
	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->RTSCheck);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%s", "none");
}
void ssi_getStaFragmentCheck(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->FragmentCheck);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%s", "none");

}
void ssi_getStaRTS(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(8);
		sprintf(wordlist, "%d", selectedProfileSetting->RTS);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%s", "none");

}
void ssi_getStaFragment(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(8);
		sprintf(wordlist, "%d", selectedProfileSetting->Fragment);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}
void ssi_getStaChannel(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Channel);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");
}
void ssi_getStaPremableType(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	int preamtype;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);

		if ( selectedProfileSetting->PreamType == Rt802_11PreambleAuto)
			preamtype = 0;
		else
			preamtype = 1;
		sprintf(wordlist, "%d", preamtype);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");
}
void ssi_getStaAuth(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(4);
		sprintf(wordlist, "%d", selectedProfileSetting->Authentication);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");
}
void ssi_getStaEncryp(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Encryption);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");
}
void ssi_getStaKey1(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->Key1, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->Key1)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->Key1);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
		fprintf(out, "%s", "none");
}

void ssi_getStaKey2(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->Key2, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->Key2)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->Key2);
		}
		
		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
		fprintf(out, "%s", "none");
}

void ssi_getStaKey3(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->Key3, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->Key3)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->Key3);
		}
		
		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
		fprintf(out, "%s", "none");
	
}

void ssi_getStaKey4(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->Key4, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->Key4)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->Key4);
		}
		
		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey1Type(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key1Type);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey2Type(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key2Type);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey3Type(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key3Type);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey4Type(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key4Type);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey1Length(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key1Length);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");
}

void ssi_getStaKey2Length(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key2Length);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey3Length(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key3Length);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);
		
		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKey4Length(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->Key4Length);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaKeyDefaultID(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->KeyDefaultId);

		if (wordlist == NULL)
			fprintf(out, "%s", "0");
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaWPAPSK(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->WpaPsk, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->WpaPsk)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->WpaPsk);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
		fprintf(out, "%s", "none");

}

void ssi_getStaConnectionStatus(FILE *out, char *ssi_arg)
{
	int s;
	s = socket(AF_INET, SOCK_DGRAM, 0);

	if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &G_ConnectStatus, sizeof(G_ConnectStatus)) < 0)
	{
		fprintf(stderr, "Query OID_GEN_MEDIA_CONNECT_STATUS error in getStaConnectionStatus()!\n");
	}

	//fprintf(out, "%d", G_ConnectStatus);
	close(s);
}

void ssi_getStaConnectionSSID(FILE *out, char *ssi_arg)
{
	NDIS_MEDIA_STATE            ConnectStatus = NdisMediaStateDisconnected;
	NDIS_802_11_SSID            SsidQuery;
	NDIS_802_11_MAC_ADDRESS     BssidQuery;
	char                        strSSID[NDIS_802_11_LENGTH_SSID + 1];
	int    s, ret;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	//step 1
	if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus)) < 0)
	{
		fprintf(stderr, "Query OID_GEN_MEDIA_CONNECT_STATUS error!\n");
		close(s);
		return;
	}

	//step 2
	if (OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &G_bRadio, sizeof(G_bRadio)) < 0)
	{
		fprintf(stderr, "Query RT_OID_802_11_RADIO error!\n");
		close(s);
		return;
	}

	if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
	{
		memset(&SsidQuery, 0x00, sizeof(SsidQuery));
		OidQueryInformation(OID_802_11_SSID, s, (char *)dev_name, &SsidQuery, sizeof(SsidQuery));

		if (SsidQuery.SsidLength == 0)
		{
			memset(&BssidQuery, 0x00, sizeof(BssidQuery));
			ret = OidQueryInformation(OID_802_11_BSSID, s, (char *)dev_name, &BssidQuery, sizeof(BssidQuery));
			fprintf(out, "Connected <--> [%02X:%02X:%02X:%02X:%02X:%02X]", 
					BssidQuery[0], BssidQuery[1], BssidQuery[2], 
					BssidQuery[3], BssidQuery[4], BssidQuery[5]);
		}
		else
		{
			memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);
			memcpy(strSSID, SsidQuery.Ssid, SsidQuery.SsidLength);
			ConverterStringToDisplay((char *)strSSID);
			fprintf(out, "Connected <--> %s", strSSID);
		}
		Connection_flag = 1;
	}
	else if (G_bRadio)
	{
		fprintf(out, "Disconnected");
		Connection_flag = 0;
	}
	else
	{
		Connection_flag = 0;
		fprintf(out, "Radio Off");
	}

	close(s);
}

void ssi_getStaBSSIDScanList(FILE *out, char *ssi_arg)
{
	int    						s, ret;
	UINT						lBufLen = 4096, we_version=16; // 64K
	PNDIS_802_11_BSSID_LIST_EX	pBssidList;
	PNDIS_WLAN_BSSID_EX  		pBssid;
	NDIS_MEDIA_STATE            ConnectStatus = NdisMediaStateDisconnected;
	NDIS_802_11_MAC_ADDRESS     BssidQuery;

	s = socket(AF_INET, SOCK_DGRAM, 0);

	//step 1
	if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus)) < 0)
	{
		fprintf(stderr, "Query OID_GEN_MEDIA_CONNECT_STATUS error!\n");
		fprintf(out, "Sta Driver isn't exist");
		close(s);
		return;
	}

	//step 2
	if (OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &G_bRadio, sizeof(G_bRadio)) < 0)
	{
		fprintf(stderr, "Query RT_OID_802_11_RADIO error!\n");
		close(s);
		return;
	}

	if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
	{
		memset(&BssidQuery, 0x00, sizeof(BssidQuery));
		OidQueryInformation(OID_802_11_BSSID, s, (char *)dev_name, &BssidQuery, sizeof(BssidQuery));
	}

	//step 3
	if (OidSetInformation(OID_802_11_BSSID_LIST_SCAN, s, (char *)dev_name, 0, 0) < 0)
	{
		fprintf(stderr, "Set OID_802_11_BSSID_LIST_SCAN error!\n");
		return;
	}
	// wait a few seconds to get all AP.
	sleep(2);

	//step 4

	ret = OidQueryInformation(RT_OID_WE_VERSION_COMPILED, s, (char *)dev_name, &we_version, sizeof(we_version));
	if (ret< 0)
	{
		fprintf(stderr, "Query RT_OID_WE_VERSION_COMPILED error! return=%d\n", ret);
		return;
	}
	if(we_version >= 17)
		lBufLen=8192;
	else
		lBufLen=4096;

	pBssidList = (PNDIS_802_11_BSSID_LIST_EX) malloc(lBufLen);  //64k
	memset(pBssidList, 0x00, sizeof(char)*lBufLen);

	ret = OidQueryInformation(OID_802_11_BSSID_LIST, s, (char *)dev_name, pBssidList, lBufLen);

	if ( errno == E2BIG )
	{
		int t=1;
		while (errno == E2BIG && t <= 3)
		{
			lBufLen = lBufLen + 4096*t;
			free(pBssidList);
			pBssidList = (PNDIS_802_11_BSSID_LIST_EX) malloc(lBufLen);
			ret = OidQueryInformation(OID_802_11_BSSID_LIST, s, (char *)dev_name, pBssidList, lBufLen);
			if (ret < 0)
				t++;
			else 
				break;
		}
	}
	if (ret< 0)
	{
		fprintf(stderr, "Query OID_802_11_BSSID_LIST error! return=%d\n", ret);
		return;
	}
	if ( pBssidList->NumberOfItems == 0)
	{
		fprintf(stderr, "Bssid List number is 0!\n");
		return;
	}	
	else
	{
		char *tmpString;
		UCHAR tmpRadio[188], tmpBSSIDII[16], tmpBSSID[28],tmpSSID[64+NDIS_802_11_LENGTH_SSID*4], tmpRSSI[16], tmpChannel[16], tmpAuth[32], tmpEncry[20], tmpNetworkType[24], tmpImg[32];
		UCHAR tmpSSIDII[(NDIS_802_11_LENGTH_SSID+1)*4];
		int i=0, j=0, tmpStringLen=0;
		unsigned int nSigQua;
		int nChannel = 1;
		UCHAR radiocheck[8];
		
		tmpStringLen =  sizeof(char) * ( sizeof(tmpRadio) + sizeof(tmpBSSID) + sizeof(tmpSSID) + sizeof(tmpRSSI) + sizeof(tmpChannel) + sizeof(tmpAuth) + sizeof(tmpEncry) + sizeof(tmpNetworkType) ) * pBssidList->NumberOfItems;
		tmpString = malloc(tmpStringLen);
		memset(tmpString, 0x00, tmpStringLen);

		if (tmpString == 0)
		{
			fprintf(stderr, "can't allocat memory in ssi_getStaBSSIDScanList()\n");
			return;
		}

		pBssid = (PNDIS_WLAN_BSSID_EX) pBssidList->Bssid;
		for (i = 0; i < pBssidList->NumberOfItems; i++)
		{
			memset(radiocheck, 0x00, sizeof(radiocheck));		
			memset(tmpRadio, 0x00, sizeof(tmpRadio));
			memset(tmpBSSID, 0x00, sizeof(tmpBSSID));
			memset(tmpRSSI, 0x00, sizeof(tmpRSSI));
			memset(tmpSSID, 0x00, sizeof(tmpSSID));
			memset(tmpChannel, 0x00, sizeof(tmpChannel));
			memset(tmpAuth, 0x00, sizeof(tmpAuth));
			memset(tmpEncry, 0x00, sizeof(tmpEncry));
			memset(tmpNetworkType, 0x00, sizeof(tmpNetworkType));
			memset(tmpBSSIDII, 0x00, sizeof(tmpBSSIDII));
			memset(tmpImg, 0x00, sizeof(tmpImg));
			memset(tmpSSIDII, 0x00, sizeof(tmpSSIDII));


			// compare BSSID with connected bssid
			if(memcmp(BssidQuery, pBssid->MacAddress, 6) == 0)
				sprintf((char *)tmpImg, "<img src=\"handshak.gif\"> ");
			else
				sprintf((char *)tmpImg, "&nbsp;");


			if (strcmp((char *)pBssid->Ssid.Ssid, "") == 0)
				sprintf((char *)tmpSSID, "<td>%s%s</td>", tmpImg, "&nbsp;");
			else
			{
				int i = 0;
				do
				{
					if (pBssid->Ssid.Ssid[i] < 32 || pBssid->Ssid.Ssid[i] > 126 || pBssid->Ssid.Ssid[i] == 13) // 13 is string end of Dos 
					{
						strcpy((char *)pBssid->Ssid.Ssid, "&nbsp;");
						break;
					}
					i++;
				}while( i < pBssid->Ssid.SsidLength-1);

				strncpy((char *)tmpSSIDII, (char *)pBssid->Ssid.Ssid, pBssid->Ssid.SsidLength);
				ConverterStringToDisplay((char *)tmpSSIDII);
				sprintf((char *)tmpSSID, "<td>%s%s</td>", tmpImg, tmpSSIDII);
			}

			sprintf((char *)tmpBSSID, "<td>%02X-%02X-%02X-%02X-%02X-%02X</td>",
				pBssid->MacAddress[0], pBssid->MacAddress[1], pBssid->MacAddress[2],
				pBssid->MacAddress[3], pBssid->MacAddress[4], pBssid->MacAddress[5]);

			sprintf((char *)tmpBSSIDII, "%02X%02X%02X%02X%02X%02X",
				pBssid->MacAddress[0], pBssid->MacAddress[1], pBssid->MacAddress[2],
				pBssid->MacAddress[3], pBssid->MacAddress[4], pBssid->MacAddress[5]);

			nSigQua = ConvertRssiToSignalQuality(pBssid->Rssi);

       		sprintf((char *)tmpRSSI,"<td>%d%%</td>", nSigQua);
			nChannel = -1;	
			for(j = 0; j < G_nChanFreqCount; j++)
			{
				//fprintf(stderr, "pBssid->Configuration.DSConfig = %d, ChannelFreqTable[j].lFreq=%d\n ", pBssid->Configuration.DSConfig, ChannelFreqTable[j].lFreq);
				if(pBssid->Configuration.DSConfig == ChannelFreqTable[j].lFreq)
				{
					nChannel = ChannelFreqTable[j].lChannel;
					break;
				}
			}

			if(nChannel == -1)
				continue;

			sprintf((char *)tmpChannel, "<td>%u</td>", nChannel);
			if (pBssid->InfrastructureMode == Ndis802_11Infrastructure)
				sprintf((char *)tmpNetworkType, "<td>%s</td>", "Infrastructure");
			else
				sprintf((char *)tmpNetworkType, "<td>%s</td>", "Ad Hoc");
			

			// work with NDIS_WLAN_BSSID_EX
			BOOLEAN bTKIP = FALSE;
			BOOLEAN bAESWRAP = FALSE;
			BOOLEAN bAESCCMP = FALSE;
			BOOLEAN bWPA = FALSE;
			BOOLEAN bWPAPSK = FALSE;
			BOOLEAN bWPANONE = FALSE;
			BOOLEAN bWPA2 = FALSE;
			BOOLEAN bWPA2PSK = FALSE;
			BOOLEAN bWPA2NONE = FALSE;
			BOOLEAN bCCKM = FALSE; // CCKM for Cisco, add by candy 2006.11.24

			if ((pBssid->Length > sizeof(NDIS_WLAN_BSSID)) && (pBssid->IELength > sizeof(NDIS_802_11_FIXED_IEs)))
			{
				UINT lIELoc = 0;
				PNDIS_802_11_FIXED_IEs pFixIE = (PNDIS_802_11_FIXED_IEs)pBssid->IEs;
				PNDIS_802_11_VARIABLE_IEs pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pFixIE + sizeof(NDIS_802_11_FIXED_IEs));
				lIELoc += sizeof(NDIS_802_11_FIXED_IEs);

				while (pBssid->IELength > (lIELoc + sizeof(NDIS_802_11_VARIABLE_IEs)))
				{
					if ((pVarIE->ElementID == 221) && (pVarIE->Length >= 16))
					{
						//UINT* pOUI = (UINT*)((char*)pVarIE + 2);
						UINT* pOUI = (UINT*)((char*)pVarIE->data);
						if(*pOUI != WPA_OUI_TYPE)
						{
							lIELoc += pVarIE->Length;
							lIELoc += 2;
							pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pVarIE + pVarIE->Length + 2);

							if(pVarIE->Length <= 0)
								break;

							continue;
						}
						UINT* plGroupKey; 
						USHORT* pdPairKeyCount;
						UINT* plPairwiseKey=NULL;
						UINT* plAuthenKey=NULL;
						USHORT* pdAuthenKeyCount;
						plGroupKey = (UINT*)((char*)pVarIE + 8);
				
						UINT lGroupKey = *plGroupKey & 0x00ffffff;
						if (lGroupKey == WPA_OUI)
						{
							lGroupKey = (*plGroupKey & 0xff000000) >> 0x18;
							if (lGroupKey == 2)
								bTKIP = TRUE;
							else if (lGroupKey == 3)
								bAESWRAP = TRUE;

							else if (lGroupKey == 4)
								bAESCCMP = TRUE;
						}
						else
						{
							lIELoc += pVarIE->Length;
							lIELoc += 2;
							pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pVarIE + pVarIE->Length + 2);

							if(pVarIE->Length <= 0)
								break;
							
							continue;
						}
				
						pdPairKeyCount = (USHORT*)((char*)plGroupKey + 4);
						plPairwiseKey = (UINT*) ((char*)pdPairKeyCount + 2);
						USHORT k = 0;
						for( k = 0; k < *pdPairKeyCount; k++)
						{
							UINT lPairKey = *plPairwiseKey & 0x00ffffff;
							if(lPairKey == WPA_OUI )//|| (lPairKey & 0xffffff00) == WPA_OUI_1)
							{
								lPairKey = (*plPairwiseKey & 0xff000000) >> 0x18;
								if(lPairKey == 2)
									bTKIP = TRUE;
								else if(lPairKey == 3)
									bAESWRAP = TRUE;
								else if(lPairKey == 4)
									bAESCCMP = TRUE;
							}
							else
								break;
							
							++plPairwiseKey;
						}
				
						pdAuthenKeyCount = (USHORT*)((char*)pdPairKeyCount + 2 + 4 * (*pdPairKeyCount));
#ifdef RT61
						if (*pdAuthenKeyCount > 0)
						{
							plAuthenKey = (UINT*)((char*)pdAuthenKeyCount + 2);
				
							UINT lAuthenKey = *plAuthenKey & 0x00ffffff;
							if (lAuthenKey == WPA_OUI)
							{
								lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;
								if (lAuthenKey == 1)
									bWPA = TRUE;
								else if ( lAuthenKey == 0 || lAuthenKey == 2)
								{
									if (pBssid->InfrastructureMode)
										bWPAPSK = TRUE;
									else 
										bWPANONE = TRUE;
								}
							}
						}
#else
						plAuthenKey = (UINT*)((char*)pdAuthenKeyCount + 2);
						for(k = 0; k < *pdAuthenKeyCount; k++)
						{
							UINT lAuthenKey = *plAuthenKey & 0x00ffffff;
							if(lAuthenKey == CISCO_OUI)
							{
								bCCKM = TRUE; // CCKM for Cisco
							}
							else if (lAuthenKey == WPA_OUI)
							{
								lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;

								if(lAuthenKey == 1)
									bWPA = TRUE;
								else if(lAuthenKey == 0 || lAuthenKey == 2)
								{
									if(pBssid->InfrastructureMode)
										bWPAPSK = TRUE;
									else
										bWPANONE = TRUE;
								}
							}

							++plAuthenKey;

						}
#endif						
					//break;
					}
					else if(pVarIE->ElementID == 48 && pVarIE->Length >= 12)
					{
						UINT* plGroupKey; 
						UINT* plPairwiseKey; 
						USHORT* pdPairKeyCount;
						UINT* plAuthenKey; 
						USHORT* pdAuthenKeyCount;
						plGroupKey = (UINT*)((char*)pVarIE + 4);

						UINT lGroupKey = *plGroupKey & 0x00ffffff;
						if(lGroupKey == WPA2_OUI)
						{
							lGroupKey = (*plGroupKey & 0xff000000) >> 0x18;
							if(lGroupKey == 2)
								bTKIP = TRUE;
							else if(lGroupKey == 3)
								bAESWRAP = TRUE;
							else if(lGroupKey == 4)
								bAESCCMP = TRUE;
						}
						else
						{
							lIELoc += pVarIE->Length;
							lIELoc += 2;
							pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pVarIE + pVarIE->Length + 2);

							if(pVarIE->Length <= 0)
								break;
							
							continue;
						}

						pdPairKeyCount = (USHORT*)((char*)plGroupKey + 4);
						plPairwiseKey = (UINT*)((char*)pdPairKeyCount + 2);
						USHORT k = 0;
						for( k = 0; k < *pdPairKeyCount; k++)
						{
							UINT lPairKey = *plPairwiseKey & 0x00ffffff;
							if(lPairKey == WPA2_OUI)
							{
								lPairKey = (*plPairwiseKey & 0xff000000) >> 0x18;
								if(lPairKey == 2)
									bTKIP = TRUE;
								else if(lPairKey == 3)
									bAESWRAP = TRUE;
								else if(lPairKey == 4)
									bAESCCMP = TRUE;
							}
							else
								break;
			
							++plPairwiseKey;
						}
			
						pdAuthenKeyCount = (USHORT*)((char*)pdPairKeyCount + 2 + 4 * *pdPairKeyCount);
						plAuthenKey = (UINT*)((char*)pdAuthenKeyCount + 2);
#ifdef RT61
						if(*pdAuthenKeyCount > 0)
						{
							plAuthenKey = (UINT*)((char*)pdAuthenKeyCount + 2);
			
							UINT lAuthenKey = *plAuthenKey & 0x00ffffff;
							if(lAuthenKey == WPA2_OUI)
							{
								lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;
								if(lAuthenKey == 1)
									bWPA2 = TRUE;
								else if(lAuthenKey == 0 || lAuthenKey == 2)
								{
									if(pBssid->InfrastructureMode)
										bWPA2PSK = TRUE;
									else
										bWPA2NONE = TRUE;
								}
							}
						}
#else
						for(k = 0; k < *pdAuthenKeyCount; k++)
						{
							UINT lAuthenKey = *plAuthenKey & 0x00ffffff;
							if(lAuthenKey == CISCO_OUI)
							{
								bCCKM = TRUE; // CCKM for Cisco
							}
	                        else if (lAuthenKey == WPA2_OUI)
							{
								lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;
								if(lAuthenKey == 1)
									bWPA2 = TRUE;
								else if(lAuthenKey == 0 || lAuthenKey == 2)
								{
									if(pBssid->InfrastructureMode)
										bWPA2PSK = TRUE;
									else
										bWPA2NONE = TRUE;
								}
							}					
							++plAuthenKey;
						}
#endif
			
					}
			
					lIELoc += pVarIE->Length;
					lIELoc += 2;
					pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pVarIE + pVarIE->Length + 2);

					if(pVarIE->Length <= 0)
						break;
				}
			}

			char strAuth[32], strEncry[32];
			memset( strAuth, 0x00, sizeof(strAuth) );
			memset( strEncry, 0x00, sizeof(strEncry) );
			if(bCCKM)
				strcpy(strAuth, "CCKM; ");
			if (bWPA)
				strcpy(strAuth, "WPA; ");
			if (bWPAPSK)
				strcat(strAuth, "WPA-PSK; ");
			if (bWPANONE)
				strcat(strAuth, "WPA-NONE; ");
			if (bWPA2)
				strcat(strAuth, "WPA2; ");
			if (bWPA2PSK)
				strcat(strAuth, "WPA2-PSK; ");
			if (bWPA2NONE)
				strcat(strAuth, "WPA2-NONE; ");
			
			if (strlen(strAuth) > 0)
			{
				strncpy((char *)tmpAuth, strAuth, strlen(strAuth) - 2);
				strcpy(strAuth, (char *)tmpAuth);
			}
			else
			{
				strcpy((char *)strAuth, "Unknown");
			}

			if(bTKIP)
				strcpy(strEncry, "TKIP; ");
			if(bAESWRAP || bAESCCMP)
				strcat(strEncry, "AES; ");


			if(strlen(strEncry) > 0)
			{
				strncpy((char *)tmpEncry, strEncry, strlen(strEncry) - 2);
				strcpy(strEncry, (char *)tmpEncry);
			}
			else
			{
				if (pBssid->Privacy)  // privacy value is on/of
					strcpy(strEncry, "WEP");
				else
				{
					strcpy(strEncry, "Not Use");
					strcpy(strAuth, "OPEN");
				}
			}

			sprintf((char *)tmpAuth, "<td>%s</td>", strAuth);
			sprintf((char *)tmpEncry, "<td>%s</td>", strEncry);


			strcpy((char *)tmpSSIDII, (char *)pBssid->Ssid.Ssid);
			ConverterToSpecialContentForSSID((char *)tmpSSIDII);
			if (strlen((char *)G_SSID.Ssid)>0 && strcmp((char *)pBssid->Ssid.Ssid, (char *)G_SSID.Ssid) == 0)
				strcpy((char *)radiocheck, "checked");
			else
				strcpy((char *)radiocheck, "");

			sprintf((char *)tmpRadio, "<td><input type=radio name=selectedSSID %s onClick=\"selectedSSIDChange(\\'%s\\',\\'%s\\',%d,%d,\\'%s\\',\\'%s\\')\"></td>", radiocheck, tmpSSIDII, tmpBSSIDII, pBssid->InfrastructureMode, nChannel, strEncry, strAuth);
			sprintf(tmpString, "%s <tr> %s %s %s %s %s %s %s %s </tr>",tmpString, tmpRadio, tmpSSID, tmpBSSID, tmpRSSI, tmpChannel, tmpEncry, tmpAuth, tmpNetworkType);
			pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);

		}
		fprintf(out, "%s", tmpString);
		free(tmpString);
	}
	free(pBssidList);
	close(s);
}
void ssi_getStaSupportAMode(FILE *out, char *ssi_arg)
{
	unsigned long lBufLen = sizeof(NDIS_802_11_NETWORK_TYPE_LIST) + sizeof(NDIS_802_11_NETWORK_TYPE)*3 ;
	PNDIS_802_11_NETWORK_TYPE_LIST pNetworkTypeList = (PNDIS_802_11_NETWORK_TYPE_LIST) malloc(lBufLen);
	int i, s, G_bSupportAMode=0;
	
	s = socket(AF_INET, SOCK_DGRAM, 0);
	if(OidQueryInformation(OID_802_11_NETWORK_TYPES_SUPPORTED, s, (char *)dev_name, pNetworkTypeList, lBufLen) >= 0)
	{
		for (i = 0 ; i < pNetworkTypeList->NumberOfItems ; i++)
		{
			if ( pNetworkTypeList->NetworkType[i] == Ndis802_11OFDM5 )
			{
				G_bSupportAMode = 1;
				break;
			}
		}
	}
	free(pNetworkTypeList);
	fprintf(out, "%d", G_bSupportAMode);
	close(s);
}


void ssi_getStaWirelessMode(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	wordlist = nvram_get("staWirelessMode");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);

	return;
}

void ssi_getStaCountryRegionA(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	wordlist = nvram_get("staCountryRegionA");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
		
	return;
}
void ssi_getStaCountryRegionBG(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	wordlist = nvram_get("staCountryRegionBG");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
		
	return;

}

void ssi_getStaBGProtection(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	wordlist = nvram_get("staBGProtection");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
		
	return;

}

void ssi_getStaTxRate(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	wordlist = nvram_get("staTxRate");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
		
	return;

}

void ssi_getStaTxBurst(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	wordlist = nvram_get("staTxBurst");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
		
	return;

}

void ssi_getStaShortSlotTime(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	
	wordlist = nvram_get("staShortSlotTime");
	
	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else if (strcmp(wordlist, "") == 0)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
		
	return;

}

void ssi_getStaRadioStatus(FILE *out, char *ssi_arg)
{
	unsigned long RadioStatus=0;
	int s, ret;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	ret = OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &RadioStatus, sizeof(RadioStatus));
	if(ret < 0)
		fprintf(stderr, "ssi_getStaRadioStatus(): Query RT_OID_802_11_RADIO error!\n");

	fprintf(out, "%ld", RadioStatus);

	close(s);
}

void ssi_getStaStatisicsTx(FILE *out, char *ssi_arg)
{
	NDIS_802_11_STATISTICS	Statistics;
	char	tmpStatisics[16];
	char 	tmpString[128*12];
	//char 	*tmpString;
	int s, ret=0;
	
	s = socket(AF_INET, SOCK_DGRAM, 0);

	memset(&tmpStatisics, 0x00, sizeof(tmpStatisics));
	memset(&tmpString, 0x00, sizeof(tmpString));

	// Transmit Section
	memset(&Statistics, 0x00, sizeof(Statistics));
	ret = OidQueryInformation(OID_802_11_STATISTICS, s, (char *)dev_name, &Statistics, sizeof(Statistics));
	if ( ret  >= 0)
	{
		// Frames Transmitted Successfully
		sprintf(tmpStatisics, "%8lld", Statistics.TransmittedFragmentCount.QuadPart);
		sprintf(tmpString,"<tr><td width=\"65%%\" bgcolor=\"#E8F8FF\" > %s </td> <td> %s </td></tr>", "Frames Transmitted Successfully", tmpStatisics);
		// Frames Transmitted Successfully  Without Retry(s) 
		sprintf(tmpStatisics, "%8lld", Statistics.TransmittedFragmentCount.QuadPart - Statistics.RetryCount.QuadPart);
		sprintf(tmpString,"%s <tr><td width=\"65%%\" bgcolor=\"#E8F8FF\" > %s </td> <td> %s </td></tr>", tmpString, "Frames Transmitted Successfully Without Retry", tmpStatisics);
		
		// Frames Transmitted Successfully After Retry(s)
		sprintf(tmpStatisics, "%8lld", Statistics.RetryCount.QuadPart);
		sprintf(tmpString, "%s <tr><td width=\"65%%\" bgcolor=\"#E8F8FF\" >%s</td><td>%s</td></tr>", tmpString, "Frames Transmitted Successfully After Retry(s)", tmpStatisics);

		// Frames Fail To Receive ACK After All Retries
		sprintf(tmpStatisics, "%8lld", Statistics.FailedCount.QuadPart);
		sprintf(tmpString,"%s <tr><td width=\"65%%\" bgcolor=\"#E8F8FF\" > %s </td> <td> %s </td></tr>", tmpString, "Frames Fail To Receive ACK After All Retries", tmpStatisics);
		
		// RTS Frames Successfully Receive CTS
		sprintf(tmpStatisics, "%8lld", Statistics.RTSSuccessCount.QuadPart);
		sprintf(tmpString,"%s <tr><td width=\"65%%\" bgcolor=\"#E8F8FF\" > %s </td> <td> %s </td></tr>", tmpString, "RTS Frames Sucessfully Receive CTS", tmpStatisics);
		
		// RTS Frames Fail To Receive CTS
		sprintf(tmpStatisics, "%8lld", Statistics.RTSFailureCount.QuadPart);
		sprintf(tmpString,"%s <tr><td width=\"65%%\" bgcolor=\"#E8F8FF\" > %s </td> <td> %s </td></tr>", tmpString, "RTS Frames Fail To Receive CTS", tmpStatisics);

		fprintf(out, "%s", tmpString);
	}
	else
		fprintf(out, "<tr><td>%s</td></tr>", "no data");

	close(s);
	return;
}

void ssi_getStaStatisicsRxOk(FILE *out, char *ssi_arg)
{
	unsigned long	lRcvOk = 0;
	int s;
	
	s = socket(AF_INET, SOCK_DGRAM, 0);

	// Frames Received Successfully
	if (OidQueryInformation(OID_GEN_RCV_OK, s, (char *)dev_name, &lRcvOk, sizeof(lRcvOk)) >= 0)
		fprintf(out, "%ld", lRcvOk);
	else
		fprintf(out, "%d", 0);

	close(s);
}

void ssi_getStaStatisicsRxNoBuf(FILE *out, char *ssi_arg)
{
	unsigned long	lRcvNoBuf = 0;
	int s;
	
	s = socket(AF_INET, SOCK_DGRAM, 0);

	// Frames Dropped Due To Out-of-Resource
	if (OidQueryInformation(OID_GEN_RCV_NO_BUFFER, s, (char *)dev_name, &lRcvNoBuf, sizeof(lRcvNoBuf)) >= 0)
		fprintf(out, "%ld", lRcvNoBuf);
	else
		fprintf(out, "%d", 0);

	close(s);
}

void ssi_getStaStatisicsRxCRCError(FILE *out, char *ssi_arg)
{
	NDIS_802_11_STATISTICS	Statistics;
	
	int s;
	memset(&Statistics, 0x00, sizeof(Statistics));

	s = socket(AF_INET, SOCK_DGRAM, 0);
	// Frames Received With CRC Error
	if( OidQueryInformation(OID_802_11_STATISTICS, s, (char *)dev_name, &Statistics, sizeof(Statistics)) >= 0)
		fprintf(out, "%8lld", Statistics.FCSErrorCount.QuadPart);
	else
		fprintf(out, "%d", 0);

	close(s);
}

void ssi_getStaStatisicsRxDuplication(FILE *out, char *ssi_arg)
{
	NDIS_802_11_STATISTICS	Statistics;
	
	int s;
	s = socket(AF_INET, SOCK_DGRAM, 0);

	memset(&Statistics, 0x00, sizeof(Statistics));
	// Duplicate Frames Received
	if( OidQueryInformation(OID_802_11_STATISTICS, s, (char *)dev_name, &Statistics, sizeof(Statistics)) >= 0)
		fprintf(out, "%8lld", Statistics.FrameDuplicateCount.QuadPart);
	else
		fprintf(out, "%d", 0);

	close(s);
}

void ssi_getStaConnectionStatusForLinkStatus(FILE *out, char *ssi_arg)
{
	//NDIS_MEDIA_STATE	ConnectStatus = NdisMediaStateDisconnected;
	int s;

	s = socket(AF_INET, SOCK_DGRAM, 0);

	/*ret = OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus));
	if (ret < 0 )
	{
		fprintf(out, "%s", IDS_DISCONNECTED);
		return ;
	}*/

	if ( G_ConnectStatus == NdisMediaStateConnected)
	{
		NDIS_802_11_SSID SSID;
		NDIS_802_11_MAC_ADDRESS Bssid;
		char *tmpSsid;

		memset( &SSID, 0x00, sizeof(NDIS_802_11_SSID) );
		OidQueryInformation(OID_802_11_SSID, s, (char *)dev_name, &SSID, sizeof(NDIS_802_11_SSID));
		
		memset(&Bssid,0x00, sizeof(NDIS_802_11_MAC_ADDRESS));
		OidQueryInformation(OID_802_11_BSSID, s, (char *)dev_name, Bssid, sizeof(NDIS_802_11_MAC_ADDRESS));
		
		SSID.Ssid[SSID.SsidLength]=0;
		tmpSsid = malloc(SSID.SsidLength*6+1);
		strcpy(tmpSsid, (char *)SSID.Ssid);
		ConverterStringToDisplay(tmpSsid);
		fprintf(out, "%s <--> %02X-%02X-%02X-%02X-%02X-%02X", tmpSsid,
				Bssid[0], Bssid[1], Bssid[2], Bssid[3], Bssid[4], Bssid[5]);
	}
	else
	{
		if (OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &G_bRadio, sizeof(G_bRadio)) < 0)
		{
			fprintf(stderr, "Query RT_OID_802_11_RADIO error!\n");
			close(s);
			return;
		}
		if (G_bRadio)
		{
			RT_802_11_STA_CONFIG configSta;
			OidQueryInformation(RT_OID_802_11_STA_CONFIG, s, (char *)dev_name, &configSta, sizeof(RT_802_11_STA_CONFIG));
			if(configSta.HwRadioStatus == 0) // Hardware radio off
				fprintf(out, "%s", IDS_RADIOOFF);
			else	
				fprintf(out, "%s", IDS_DISCONNECTED);
		}
		else
			fprintf(out, "%s", IDS_RADIOOFF);
	}
	close(s);
}

// Extra Info 
EXTRA_INFO_DATA ExtraInfoTable[] =
{
	{GENERAL_LINK_UP,		IDS_GENERAL_LINK_UP},
	{GENERAL_LINK_DOWN,		IDS_GENERAL_LINK_DOWN},
	{HW_RADIO_OFF,			IDS_HW_RADIO_OFF},
	{SW_RADIO_OFF,			IDS_SW_RADIO_OFF},
	{AUTH_FAIL,			IDS_AUTH_FAIL},
	{AUTH_FAIL_KEYS,		IDS_AUTH_FAIL_KEYS},
	{ASSOC_FAIL,			IDS_ASSOC_FAIL},
	{EAP_MIC_FAILURE,		IDS_EAP_MIC_FAILURE},
	{EAP_4WAY_TIMEOUT,		IDS_EAP_4WAY_TIMEOUT},
	{EAP_GROUP_KEY_TIMEOUT,	IDS_EAP_GROUP_KEY_TIMEOUT},
	{EAP_SUCCESS,			IDS_EAP_SUCCESS},
};

void ssi_getStaExtraInfo(FILE *out, char *ssi_arg)
{
	unsigned long lExtraInfo;
	int s, ret, i;
	s = socket(AF_INET, SOCK_DGRAM, 0);
	
	ret = OidQueryInformation(RT_OID_802_11_EXTRA_INFO, s, (char *)dev_name, &lExtraInfo, 4);
	if (ret < 0 )
		fprintf(out, "&nbsp;");
	else
	{
		if(lExtraInfo <= EXTRA_INFO_MAX)
		{
			for(i = 0; i <= EXTRA_INFO_MAX; i++)
			{
				if(lExtraInfo == ExtraInfoTable[i].nExtraInfoDef)
				{
					fprintf(out, "%s", ExtraInfoTable[i].nExtraInfoString);
					break;
				}
			}
		}
		else
			fprintf(out, "&nbsp;");
	}
	close(s);
}

void ssi_getStaLinkChannel(FILE *out, char *ssi_arg)
{
	NDIS_802_11_CONFIGURATION Configuration;
	RT_802_11_LINK_STATUS       LinkStatus;
	int s, i;
	int nChannel = -1;
	int Japan_channel = 200;
	HTTRANSMIT_SETTING HTSetting;

	if (G_ConnectStatus == NdisMediaStateDisconnected)
	{
		fprintf(out, "&nbsp;");
		return ;
	}

	s = socket(AF_INET, SOCK_DGRAM, 0);
	// Current Channel
	OidQueryInformation(OID_802_11_CONFIGURATION, s, (char *)dev_name, &Configuration, sizeof(NDIS_802_11_CONFIGURATION));
	for(i = 0; i < G_nChanFreqCount; i++)
	{
		if(Configuration.DSConfig == ChannelFreqTable[i].lFreq)
		{
			nChannel = ChannelFreqTable[i].lChannel;
			break;
		}
	}

	memset(&HTSetting, 0x00, sizeof(HTTRANSMIT_SETTING));
	OidQueryInformation(RT_OID_802_11_QUERY_LAST_TX_RATE, s, (char *)dev_name, &HTSetting, sizeof(HTTRANSMIT_SETTING));

	

#ifndef RT61
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(&LinkStatus));
#endif

	if(nChannel == -1)
		fprintf(stderr, "ssi_getStaConnectionChannel()--Can't find suitable nChannel\n");

#ifdef RT61  // no support N mode
	else
		fprintf(out, "%u <--> ld KHz", nChannel, Configuration.DSConfig);
#else
	else if(HTSetting.field.MODE > 1) // 0: CCK, 1:OFDM, 2:Mixedmode, 3:GreenField
	{
		if (nChannel == (Japan_channel + 8))
			fprintf(out, "J8 <--> %ld KHz ; Central Channel: %ld", Configuration.DSConfig, LinkStatus.CentralChannel);
		else if (nChannel == (Japan_channel + 12))
			fprintf(out, "J12 <--> %ld KHz ; Central Channel: %ld", Configuration.DSConfig, LinkStatus.CentralChannel);
		else if (nChannel == (Japan_channel + 16))
			fprintf(out, "J16 <--> %ld KHz ; Central Channel: %ld", Configuration.DSConfig, LinkStatus.CentralChannel);
		else
			fprintf(out, "%u <--> %ld KHz ; Central Channel: %ld", nChannel, Configuration.DSConfig, LinkStatus.CentralChannel);
	}
	else if(HTSetting.field.MODE <= 1)
	{
		if (nChannel == (Japan_channel + 8))
			fprintf(out, "J8 <--> %ld KHz ", Configuration.DSConfig);
		else if (nChannel == (Japan_channel + 12))
			fprintf(out, "J12 <--> %ld KHz ", Configuration.DSConfig);
		else if (nChannel == (Japan_channel + 16))
			fprintf(out, "J16 <--> %ld KHz ", Configuration.DSConfig);
		else
			fprintf(out, "%u <--> %ld KHz ", nChannel, Configuration.DSConfig);
	}

#endif
	close(s);
}

void ssi_getStaLinkStatus(FILE *out, char *ssi_arg)
{
	RT_802_11_LINK_STATUS       LinkStatus;
	int s;
	s = socket(AF_INET, SOCK_DGRAM, 0);

	if (OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(&LinkStatus)) >= 0)
	{
		m_lTxCount = LinkStatus.TxByteCount;
		m_lRxCount = LinkStatus.RxByteCount;
	}
	close(s);


	fprintf(out, "<META HTTP-EQUIV=\"refresh\" CONTENT=\"2; URL=./sta_link_status.html\">");
}

char bGetHTTxRateByBW_GI_MCS(int nBW, int nGI, int nMCS, double* dRate)
{
	double HTTxRate20_800[16]={6.5, 13.0, 19.5, 26.0, 39.0, 52.0, 58.5, 65.0, 13.0, 26.0, 39.0, 52.0, 78.0, 104.0, 117.0, 130.0};
	double HTTxRate20_400[16]={7.2, 14.4, 21.7, 28.9, 43.3, 57.8, 65.0, 72.2, 14.444, 28.889, 43.333, 57.778, 86.667, 115.556, 130.000, 144.444};
	double HTTxRate40_800[18]={13.5, 27.0, 40.5, 54.0, 81.0, 108.0, 121.5, 135.0, 27.0, 54.0, 81.0, 108.0, 162.0, 216.0, 243.0, 270.0, 6.0, 39.0};
	double HTTxRate40_400[18]={15.0, 30.0, 45.0, 60.0, 90.0, 120.0, 135.0, 150.0, 30.0, 60.0, 90.0, 120.0, 180.0, 240.0, 270.0, 300.0, 6.7, 43.3};

	// no TxRate for (BW = 20, GI = 400, MCS = 32) & (BW = 20, GI = 400, MCS = 32)
    if (((nBW == BW_20) && (nGI == GI_400) && (nMCS == 32)) || 
        ((nBW == BW_20) && (nGI == GI_800) && (nMCS == 32)))
    {
        return 0;
    }

	if( nBW == BW_20 && nGI == GI_800)
		*dRate = HTTxRate20_800[nMCS];
	else if( nBW == BW_20 && nGI == GI_400)
		*dRate = HTTxRate20_400[nMCS];
	else if( nBW == BW_40 && nGI == GI_800)
		*dRate = HTTxRate40_800[nMCS];
	else if( nBW == BW_40 && nGI == GI_400)
		*dRate = HTTxRate40_400[nMCS];
	else
		return 0; //false

    return 1; //true
}
void DisplayLastTxRxRateFor11n(int s, int nID, double* fLastTxRxRate)
{
	unsigned long lHTSetting;
	HTTRANSMIT_SETTING HTSetting;
	double b_mode[] ={1, 2, 5.5, 11};
	float g_Rate[] = { 6,9,12,18,24,36,48,54};

	OidQueryInformation(nID, s, (char *)dev_name, &lHTSetting, sizeof(lHTSetting));

	memset(&HTSetting, 0x00, sizeof(HTSetting));
    memcpy(&HTSetting, &lHTSetting, sizeof(HTSetting));

	switch(HTSetting.field.MODE)
	{
		case 0:
			if(HTSetting.field.MCS >=0 && HTSetting.field.MCS<=3)
				*fLastTxRxRate = b_mode[HTSetting.field.MCS];
			else if	(HTSetting.field.MCS >=8 && HTSetting.field.MCS<=11)
				*fLastTxRxRate = b_mode[HTSetting.field.MCS-8];
			else
				*fLastTxRxRate = 0;

			break;
		case 1:
			if ((HTSetting.field.MCS >= 0) && (HTSetting.field.MCS < 8))
				*fLastTxRxRate = g_Rate[HTSetting.field.MCS];
	        else
				*fLastTxRxRate = 0;

			break;
		case 2:
		case 3:
			if (0 == bGetHTTxRateByBW_GI_MCS(HTSetting.field.BW, 
                                               HTSetting.field.ShortGI, 
                                               HTSetting.field.MCS, 
                                               fLastTxRxRate))
        	{
				*fLastTxRxRate = 0;
	        }
			break;
		default:
			*fLastTxRxRate = 0;
			break;
	}

	//fprintf(stderr, "fLastTxRxRate=%f\n", *fLastTxRxRate);
}
void ssi_getStaLinkTxRate(FILE *out, char *ssi_arg)
{
	int s;

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "%d", 0);
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);

#ifdef RT61
	RT_802_11_LINK_STATUS LinkStatus;
	// Get Link Status Info from driver
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(RT_802_11_LINK_STATUS));

	// Current Tx Rate LinkStatus.CurrTxRate / 2(secs)
	fprintf(out, "%.1f", (double)(LinkStatus.CurrTxRate) / 2);
#else
	double fLastTxRate = 1;
	DisplayLastTxRxRateFor11n(s, RT_OID_802_11_QUERY_LAST_TX_RATE, &fLastTxRate);
	fprintf(out, "%.1f", fLastTxRate);
#endif

	close(s);
}

void ssi_getStaLinkRxRate(FILE *out, char *ssi_arg)
{
	int s;

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "%d", 0);
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);

	double fLastRxRate = 1;
	DisplayLastTxRxRateFor11n(s, RT_OID_802_11_QUERY_LAST_RX_RATE, &fLastRxRate);
	fprintf(out, "%.1f", fLastRxRate);

	close(s);
}

void ssi_getStaTxThroughput(FILE *out, char *ssi_arg)
{
	RT_802_11_LINK_STATUS LinkStatus;
	int s;

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "%d", 0);
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);
	// Get Link Status Info from driver
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(RT_802_11_LINK_STATUS));
	
	// Tx Throughput (KBits/sec) (LinkStatus.TxByteCount - m_lTxCount) * 8(bits) /1000 / 2(secs)
	if (m_lTxCount != 0)
		fprintf(out, "%.1f", (double)(LinkStatus.TxByteCount - m_lTxCount) / 250);
	else
		fprintf(out, "%.1f", (double)0);

	m_lTxCount = LinkStatus.TxByteCount;
	close(s);
}

void ssi_getStaRxThroughput(FILE *out, char *ssi_arg)
{
	RT_802_11_LINK_STATUS LinkStatus;
	int s;

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "%d", 0);
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);
	
	// Get Link Status Info from driver
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(RT_802_11_LINK_STATUS));

	// Rx Throughput (KBits/sec) (LinkStatus.RxByteCount - m_lRxCount) * 8(bits) /1000 / 2(secs)
	if (m_lRxCount != 0)
		fprintf(out, "%.1f", (double)(LinkStatus.RxByteCount - m_lRxCount) / 250);
	else
		fprintf(out, "%.1f", (double)0);

	m_lRxCount = LinkStatus.RxByteCount;
	close(s);
}

void ssi_getStaLinkQuality(FILE *out, char *ssi_arg)
{
	RT_802_11_LINK_STATUS LinkStatus;
	int s;
	char tmp[8];

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "0%%");
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);

	// Get Link Status Info from driver
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(RT_802_11_LINK_STATUS));

	LinkStatus.ChannelQuality = (unsigned long)(LinkStatus.ChannelQuality * 1.2 + 10);
	if(LinkStatus.ChannelQuality > 100)
		LinkStatus.ChannelQuality = 100;
	if(m_lChannelQuality != 0)
		LinkStatus.ChannelQuality = (unsigned long)((m_lChannelQuality + LinkStatus.ChannelQuality) / 2.0 + 0.5);

	m_lChannelQuality = LinkStatus.ChannelQuality;

	if(LinkStatus.ChannelQuality > 70)
	{
		sprintf(tmp, "%s", IDS_LINK_GOOD);
	}
	else if(LinkStatus.ChannelQuality > 40)
	{
		sprintf(tmp, "%s", IDS_LINK_NORMAL);
	}
	else
	{
		sprintf(tmp, "%s", IDS_LINK_WEAK);
	}

	fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %ld%%", tmp, LinkStatus.ChannelQuality);
	close(s);
}

void getRSSI(FILE *out, int oid)
{
	RT_802_11_LINK_STATUS LinkStatus;
	int s;
	unsigned int nSigQua;
	char tmp[8];

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "0%%");
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);
	
	// Get Link Status Info from driver
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, s, (char *)dev_name, &LinkStatus, sizeof(RT_802_11_LINK_STATUS));

	// Signal Strength

	// Get Rssi Value from driver
	NDIS_802_11_RSSI RSSI;
	OidQueryInformation(oid, s, (char *)dev_name, &RSSI, sizeof(NDIS_802_11_RSSI));

	// Use convert formula to getSignal Quality
	nSigQua = ConvertRssiToSignalQuality(RSSI);
	if(m_nSigQua !=0)
	nSigQua = (unsigned int)((m_nSigQua + nSigQua) / 2.0 + 0.5);

	m_nSigQua = nSigQua;
	if(nSigQua > 70)
	{
		sprintf(tmp, "%s", IDS_LINK_GOOD);
		if(G_bdBm_ischeck == 1) //checked
		{
			fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %ld dBm", tmp,RSSI);
		}
		else
		{
			fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %d%%", tmp, nSigQua);
		}
	}
	else if(nSigQua > 40)
	{
		sprintf(tmp, "%s", IDS_LINK_NORMAL);
		if(G_bdBm_ischeck == 1) //checked
		{
			fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %ld dBm", tmp,RSSI);
		}
		else
		{
			fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %d%%", tmp, nSigQua);
		}
	}
	else
	{
		sprintf(tmp, "%s", IDS_LINK_WEAK);
		
		if(G_bdBm_ischeck == 1) //checked
		{
			fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %ld dBm", tmp,RSSI);
		}
		else
		{
			fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %d%%", tmp, nSigQua);
		}
	}
	close(s);
}

void ssi_getStaSignalStrength(FILE *out, char *ssi_arg)
{
	getRSSI(out, RT_OID_802_11_RSSI);
}

void ssi_getStaSignalStrength_1(FILE *out, char *ssi_arg)
{
	getRSSI(out, RT_OID_802_11_RSSI_1);
}

void ssi_getStaSignalStrength_2(FILE *out, char *ssi_arg)
{
	getRSSI(out, RT_OID_802_11_RSSI_2);
}


void ssi_getStaNoiseLevel(FILE *out, char *ssi_arg)
{
	//NDIS_MEDIA_STATE	ConnectStatus = NdisMediaStateDisconnected;
	unsigned char lNoise; // this value is (ULONG) in Ndis driver (NOTICE!!!)
	int nNoiseDbm;
	int nNoisePercent;	
	int s;
	char tmp[10];
	

	//OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus));
	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "0%%");
		//close(s);
		return ;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);

	// Noise Level
	// Get Noise Level From Driver	
	OidQueryInformation(RT_OID_802_11_QUERY_NOISE_LEVEL, s, (char *)dev_name, &lNoise, sizeof(lNoise));

	nNoiseDbm = lNoise;
	nNoiseDbm -= 143;
	nNoisePercent = (nNoiseDbm + 100) * 10 / 3;
	
	if (nNoisePercent > 100)
		nNoisePercent =100;
	else if (nNoisePercent < 0)
		nNoisePercent =0;
	

	// Show the NoiseLevel Strength Word & Percentage
	if(nNoisePercent > 90)
		sprintf(tmp, "Strength");
	else if(nNoisePercent > 50)
		sprintf(tmp, "Normal");
	else
		sprintf(tmp, "Low");

	// Percentage	
	if(G_bdBm_ischeck)
	{
		fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %d dBm", tmp, nNoiseDbm);
	}
	else
	{
		fprintf(out, "%s &nbsp;&nbsp;&nbsp;&nbsp; %d%%", tmp, nNoisePercent);
	}

	close(s);
}

void ssi_getStaHT(FILE *out, char *ssi_arg)
{
	INT s;
	HTTRANSMIT_SETTING HTSetting;
	HTTRANSMIT_SETTING	tmpHT;
	UCHAR	tmp[8], tmpBW[72], tmpGI[72], tmpSTBC[72], tmpMCS[72];

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		sprintf((char *)tmpBW, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >BW</td><td >n/a</td></tr>");
		sprintf((char *)tmpGI, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >GI</td><td >n/a</td></tr>");
		sprintf((char *)tmpSTBC,"<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >STBC</td><td >n/a</td></tr>");
		sprintf((char *)tmpMCS, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >MCS</td><td >n/a</td></tr>");		
		

		fprintf(out,"%s %s %s %s", tmpBW, tmpGI, tmpSTBC, tmpMCS);
		return ;
	}
	
	s = socket(AF_INET, SOCK_DGRAM, 0);

	OidQueryInformation(RT_OID_802_11_QUERY_LAST_TX_RATE, s, (char *)dev_name, &tmpHT, sizeof(HTTRANSMIT_SETTING));
	memset(&HTSetting, 0x00, sizeof(HTTRANSMIT_SETTING));
	memcpy(&HTSetting, &tmpHT, sizeof(HTTRANSMIT_SETTING));


	if(HTSetting.field.MODE > 1) // 0: CCK, 1:OFDM, 2:Mixedmode, 3:GreenField
	{
		if (HTSetting.field.BW == 0)
			strcpy((char *)tmp, "20");
		else
			strcpy((char *)tmp, "40");
		sprintf((char *)tmpBW, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >BW</td><td >%s</td></tr>",tmp);

		if (HTSetting.field.ShortGI == 0)
			strcpy((char *)tmp, "long");
		else
			strcpy((char *)tmp, "short");
		sprintf((char *)tmpGI, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >GI</td><td >%s</td></tr>",tmp);

		if (HTSetting.field.STBC == 0)
			strcpy((char *)tmp, "none");
		else
			strcpy((char *)tmp, "used");
		sprintf((char *)tmpSTBC, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >STBC</td><td >%s</td></tr>",tmp);

		sprintf((char *)tmpMCS, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >MCS</td><td >%d</td></tr>",HTSetting.field.MCS);
	}
	else
	{
		sprintf((char *)tmpBW, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >BW</td><td >n/a</td></tr>");
		sprintf((char *)tmpGI, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >GI</td><td >n/a</td></tr>");
		sprintf((char *)tmpSTBC,"<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >STBC</td><td >n/a</td></tr>");
		sprintf((char *)tmpMCS, "<tr><td width=\"35%%\" bgcolor=\"#E8F8FF\" >MCS</td><td >n/a</td></tr>");		
	}
		

	fprintf(out,"%s %s %s %s", tmpBW, tmpGI, tmpSTBC, tmpMCS);

	close(s);
}

void ssi_getStaSNR0(FILE *out, char *ssi_arg)
{
	int s;
	unsigned long SNR0;
	HTTRANSMIT_SETTING HTSetting;
	HTTRANSMIT_SETTING tmpHT;

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "n/a");
		return;
	}


	s = socket(AF_INET, SOCK_DGRAM, 0);

	OidQueryInformation(RT_OID_802_11_QUERY_LAST_TX_RATE, s, (char *)dev_name, &tmpHT, sizeof(HTTRANSMIT_SETTING));
	memset(&HTSetting, 0x00, sizeof(HTTRANSMIT_SETTING));
	memcpy(&HTSetting, &tmpHT, sizeof(HTTRANSMIT_SETTING));


	if(HTSetting.field.MODE > 1) // 0: CCK, 1:OFDM, 2:Mixedmode, 3:GreenField
	{
		OidQueryInformation(RT_OID_802_11_SNR_0, s, (char *)dev_name, &SNR0, sizeof(SNR0));

		if(SNR0 != 44)
			fprintf(out, "%ld", SNR0);
		else
			fprintf(out, "n/a");
	}
	else
		fprintf(out, "n/a");

	close(s);
}

void ssi_getStaSNR1(FILE *out, char *ssi_arg)
{
	int s;
	unsigned long SNR1;
	HTTRANSMIT_SETTING HTSetting;
	HTTRANSMIT_SETTING tmpHT;

	if ( G_ConnectStatus == NdisMediaStateDisconnected )
	{
		fprintf(out, "n/a");
		return;
	}
	
	s = socket(AF_INET, SOCK_DGRAM, 0);

	OidQueryInformation(RT_OID_802_11_QUERY_LAST_TX_RATE, s, (char *)dev_name, &tmpHT, sizeof(HTTRANSMIT_SETTING));
	memset(&HTSetting, 0x00, sizeof(HTTRANSMIT_SETTING));
	memcpy(&HTSetting, &tmpHT, sizeof(HTTRANSMIT_SETTING));

	if(HTSetting.field.MODE > 1) // 0: CCK, 1:OFDM, 2:Mixedmode, 3:GreenField
	{
		OidQueryInformation(RT_OID_802_11_SNR_1, s, (char *)dev_name, &SNR1, sizeof(SNR1));

		if(SNR1 != 44)
			fprintf(out, "%ld", SNR1);
		else
			fprintf(out, "n/a");
	}
	else
		fprintf(out, "n/a");
	
	close(s);
}

void ssi_getStadBmisCheck(FILE *out, char *ssi_arg)
{
	fprintf(out, "%d", G_bdBm_ischeck);
}

void ssi_getStaDriverVersion(FILE *out, char *ssi_arg)
{
	RT_VERSION_INFO	DriverVersionInfo;
	int s;

	s = socket(AF_INET, SOCK_DGRAM, 0);

	//Driver
	if(OidQueryInformation(RT_OID_VERSION_INFO, s, (char *)dev_name, &DriverVersionInfo, sizeof(DriverVersionInfo)) >= 0)
	{
		fprintf(out, "%d.%d.%d.%d", DriverVersionInfo.DriverVersionW, DriverVersionInfo.DriverVersionX, DriverVersionInfo.DriverVersionY, DriverVersionInfo.DriverVersionZ);	
	}
	else
		fprintf(out, "&nbsp;");

	close(s);
}

void ssi_getStaUIVersion(FILE *out, char *ssi_arg)
{
	fprintf(out, "%s", STA_WEBUI_VERSION);
}

void ssi_getStaEEPROMVersion(FILE *out, char *ssi_arg)
{
	unsigned char	chEEPROMVer[4];
	int s;

	s = socket(AF_INET, SOCK_DGRAM, 0);

	//EEPROM
	if( OidQueryInformation(RT_OID_802_11_QUERY_EEPROM_VERSION, s, (char *)dev_name, &chEEPROMVer, sizeof(unsigned char)*4) >= 0)
	{
		fprintf(out, "%d.%d", chEEPROMVer[0], chEEPROMVer[1]);
	}
	else
		fprintf(out, "&nbsp;");

	close(s);
}

void ssi_getStaFirmwareVersion(FILE *out, char *ssi_arg)
{
	unsigned char chFirmwareVer[4];
	int s;

	s = socket(AF_INET, SOCK_DGRAM, 0);

	//Firmware 
	if( OidQueryInformation(RT_OID_802_11_QUERY_FIRMWARE_VERSION, s, (char *)dev_name, &chFirmwareVer, sizeof(unsigned char)*4) >= 0)
	{
		fprintf(out, "%d.%d", chFirmwareVer[1], chFirmwareVer[0]);
	}
	else
		fprintf(out, "&nbsp;");

	close(s);
}

void ssi_getStaMacAddress(FILE *out, char *ssi_arg)
{
	NDIS_802_11_MAC_ADDRESS         CurrentAddress;
	int s;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	if(OidQueryInformation(OID_802_3_CURRENT_ADDRESS, s, (char *)dev_name, &CurrentAddress, sizeof(CurrentAddress)) >= 0)
	{
		fprintf(out, "%02X-%02X-%02X-%02X-%02X-%02X", CurrentAddress[0], CurrentAddress[1],
		CurrentAddress[2], CurrentAddress[3], CurrentAddress[4], CurrentAddress[5]);
	}
	else
		fprintf(out, "&nbsp;");

	close(s);
}

void ssi_getStaConnectedBSSID(FILE *out, char *ssi_arg)
{
	NDIS_MEDIA_STATE            ConnectStatus = NdisMediaStateDisconnected;
	NDIS_802_11_MAC_ADDRESS     BssidQuery;
	int    s;

	s = socket(AF_INET, SOCK_DGRAM, 0);

	//step 1
	if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, s, (char *)dev_name, &ConnectStatus, sizeof(ConnectStatus)) < 0)
	{
		fprintf(stderr, "Query OID_GEN_MEDIA_CONNECT_STATUS error!\n");
		close(s);
		return;
	}

	//step 2
	if (OidQueryInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &G_bRadio, sizeof(G_bRadio)) < 0)
	{
		fprintf(stderr, "Query RT_OID_802_11_RADIO error!\n");
		close(s);
		return;
	}

	if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
	{
		memset(&BssidQuery, 0x00, sizeof(BssidQuery));
		OidQueryInformation(OID_802_11_BSSID, s, (char *)dev_name, &BssidQuery, sizeof(BssidQuery));
			fprintf(out, "<tr><td><input type=checkbox name=mac onClick=selectedBSSID(\'%02X%02X%02X%02X%02X%02X\')> %02X:%02X:%02X:%02X:%02X:%02X</td></tr>",
					BssidQuery[0], BssidQuery[1], BssidQuery[2],BssidQuery[3], BssidQuery[4], BssidQuery[5],
					BssidQuery[0], BssidQuery[1], BssidQuery[2],BssidQuery[3], BssidQuery[4], BssidQuery[5]);
	}

	close(s);
}

void ssi_setRefreshSta11nConfiguration(FILE *out, char *ssi_arg)
{
	nConfig_flag = 1;
}

void ssi_getHTMode(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	wordlist = nvram_get("staHT_OpMode");

	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);
}

void ssi_getHTBandWidth(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	wordlist = nvram_get("staHT_BW");

	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);

}

void ssi_getHTGI(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	wordlist = nvram_get("staHT_GI");

	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);

}

void ssi_getHTMCS(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;
	//int mcs_index;

	wordlist = nvram_get("staHT_MCS");

	if (wordlist == NULL)
		fprintf(out, "%s", "0");
	else
		fprintf(out, "%s", wordlist);

}
#ifdef WPA_SUPPLICANT_SUPPORT
//kathy, 802.1x
void ssi_getSta8021xKeyMgmt(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);
		sprintf(wordlist, "%d", selectedProfileSetting->KeyMgmt);


		if (wordlist == NULL)
			fprintf(out, "%d", Rtwpa_supplicantKeyMgmtNONE);
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%d", Rtwpa_supplicantKeyMgmtNONE);

}
void ssi_getSta8021xEAP(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);

		sprintf(wordlist, "%d", selectedProfileSetting->EAP);


		if (wordlist == NULL)
			fprintf(out, "%d", Rtwpa_supplicantEAPNONE);
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%d", Rtwpa_supplicantEAPNONE);
}
void ssi_getSta8021xIdentity(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->Identity, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->Identity)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->Identity);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
			fprintf(out, "%s", "none");
}

void ssi_getSta8021xCACert(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->CACert, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->CACert)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->CACert);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
			fprintf(out, "%s", "none");
}

void ssi_getSta8021xClientCert(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->ClientCert, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->ClientCert)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->ClientCert);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
			fprintf(out, "%s", "none");
}

void ssi_getSta8021xPrivateKey(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->PrivateKey, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->PrivateKey)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->PrivateKey);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
			fprintf(out, "%s", "none");
}

void ssi_getSta8021xPrivateKeyPassword(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->PrivateKeyPassword, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->PrivateKeyPassword)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->PrivateKeyPassword);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
			fprintf(out, "%s", "none");
}

void ssi_getSta8021xPassword(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		if ( strcmp((char *)selectedProfileSetting->Password, "0") != 0)
		{
			wordlist = malloc(strlen((char *)selectedProfileSetting->Password)*6+1);
			sprintf(wordlist, "%s", selectedProfileSetting->Password);
		}

		if (wordlist == NULL)
			fprintf(out, "%s", "");
		else
		{
			ConverterStringToDisplay(wordlist);
			fprintf(out, "%s", wordlist);
			free(wordlist);
		}
	}
	else
			fprintf(out, "%s", "none");
}

void ssi_getSta8021xTunnel(FILE *out, char *ssi_arg)
{
	char *wordlist=NULL;

	if (selectedProfileSetting != NULL)
	{
		wordlist = malloc(2);

		sprintf(wordlist, "%d", selectedProfileSetting->Tunnel);


		if (wordlist == NULL)
			fprintf(out, "%d", Rtwpa_supplicantTUNNENONE);
		else
			fprintf(out, "%s", wordlist);

		free(wordlist);
	}
	else
			fprintf(out, "%d", Rtwpa_supplicantTUNNENONE);
}
#endif

//wpa , kathy
PUCHAR WPSTLV(char *data, int data_len, int fine_type)
{
	UCHAR *tmp;
	UCHAR type[2], len[2];
	UCHAR *value, *retvalue;
	int i=0, j=0;

	tmp = (PUCHAR)(data+4);
	for (i=0 ; i<(data_len-4) ; )
	{
		type[0] = *tmp;
		type[1] = *(tmp+1);

		len[0] = *(tmp+2);
		len[1] = *(tmp+3);

		retvalue = value = malloc(len[1]);
		memset(value, 0x00, len[1]);

		tmp = tmp+4;
		for (j=0; j < len[1]; j++)
		{
			value[j]= *tmp;
			tmp++;
		}

		if ( type[0] == (fine_type &0x00ff) && type[1] == (fine_type>>8))
			return retvalue;

		i = i+4+len[1];
	}
	return NULL;

}


//==============================================================================

void cgi_example(char *data, FILE *out)
{
#if 0
    struct httpform *form=NULL;
    int i;

    fprintf(out, "<html><head><title>Example script</title></head><body>\n");
    fprintf(out, "Raw data supplied:<p>"
            "<tt>%s</tt><p>\n", data);
    form=parseargs(data);

    for(i=0;i<form->nv_ct;i++)
        fprintf(out,"name%d = %s    value%d == %s <BR>",i,form->nameval[i].name,i,form->nameval[i].value);
    fprintf(out, "</body></html>\n");

    freeform((char *)form);
#endif
}


//kathy , for sta, 2006-0915
//
int writeProfileToFile(PRT_PROFILE_SETTING profileSetting)
{
	int len=0;
	FILE *WriteProfileId;

	if ( (WriteProfileId = fopen("/etc/Wireless/RT61STA/rt61sta.ui", "wb")) !=NULL)
	{
		len = fwrite(profileSetting, sizeof(RT_PROFILE_SETTING), 1, WriteProfileId);
		fclose(WriteProfileId);
	}
	return len;
}
void writeProfileToNvram()
{
	char tmp_buffer[512], tmp_data[8];
	int len;
	
	//profile name
	bzero(tmp_buffer, 512);
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(tmp_buffer, (char *)currentProfileSetting->Profile);
		currentProfileSetting = currentProfileSetting->Next;

		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
		
	}while( currentProfileSetting != NULL);
	nvram_set("staProfile", tmp_buffer);

	//ssid
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->SSID);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("staSSID", tmp_buffer);

	//NetworkType
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->NetworkType);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staNetworkType", tmp_buffer);

	//PSMode
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->PSmode);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");	
	}while( currentProfileSetting != NULL);
	nvram_set("staPSMode", tmp_buffer);

	//Channel
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Channel);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staChannel", tmp_buffer);
		
	//PreamType
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->PreamType);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staPreamType", tmp_buffer);

	//RTSCheck
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->RTSCheck);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staRTSCheck", tmp_buffer);

	//FragmentCheck
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->FragmentCheck);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staFragmentCheck", tmp_buffer);

	//AdhocMode
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->RTS);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staRTS", tmp_buffer);

	//Fragment
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Fragment);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staFragment", tmp_buffer);
	/* Security Policy */

	//Authentication
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Authentication);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staAuth", tmp_buffer);

	//Encryption
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Encryption);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staEncrypt", tmp_buffer);

	//KeyDefaultId
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->KeyDefaultId);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKeyDefaultId", tmp_buffer);

	//Key1Type
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key1Type);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey1Type", tmp_buffer);

	//Key2Type
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key2Type);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey2Type", tmp_buffer);

	//Key3Type
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key3Type);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey3Type", tmp_buffer);

	//Key4Type
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key4Type);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey4Type", tmp_buffer);

	//Key1Lenght
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key1Length);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey1Length", tmp_buffer);

	//Key2Length
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key2Length);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey2Length", tmp_buffer);

	//Key3Length
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key3Length);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey3Length", tmp_buffer);

	//Key4Length
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Key4Length);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
	}while( currentProfileSetting != NULL);
	nvram_set("staKey4Length", tmp_buffer);


	//Key1
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->Key1);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("staKey1", tmp_buffer);

	//Key2
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->Key2);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("staKey2", tmp_buffer);

	//Key3
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->Key3);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("staKey3", tmp_buffer);

	//Key4
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->Key4);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("staKey4", tmp_buffer);

	//WpaPsk
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->WpaPsk);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("staWpaPsk", tmp_buffer);

#ifdef WPA_SUPPLICANT_SUPPORT
	//Key Mgmt
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->KeyMgmt);
		strcat(tmp_buffer, tmp_data);

		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");	
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xKeyMgmt", tmp_buffer);

	//EAP
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->EAP);
		strcat(tmp_buffer, tmp_data);

		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");	
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xEAP", tmp_buffer);
	
	//Tunnel
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Tunnel);
		strcat(tmp_buffer, tmp_data);

		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");	
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xTunnel", tmp_buffer);
	
	//Identity
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->Identity);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xIdentity", tmp_buffer);
	
	//Password
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->Password);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xPassword", tmp_buffer);
	
	//Client Cert Path
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->ClientCert);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xClientCert", tmp_buffer);
	
	//Private Key
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->PrivateKey);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xPrivateKey", tmp_buffer);

	//Private Key Password
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->PrivateKeyPassword);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xPrivateKeyPassword", tmp_buffer);

	//CA CertPath
	bzero(tmp_buffer, 512);
	len = 0;
	currentProfileSetting = headerProfileSetting;
	do
	{
		strcat(&tmp_buffer[len], (char *)currentProfileSetting->CACert);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
		{
			len = strlen(tmp_buffer);
			tmp_buffer[len] = bk;
			len++;
		}
	}while( currentProfileSetting != NULL);
	nvram_set("sta8021xCACert", tmp_buffer);
	
#endif

	//Active
	bzero(tmp_buffer, 512);
	bzero(tmp_data, 8);
	currentProfileSetting = headerProfileSetting;
	do
	{
		sprintf(tmp_data, "%d", currentProfileSetting->Active);
		strcat(tmp_buffer, tmp_data);
		currentProfileSetting = currentProfileSetting->Next;
		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");	
	}while( currentProfileSetting != NULL);
	nvram_set("staActive", tmp_buffer);

}

void cgi_sta_profile(char *data, FILE *out)
{
	PRT_PROFILE_SETTING	previousProfileSetting = NULL;
	int selectedProfile = 0 , i=0, j=0;
	struct httpform *form=NULL;
	char *name=NULL;
	char *wordlist=NULL;
	char tmpString[8];
	
	if ( headerProfileSetting == NULL)
		return;
	
	selectedProfileSetting = NULL;
	form=parseargs(data);
	for(i=0; i < form->nv_ct; i++)
	{
		wordlist=NULL;
		name = form->nameval[i].name;
		
		if (strcmp(name, "hiddenButton") == 0)
		{
			if (form->nameval[i].value == NULL)
				continue;

			sprintf(tmpString, "%s", form->nameval[i].value);
			if( strcmp(tmpString, "delete") == 0)
			{
				fprintf(stderr, "deleteProfileButton\n");
				if ( selectedProfile <= 0)
				{
					continue;
				}
				
				if( selectedProfileSetting == headerProfileSetting )
				{
					if ( headerProfileSetting->Next == NULL )
					{
						selectedProfileSetting = headerProfileSetting = NULL;
					}
					else
					{
						headerProfileSetting = headerProfileSetting->Next;
						writeProfileToNvram();
					}
				}
				else
				{
					if( previousProfileSetting != NULL && selectedProfileSetting != NULL)
					{
						previousProfileSetting->Next = selectedProfileSetting->Next;
						writeProfileToNvram();
					}
					selectedProfileSetting = NULL;
				}
	
				if( headerProfileSetting == NULL)
				{
					nvram_set("staProfile", "");
					nvram_set("staSSID", "");
					nvram_set("staNetworkType", "");
					nvram_set("staPSMode", "");
					nvram_set("staChannel", "");
					nvram_set("staPreamType", "");
					nvram_set("staRTSCheck", "");
					nvram_set("staFragmentCheck", "");
					nvram_set("staRTS", "");
					nvram_set("staFragment", "");
					nvram_set("staAuth", "");
					nvram_set("staEncrypt", "");
					nvram_set("staKeyDefaultId", "");
					nvram_set("staKey1Type", "");
					nvram_set("staKey2Type", "");
					nvram_set("staKey3Type", "");
					nvram_set("staKey4Type", "");
					nvram_set("staKey1Length", "");
					nvram_set("staKey2Length", "");
					nvram_set("staKey3Length", "");
					nvram_set("staKey4Length", "");
					nvram_set("staKey1", "");
					nvram_set("staKey2", "");
					nvram_set("staKey3", "");
					nvram_set("staKey4", "");
					nvram_set("staWpaPsk", "");
					nvram_set("sta8021xKeyMgmt", "");
					nvram_set("sta8021xEAP", "");
					nvram_set("sta8021xIdentity", "");
					nvram_set("sta8021xCACert", "");
					nvram_set("sta8021xClientCert", "");
					nvram_set("sta8021xPrivateKey", "");
					nvram_set("sta8021xPrivateKeyPassword", "");
					nvram_set("sta8021xPassword", "");
					nvram_set("sta8021xTunnel", "");
					nvram_set("staActive", "");
				}
			}

			if( strcmp(tmpString, "activate") == 0)
			{
				int tmp_auth, tmp_encry, tmp_defaultkeyid, tmp_networktype, tmp_preamtype, tmp_channel; //tmp_adhocmode,
				int s, ret;
				char tmp_wpapsk[65], tmp_key1[27], tmp_key2[27], tmp_key3[27], tmp_key4[27], tmp_bssid[13];
				char tmp_rtscheck=0, tmp_fragmentcheck=0;
				NDIS_802_11_RTS_THRESHOLD	tmp_rts;
				NDIS_802_11_FRAGMENTATION_THRESHOLD	tmp_fragment;
				NDIS_802_11_SSID			SSID;
				NDIS_802_11_POWER_MODE		tmp_psmode;
				char *install_dir=NULL;
				char wpaconf[120];


				currentProfileSetting = headerProfileSetting;
				do
				{
					currentProfileSetting->Active = 0;
					currentProfileSetting = currentProfileSetting->Next;
				}while( currentProfileSetting != NULL);

				selectedProfileSetting->Active = 1; // acivate
				writeProfileToNvram();

				memset(&SSID, 0x00, sizeof(SSID));
				bzero(tmp_bssid, sizeof(tmp_bssid));
				bzero(tmp_wpapsk, sizeof(tmp_wpapsk));
				bzero(tmp_key1, sizeof(tmp_key1));
				bzero(tmp_key2, sizeof(tmp_key2));
				bzero(tmp_key3, sizeof(tmp_key3));
				bzero(tmp_key4, sizeof(tmp_key4));
				//memset(tmp_wpapsk, 0x00, sizeof(tmp_wpapsk));

				SSID.SsidLength = selectedProfileSetting->SsidLen;
				memcpy(SSID.Ssid, (const void *)selectedProfileSetting->SSID, selectedProfileSetting->SsidLen);

				tmp_networktype = selectedProfileSetting->NetworkType;
				tmp_auth  = selectedProfileSetting->Authentication;
				tmp_encry = selectedProfileSetting->Encryption;
				tmp_preamtype = selectedProfileSetting->PreamType;
				tmp_rts = selectedProfileSetting->RTS;
				tmp_rtscheck = selectedProfileSetting->RTSCheck;
				tmp_fragment = selectedProfileSetting->Fragment;
				tmp_fragmentcheck = selectedProfileSetting->FragmentCheck;
				tmp_psmode = selectedProfileSetting->PSmode;
				tmp_channel = selectedProfileSetting->Channel;
				tmp_defaultkeyid = selectedProfileSetting->KeyDefaultId;

				sprintf(tmp_wpapsk, "%s", selectedProfileSetting->WpaPsk);
				strcpy(tmp_key1, (char *)selectedProfileSetting->Key1);
				strcpy(tmp_key2, (char *)selectedProfileSetting->Key2);
				strcpy(tmp_key3, (char *)selectedProfileSetting->Key3);
				strcpy(tmp_key4, (char *)selectedProfileSetting->Key4);

				s = socket(AF_INET, SOCK_DGRAM, 0);
				//step 1: OID_802_11_INFRASTRUCTURE_MODE
				ret = OidSetInformation(OID_802_11_INFRASTRUCTURE_MODE, s, (char *)dev_name, &tmp_networktype, sizeof(int));
				if (ret < 0)
					fprintf(stderr, "Set OID_802_11_INFRASTRUCTURE_MODE has error =%d, networktype=%d\n", ret, tmp_networktype);
				close(s);

				//activate
#ifdef WPA_SUPPLICANT_SUPPORT				
				if (selectedProfileSetting->Authentication == Ndis802_11AuthModeWPA ||
						selectedProfileSetting->Authentication == Ndis802_11AuthModeWPA2 ||
						selectedProfileSetting->Authentication == Ndis802_11AuthModeMax )//802.1x
				{
					char tmp_key[27];
					if (tmp_defaultkeyid == 1) // 1~4
						strcpy(tmp_key, tmp_key1);
					else if (tmp_defaultkeyid == 2)
						strcpy(tmp_key, tmp_key2);
					else if (tmp_defaultkeyid == 3)
						strcpy(tmp_key, tmp_key3);
					else if (tmp_defaultkeyid == 4)
						strcpy(tmp_key, tmp_key4);

					conf_WPASupplicant((char*)selectedProfileSetting->SSID, selectedProfileSetting->KeyMgmt, selectedProfileSetting->EAP, (char*)selectedProfileSetting->Identity, (char*)selectedProfileSetting->Password, (char*)selectedProfileSetting->CACert, (char*)selectedProfileSetting->ClientCert, (char*)selectedProfileSetting->PrivateKey, (char*)selectedProfileSetting->PrivateKeyPassword, tmp_key, selectedProfileSetting->KeyDefaultId-1, selectedProfileSetting->Encryption, selectedProfileSetting->Tunnel, selectedProfileSetting->Authentication);
				}
				else
#endif
					sta_connection(tmp_networktype, tmp_auth, tmp_encry, tmp_defaultkeyid, &SSID, NULL, tmp_wpapsk, tmp_key1, tmp_key2, tmp_key3, tmp_key4, tmp_preamtype, tmp_rtscheck, tmp_rts, tmp_fragmentcheck, tmp_fragment, tmp_psmode, tmp_channel);

				if (install_dir == NULL)
				{
					char *pwd=NULL;
					pwd = getenv("PWD");
					memset(wpaconf, 0x00, sizeof(wpaconf));
					sprintf(wpaconf, "%s/../../nvram/make_config_file", pwd);
				}
				else
				{
					memset(wpaconf, 0x00, sizeof(wpaconf));
					sprintf(wpaconf, "%s/WebUI/nvram/make_config_file", install_dir);
				}
				
				if(strlen(wpaconf) > 120)
				{
					fprintf(stderr, "Path length is more than 120.\n");
					return;
				}
				system(wpaconf);
				
				Active_flag = 1;
			}
		}

		if (strcmp(name, "selectedProfile") == 0)
		{
			if ( form->nameval[i].value == NULL)
				selectedProfile = 1;
			else
				selectedProfile = atoi(form->nameval[i].value);

			if ( selectedProfile > 0 )
			{
				previousProfileSetting = selectedProfileSetting = headerProfileSetting;
				for ( j=2 ; j <= selectedProfile ; j++)
				{
					selectedProfileSetting = selectedProfileSetting->Next;
					if ( j == selectedProfile-1 )
					{
						previousProfileSetting = selectedProfileSetting;
					}
				}
 
				if( selectedProfileSetting == headerProfileSetting )
					previousProfileSetting = NULL;
			}
		}
	}
	freeform((char *)form);
}

void noWpaPskMode(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	int len;
	
	strcpy(NullKey, "0");
	len=0;
	bzero(tmp_buffer, sizeof(tmp_buffer));
	sprintf((char *)tmpProfileSetting.WpaPsk, "%s", NullKey);

	wordlist = nvram_get("staWpaPsk");
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.WpaPsk);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.WpaPsk);

	nvram_set("staWpaPsk", tmp_buffer);

}

void noWepMode(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	int len;
	
	strcpy(NullKey, "0");
	len=0;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	sprintf((char *)tmpProfileSetting.Key1, "%s", NullKey);
	wordlist = nvram_get("staKey1");
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key1);
		//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Key1);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.Key1);

	nvram_set("staKey1", tmp_buffer);

	// key2
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));
	
	sprintf((char *)tmpProfileSetting.Key2, "%s", NullKey);
	wordlist = nvram_get("staKey2");
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key2);
		//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Key2);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.Key2);

	nvram_set("staKey2", tmp_buffer);

	// key3
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));
	
	sprintf((char *)tmpProfileSetting.Key3, "%s", NullKey);
	wordlist = nvram_get("staKey3");
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key3);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.Key3);

	nvram_set("staKey3", tmp_buffer);

	// key4
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));
	
	sprintf((char *)tmpProfileSetting.Key4, "%s", NullKey);
	wordlist = nvram_get("staKey4");
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key4);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.Key4);

	nvram_set("staKey4", tmp_buffer);

	//key1 type
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));
		
	tmpProfileSetting.Key1Type = 0;
	wordlist = nvram_get("staKey1Type");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key1Type);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key1Type);

	nvram_set("staKey1Type", tmp_buffer);

	//key2 type
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.Key2Type = 0;
	wordlist = nvram_get("staKey2Type");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key2Type);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key2Type);

	nvram_set("staKey2Type", tmp_buffer);

	//key3 type
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.Key3Type = 0;
	wordlist = nvram_get("staKey3Type");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key3Type);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key3Type);

	nvram_set("staKey3Type", tmp_buffer);


	//key4 type
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.Key4Type = 0;
	wordlist = nvram_get("staKey4Type");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key4Type);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key4Type);

	nvram_set("staKey4Type", tmp_buffer);

	//key1 Length
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));
		
	tmpProfileSetting.Key1Length = 0;
	wordlist = nvram_get("staKey1Length");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key1Length);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key1Length);

	nvram_set("staKey1Length", tmp_buffer);

	//key2 Length
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.Key2Length = 0;
	wordlist = nvram_get("staKey2Length");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key2Length);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key2Length);

	nvram_set("staKey2Length", tmp_buffer);

	//key3 Length
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.Key3Length = 0;
	wordlist = nvram_get("staKey3Length");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key3Length);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key3Length);

	nvram_set("staKey3Length", tmp_buffer);


	//key4 Length
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.Key4Length = 0;
	wordlist = nvram_get("staKey4Length");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key4Length);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Key4Length);

	nvram_set("staKey4Length", tmp_buffer);

	//default key id
	wordlist = NULL;
	bzero(tmp_buffer, sizeof(tmp_buffer));

	tmpProfileSetting.KeyDefaultId = 1;
	wordlist = nvram_get("staKeyDefaultId");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.KeyDefaultId);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.KeyDefaultId);

	nvram_set("staKeyDefaultId", tmp_buffer);
}

void no8021xCACert(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	int len;
	
	len=0;
	bzero(NullKey, sizeof(NullKey));
	bzero(tmp_buffer, sizeof(tmp_buffer));
	strcpy(NullKey, "0");

	//CA Cert
	wordlist = nvram_get("sta8021xCACert");
	sprintf((char *)tmpProfileSetting.CACert, "%s", NullKey);
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.CACert);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.CACert);

	nvram_set("sta8021xCACert", tmp_buffer);
}

void no8021xClientCert(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	int len;

	len=0;
	strcpy(NullKey, "0");
	bzero(tmp_buffer, sizeof(tmp_buffer));

	//Client Cert
	wordlist = nvram_get("sta8021xClientCert");
	sprintf((char *)tmpProfileSetting.ClientCert, "%s", NullKey);
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.ClientCert);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.ClientCert);

	nvram_set("sta8021xClientCert", tmp_buffer);

	//Private Key
	wordlist = nvram_get("sta8021xPrivateKey");
	sprintf((char *)tmpProfileSetting.PrivateKey, "%s", NullKey);
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.PrivateKey);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.PrivateKey);

	nvram_set("sta8021xPrivateKey", tmp_buffer);

	//Private Key Password
	wordlist = nvram_get("sta8021xPrivateKeyPassword");
	sprintf((char *)tmpProfileSetting.PrivateKeyPassword, "%s", NullKey);
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.PrivateKeyPassword);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.PrivateKeyPassword);

	nvram_set("sta8021xPrivateKeyPassword", tmp_buffer);

}

void no8021xTunnel(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	strcpy(NullKey, "0");
	bzero(tmp_buffer, sizeof(tmp_buffer));

	//Tunnel
	wordlist = nvram_get("sta8021xTunnel");
	tmpProfileSetting.Tunnel = Rtwpa_supplicantTUNNENONE;
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Tunnel);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Tunnel);

	nvram_set("sta8021xTunnel", tmp_buffer);
}

void no8021xPassword(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	int len;
	
	strcpy(NullKey, "0");
	bzero(tmp_buffer, sizeof(tmp_buffer));
	len=0;
	//Password
	wordlist = nvram_get("sta8021xPassword");
	sprintf((char *)tmpProfileSetting.Password, "%s", NullKey);
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Password);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.Password);

	nvram_set("sta8021xPassword", tmp_buffer);

}

void no8021xMode(RT_PROFILE_SETTING tmpProfileSetting)
{
	char *wordlist=NULL;
	char tmp_buffer[128];
	char NullKey[4];
	int len;
	
	strcpy(NullKey, "0");
	bzero(tmp_buffer, sizeof(tmp_buffer));
	len=0;
	//EAP
	wordlist = nvram_get("sta8021xEAP");
	tmpProfileSetting.EAP = Rtwpa_supplicantEAPNONE;
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.EAP);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.EAP);

	nvram_set("sta8021xEAP", tmp_buffer);

	//Identity
	wordlist = nvram_get("sta8021xIdentity");
	sprintf((char *)tmpProfileSetting.Identity, "%s", NullKey);
	if ( strcmp(wordlist, "") != 0 )
	{
		sprintf(tmp_buffer, "%s", wordlist);
		len = strlen(wordlist);
		tmp_buffer[len] = bk;
		sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Identity);
	}
	else
		sprintf(tmp_buffer, "%s", tmpProfileSetting.Identity);

	nvram_set("sta8021xIdentity", tmp_buffer);

	no8021xCACert(tmpProfileSetting);
	no8021xClientCert(tmpProfileSetting);
	no8021xPassword(tmpProfileSetting);
	no8021xTunnel(tmpProfileSetting);

	
}
void cgi_sta_add_profile_apply(char *data, FILE *out)
{
	struct httpform *form=NULL;
	char *name=NULL;
	int  i, rts_flag=0, fragment_flag=0, securitymode=-1, len;;
	RT_PROFILE_SETTING	tmpProfileSetting;
	char tmp_buffer[512];
	char *wordlist=NULL;
	
	memset(&tmpProfileSetting, 0x00, sizeof(RT_PROFILE_SETTING));
	tmpProfileSetting.Next = NULL;

	form=parseargs(data);
	for(i=0; i < form->nv_ct; i++)
	{
		bzero(tmp_buffer, sizeof(tmp_buffer));
		wordlist=NULL;
		name = form->nameval[i].name;

		if (strcmp(name, "profile_name") == 0)
		{
			// to tell profile is duplication with other
			// todo
			if (form->nameval[i].value == NULL)
				return;
			
			strcpy((char *)tmpProfileSetting.Profile, form->nameval[i].value);

			wordlist = nvram_get("staProfile");
			if ( strcmp(wordlist,"") != 0)
				sprintf(tmp_buffer, "%s;%s",wordlist,form->nameval[i].value);
			else
				sprintf(tmp_buffer, "%s", form->nameval[i].value);

			nvram_set("staProfile", tmp_buffer);
		}

		if (strcmp(name, "Ssid") == 0)
		{
			strcpy((char *)tmpProfileSetting.SSID, form->nameval[i].value);
			tmpProfileSetting.SsidLen = strlen((char *)tmpProfileSetting.SSID);
			
			wordlist = nvram_get("staSSID");
			if ( strcmp(wordlist,"") != 0)
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", form->nameval[i].value);
			}
			else
				sprintf(tmp_buffer, "%s", form->nameval[i].value);

			nvram_set("staSSID", tmp_buffer);
		}

		if (strcmp(name, "network_type") == 0)
		{
			int networktype =  atoi(form->nameval[i].value);
			tmpProfileSetting.NetworkType = networktype;

			wordlist = nvram_get("staNetworkType");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.NetworkType);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.NetworkType);

			nvram_set("staNetworkType", tmp_buffer);
		}

		if (strcmp(name, "power_saving_mode") == 0)
		{
			if ( strcmp(form->nameval[i].value, "0") ==0) //CAM
				tmpProfileSetting.PSmode = Ndis802_11PowerModeCAM;
			else
				tmpProfileSetting.PSmode = Ndis802_11PowerModeMAX_PSP;

			wordlist = nvram_get("staPSMode");
			if ( strcmp(wordlist, "") )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.PSmode);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.PSmode);
			
			nvram_set("staPSMode", tmp_buffer);
		}

		if (strcmp(name, "channel") == 0)
		{
			if (tmpProfileSetting.NetworkType == Ndis802_11IBSS)
				tmpProfileSetting.Channel = atoi(form->nameval[i].value);
			else
				tmpProfileSetting.Channel = 0;

			wordlist = nvram_get("staChannel");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Channel);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Channel);

			nvram_set("staChannel", tmp_buffer);
		}

		if (strcmp(name, "b_premable_type") == 0)
		{
			if( strcmp(form->nameval[i].value, "0") ==0)
				tmpProfileSetting.PreamType = Rt802_11PreambleAuto;
			else
				tmpProfileSetting.PreamType = Rt802_11PreambleLong;

			wordlist = nvram_get("staPreamType");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.PreamType);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.PreamType);

			nvram_set("staPreamType", tmp_buffer);
			
		}

		if (strcmp(name, "rts_threshold") == 0)
		{
			rts_flag = 1;
			
			// if rts_threshold have a value : on , it is checked, else rts_threshold will not send "rts_threshold"
			tmpProfileSetting.RTSCheck = 1;

			wordlist = nvram_get("staRTSCheck");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.RTSCheck);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.RTSCheck);

			nvram_set("staRTSCheck", tmp_buffer);
		}
		
		if (strcmp(name, "fragment_threshold") == 0)
		{
			fragment_flag = 1;
			tmpProfileSetting.FragmentCheck= 1;

			wordlist = nvram_get("staFragmentCheck");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.FragmentCheck);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.FragmentCheck);

			nvram_set("staFragmentCheck", tmp_buffer);
		}
		
		if (strcmp(name, "rts_thresholdvalue") == 0)
		{
			tmpProfileSetting.RTS = atoi(form->nameval[i].value);

			wordlist = nvram_get("staRTS");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.RTS);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.RTS);

			nvram_set("staRTS", tmp_buffer);
		}

		if (strcmp(name, "fragment_thresholdvalue") == 0)
		{
			tmpProfileSetting.Fragment = atoi(form->nameval[i].value);

			wordlist = nvram_get("staFragment");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Fragment);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Fragment);

			nvram_set("staFragment", tmp_buffer);
		}

		//Security Policy
		if (strcmp(name, "security_infra_mode") == 0 || strcmp(name, "security_adhoc_mode") == 0)
		{
			securitymode = atoi(form->nameval[i].value);

			tmpProfileSetting.Authentication = securitymode;

			wordlist = nvram_get("staAuth");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Authentication);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Authentication);
			
			nvram_set("staAuth", tmp_buffer);

#ifdef WPA_SUPPLICANT_SUPPORT
			if ( tmpProfileSetting.Authentication == Ndis802_11AuthModeWPA
				|| tmpProfileSetting.Authentication == Ndis802_11AuthModeWPA2)
			{
				tmpProfileSetting.KeyMgmt = Rtwpa_supplicantKeyMgmtWPAEAP;
			}
			else if ( tmpProfileSetting.Authentication == Ndis802_11AuthModeMax) //802.1x
				tmpProfileSetting.KeyMgmt = Rtwpa_supplicantKeyMgmtIEEE8021X;
			else 
				tmpProfileSetting.KeyMgmt = Rtwpa_supplicantKeyMgmtNONE;
			
			wordlist = nvram_get("sta8021xKeyMgmt");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.KeyMgmt);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.KeyMgmt);
			
			nvram_set("sta8021xKeyMgmt", tmp_buffer);
#endif
		}
		
		if( strcmp(name, "wep_key_1") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)tmpProfileSetting.Key1, "0");
			else
				sprintf((char *)tmpProfileSetting.Key1, "%s", form->nameval[i].value);
			
			wordlist = nvram_get("staKey1");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key1);

				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Key1);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.Key1);

			nvram_set("staKey1", tmp_buffer);
		}

		if( strcmp(name, "wep_key_2") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)tmpProfileSetting.Key2, "0");
			else
				sprintf((char *)tmpProfileSetting.Key2, "%s", form->nameval[i].value);

			wordlist = nvram_get("staKey2");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key2);

				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Key2);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.Key2);

			nvram_set("staKey2", tmp_buffer);
		}

		if( strcmp(name, "wep_key_3") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)tmpProfileSetting.Key3, "0");
			else				
				sprintf((char *)tmpProfileSetting.Key3, "%s", form->nameval[i].value);
			
			wordlist = nvram_get("staKey3");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key3);

				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Key3);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.Key3);

			nvram_set("staKey3", tmp_buffer);
		}

		if( strcmp(name, "wep_key_4") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)tmpProfileSetting.Key4, "0");
			else	
				sprintf((char *)tmpProfileSetting.Key4, "%s", form->nameval[i].value);
			
			wordlist = nvram_get("staKey4");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Key4);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Key4);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.Key4);

			nvram_set("staKey4", tmp_buffer);
		}

		if( strcmp(name, "wep_key_entry_method") == 0)
		{
			int keytype = atoi(form->nameval[i].value);
			
			tmpProfileSetting.Key1Type = keytype;
			wordlist = nvram_get("staKey1Type");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key1Type);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key1Type);

			nvram_set("staKey1Type", tmp_buffer);


			tmpProfileSetting.Key2Type = keytype;
			wordlist = nvram_get("staKey2Type");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key2Type);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key2Type);

			nvram_set("staKey2Type", tmp_buffer);



			tmpProfileSetting.Key3Type = keytype;
			wordlist = nvram_get("staKey3Type");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key3Type);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key3Type);

			nvram_set("staKey3Type", tmp_buffer);



			tmpProfileSetting.Key4Type = keytype;
			wordlist = nvram_get("staKey4Type");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key4Type);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key4Type);

			nvram_set("staKey4Type", tmp_buffer);
		}

		if( strcmp(name, "wep_key_length") == 0)
		{
			int keylen = atoi(form->nameval[i].value);
			tmpProfileSetting.Key1Length = keylen;
			wordlist = nvram_get("staKey1Length");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key1Length);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key1Length);

			nvram_set("staKey1Length", tmp_buffer);


			tmpProfileSetting.Key2Length = keylen;
			wordlist = nvram_get("staKey2Length");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key2Length);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key2Length);

			nvram_set("staKey2Length", tmp_buffer);


			tmpProfileSetting.Key3Length = keylen;
			wordlist = nvram_get("staKey3Length");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key3Length);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key3Length);

			nvram_set("staKey3Length", tmp_buffer);


			tmpProfileSetting.Key4Length = keylen;
			wordlist = nvram_get("staKey4Length");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Key4Length);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Key4Length);

			nvram_set("staKey4Length", tmp_buffer);
		}

		if( strcmp(name, "wep_default_key") == 0)
		{
			tmpProfileSetting.KeyDefaultId= atoi(form->nameval[i].value);
			wordlist = nvram_get("staKeyDefaultId");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.KeyDefaultId);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.KeyDefaultId);

			nvram_set("staKeyDefaultId", tmp_buffer);
		}

		if( strcmp(name, "cipher") == 0 )
		{
			int encry = atoi(form->nameval[i].value);

			if( encry == 0) //TKIP
				tmpProfileSetting.Encryption = Ndis802_11Encryption2Enabled;
			else //AES
				tmpProfileSetting.Encryption = Ndis802_11Encryption3Enabled;
		
			wordlist = nvram_get("staEncrypt");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Encryption);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Encryption);

			nvram_set("staEncrypt", tmp_buffer);
		}

		if( strcmp(name, "passphrase") == 0 )
		{
			if (form->nameval[i].value == NULL) 
				strcpy((char *)tmpProfileSetting.WpaPsk, "0");
			else
				sprintf((char *)tmpProfileSetting.WpaPsk, "%s", form->nameval[i].value);
			
			wordlist = nvram_get("staWpaPsk");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				
				if (strlen((char *)tmpProfileSetting.WpaPsk) == 65)
					tmpProfileSetting.WpaPsk[64] ='\0';
				
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.WpaPsk);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.WpaPsk);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.WpaPsk);

			nvram_set("staWpaPsk", tmp_buffer);
		}

#ifdef WPA_SUPPLICANT_SUPPORT
		if( strcmp(name, "cert_auth_type_from_1x") == 0 || strcmp(name, "cert_auth_type_from_wpa") == 0)
		{
			int eap = atoi(form->nameval[i].value);
			tmpProfileSetting.EAP = (RT_WPA_SUPPLICANT_EAP) eap;

			wordlist = nvram_get("sta8021xEAP");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.EAP);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.EAP);

			nvram_set("sta8021xEAP", tmp_buffer);
		}

		if ( strcmp(name, "cert_tunnel_auth_peap") == 0 
			|| strcmp(name, "cert_tunnel_auth_ttls") == 0)
		{
			int tunnel = atoi(form->nameval[i].value);
			tmpProfileSetting.Tunnel = (RT_WPA_SUPPLICANT_TUNNEL) tunnel;
			
			wordlist = nvram_get("sta8021xTunnel");
			if ( strcmp(wordlist, "") != 0 )
				sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Tunnel);
			else
				sprintf(tmp_buffer, "%d", tmpProfileSetting.Tunnel);

			nvram_set("sta8021xTunnel", tmp_buffer);
		}
			
		if ( strcmp(name, "cert_id") == 0 )
		{
			sprintf((char *)tmpProfileSetting.Identity, "%s", form->nameval[i].value);

			wordlist = nvram_get("sta8021xIdentity");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Identity);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Identity);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.Identity);

			nvram_set("sta8021xIdentity", tmp_buffer);
		}

		if ( strcmp(name, "cert_password") == 0 )
		{
			sprintf((char *)tmpProfileSetting.Password, "%s", form->nameval[i].value);

			wordlist = nvram_get("sta8021xPassword");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.Password);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.Password);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.Password);

			nvram_set("sta8021xPassword", tmp_buffer);
		}

		if ( strcmp(name, "cert_client_cert_path") == 0 )
		{
			sprintf((char *)tmpProfileSetting.ClientCert, "%s", form->nameval[i].value);

			wordlist = nvram_get("sta8021xClientCert");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.ClientCert);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.ClientCert);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.ClientCert);

			nvram_set("sta8021xClientCert", tmp_buffer);
		}

		if ( strcmp(name, "cert_private_key_path") == 0 )
		{
			sprintf((char *)tmpProfileSetting.PrivateKey, "%s", form->nameval[i].value);

			wordlist = nvram_get("sta8021xPrivateKey");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.PrivateKey);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.PrivateKey);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.PrivateKey);

			nvram_set("sta8021xPrivateKey", tmp_buffer);
		}

		if ( strcmp(name, "cert_private_key_password") == 0 )
		{
			sprintf((char *)tmpProfileSetting.PrivateKeyPassword, "%s", form->nameval[i].value);

			wordlist = nvram_get("sta8021xPrivateKeyPassword");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.PrivateKeyPassword);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.PrivateKeyPassword);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.PrivateKeyPassword);

			nvram_set("sta8021xPrivateKeyPassword", tmp_buffer);
		}

		if ( strcmp(name, "cert_ca_cert_path") == 0 )
		{
			sprintf((char *)tmpProfileSetting.CACert, "%s", form->nameval[i].value);

			wordlist = nvram_get("sta8021xCACert");
			if ( strcmp(wordlist, "") != 0 )
			{
				sprintf(tmp_buffer, "%s", wordlist);
				len = strlen(wordlist);
				tmp_buffer[len] = bk;
				sprintf(&tmp_buffer[len+1], "%s", (char *)tmpProfileSetting.CACert);
				//sprintf(tmp_buffer, "%s;%s",wordlist, tmpProfileSetting.CACert);
			}
			else
				sprintf(tmp_buffer, "%s", tmpProfileSetting.CACert);

			nvram_set("sta8021xCACert", tmp_buffer);
		}
#endif
	}

	if( tmpProfileSetting.Authentication <= Ndis802_11AuthModeShared )
	{
		if( strlen((char *)tmpProfileSetting.Key1) > 1 || strlen((char *)tmpProfileSetting.Key2) > 1 ||
			strlen((char *)tmpProfileSetting.Key4) > 1 || strlen((char *)tmpProfileSetting.Key3) > 1)
		{
			tmpProfileSetting.Encryption = Ndis802_11WEPEnabled;
		}
		else
		{
			tmpProfileSetting.Encryption = Ndis802_11WEPDisabled;
		}
		
		wordlist = nvram_get("staEncrypt");
		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Encryption);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.Encryption);

		nvram_set("staEncrypt", tmp_buffer);

	}
	else if ( tmpProfileSetting.Authentication == Ndis802_11AuthModeMax) //802.1x
	{
		tmpProfileSetting.Encryption = Ndis802_11WEPEnabled;

		wordlist = nvram_get("staEncrypt");
		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Encryption);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.Encryption);

		nvram_set("staEncrypt", tmp_buffer);
	}
	//write into /etc/rt61sta.ui
	//writeProfileToFile(&tmpProfileSetting);

	freeform((char *)form);

	tmpProfileSetting.Active = 0;
	wordlist = nvram_get("staActive");
	if ( strcmp(wordlist, "") != 0 )
		sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Active);
	else
		sprintf(tmp_buffer, "%d", tmpProfileSetting.Active);

	nvram_set("staActive", tmp_buffer);

	
	//nvram_commit();
	if ( !rts_flag )
	{
		// ***  rts check **//
		wordlist = NULL;
		bzero(tmp_buffer, sizeof(tmp_buffer));

		tmpProfileSetting.RTSCheck = 0;
		wordlist = nvram_get("staRTSCheck");

		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.RTSCheck);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.RTSCheck);

		nvram_set("staRTSCheck", tmp_buffer);

		// ***  rts value **//
		wordlist = NULL;
		bzero(tmp_buffer, sizeof(tmp_buffer));

		tmpProfileSetting.RTS = 2347;
		wordlist = nvram_get("staRTS");

		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.RTS);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.RTS);

		nvram_set("staRTS", tmp_buffer);

	}

	if ( !fragment_flag )
	{
		// ***  fragment check**//
		wordlist = NULL;
		bzero(tmp_buffer, sizeof(tmp_buffer));

		tmpProfileSetting.FragmentCheck = 0;
		wordlist = nvram_get("staFragmentCheck");

		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.FragmentCheck);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.FragmentCheck);

		nvram_set("staFragmentCheck", tmp_buffer);

		// ***  fragment value**//
		wordlist = NULL;
		bzero(tmp_buffer, sizeof(tmp_buffer));

		tmpProfileSetting.Fragment = 2346;
		wordlist = nvram_get("staFragment");
		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Fragment);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.Fragment);

		nvram_set("staFragment", tmp_buffer);
	}

	if ( tmpProfileSetting.NetworkType == Ndis802_11Infrastructure )
	{
		//Channel
		wordlist = NULL;
		bzero(tmp_buffer, sizeof(tmp_buffer));

		tmpProfileSetting.Channel = 0;
		wordlist = nvram_get("staChannel");
		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.Channel);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.Channel);

		nvram_set("staChannel", tmp_buffer);

		//11b premable type
		wordlist = NULL;
		bzero(tmp_buffer, sizeof(tmp_buffer));

		tmpProfileSetting.PreamType = Rt802_11PreambleLong;
		wordlist = nvram_get("staPreamType");
		if ( strcmp(wordlist, "") != 0 )
			sprintf(tmp_buffer, "%s;%d",wordlist, tmpProfileSetting.PreamType);
		else
			sprintf(tmp_buffer, "%d", tmpProfileSetting.PreamType);

		nvram_set("staPreamType", tmp_buffer);

	}

	if( tmpProfileSetting.NetworkType >= Ndis802_11AuthModeOpen)
	{
		switch ( securitymode )
		{
			case Ndis802_11AuthModeOpen: //OPEN
			case Ndis802_11AuthModeShared: //Shared

				noWpaPskMode(tmpProfileSetting);
				no8021xMode(tmpProfileSetting);
				break;			

			case Ndis802_11AuthModeWPAPSK: //WPA-PSK
			case Ndis802_11AuthModeWPA2PSK: //WPA2-PSK
				noWepMode(tmpProfileSetting);
				no8021xMode(tmpProfileSetting);
				break;

#ifdef WPA_SUPPLICANT_SUPPORT
			case Ndis802_11AuthModeWPA:
			case Ndis802_11AuthModeWPA2:
				noWepMode(tmpProfileSetting);

			case Ndis802_11AuthModeMax: //802.1x
			{
				noWpaPskMode(tmpProfileSetting);

				int eap = tmpProfileSetting.EAP;
				switch( eap )
				{
					case Rtwpa_supplicantEAPPEAP:
					case Rtwpa_supplicantEAPTTLS:
						if ( strlen((char *)tmpProfileSetting.ClientCert) == 0 )
							no8021xClientCert(tmpProfileSetting);

						if ( strlen((char *)tmpProfileSetting.CACert) == 0 )
							no8021xCACert(tmpProfileSetting);
							
						if( securitymode == Ndis802_11AuthModeMax)
							noWepMode(tmpProfileSetting);
						break;
						
					case Rtwpa_supplicantEAPTLS:
						//Password
						no8021xPassword(tmpProfileSetting);
						
						//Tunnel
						no8021xTunnel(tmpProfileSetting);						

						if ( strlen((char *)tmpProfileSetting.CACert) == 0 )
							no8021xCACert(tmpProfileSetting);
						if( securitymode == Ndis802_11AuthModeMax)
							noWepMode(tmpProfileSetting);
						break;
						
					case Rtwpa_supplicantEAPMD5:
						//Tunnel
						no8021xTunnel(tmpProfileSetting);

						//Client Cert
						no8021xClientCert(tmpProfileSetting);

						//CA Cert
						if ( strlen((char *)tmpProfileSetting.CACert) == 0 )
							no8021xCACert(tmpProfileSetting);

						break;
						
					default:
						break;
				}
			}
			break;
#endif
				
			default:
				break;
		}
	}

	headerProfileSetting = NULL;
}

void noWepModeforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");
	//key1
	sprintf((char *)selectedProfileSetting->Key1, "%s", NullKey);

	// key2
	sprintf((char *)selectedProfileSetting->Key2, "%s", NullKey);

	// key3
	sprintf((char *)selectedProfileSetting->Key3, "%s", NullKey);

	// key4
	sprintf((char *)selectedProfileSetting->Key4, "%s", NullKey);

	//key1 type
	selectedProfileSetting->Key1Type = 0;

	//key2 type
	selectedProfileSetting->Key2Type = 0;

	//key3 type
	selectedProfileSetting->Key3Type = 0;

	//key4 type
	selectedProfileSetting->Key4Type = 0;

	//key1 len
	selectedProfileSetting->Key1Length = 0;

	//key2 len
	selectedProfileSetting->Key2Length = 0;

	//key3 len
	selectedProfileSetting->Key3Length = 0;

	//key4 len
	selectedProfileSetting->Key4Length = 0;

	//default key id
	selectedProfileSetting->KeyDefaultId = 0;

}

void noWPAPSKModeforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");

	//WpaPsk
	sprintf((char *)selectedProfileSetting->WpaPsk, "%s", NullKey);
}

void no8021xCACertforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");

	//CA Cert
	sprintf((char *)selectedProfileSetting->CACert, "%s", NullKey);	
}

void no8021xClientCertforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");

	//Client Cert
	sprintf((char *)selectedProfileSetting->ClientCert, "%s", NullKey);

	//Private Key
	sprintf((char *)selectedProfileSetting->PrivateKey, "%s", NullKey);

	//Private Key Password
	sprintf((char *)selectedProfileSetting->PrivateKeyPassword, "%s", NullKey);
}

void no8021xTunnelforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");

	//Tunnel
	selectedProfileSetting->Tunnel = Rtwpa_supplicantTUNNENONE;
}

void no8021xPasswordforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");

	//Password
	sprintf((char *)selectedProfileSetting->Password, "%s", NullKey);
}

void no8021xModeforEditProfile()
{
	char NullKey[4];
	strcpy(NullKey, "0");
	
	//EAP
	selectedProfileSetting->EAP = Rtwpa_supplicantEAPNONE;

	//Identity
	sprintf((char *)selectedProfileSetting->Identity, "%s", NullKey);

	no8021xCACertforEditProfile();
	no8021xClientCertforEditProfile();
	no8021xPasswordforEditProfile();
	no8021xTunnelforEditProfile();	
}
void cgi_sta_edit_profile_apply(char *data, FILE *out)
{
	// step 1, modify info on selectedProfileSetting

	struct httpform *form=NULL;
	char *name=NULL;
	int  i, rts_flag=0, fragment_flag=0, securitymode=-1;
	char tmp_buffer[512];
	char *wordlist=NULL;
#ifdef WPA_SUPPLICANT_SUPPORT
	BOOLEAN	use_client_cert=FALSE, use_ca_cert=FALSE;
#endif

	form=parseargs(data);
	for(i=0; i < form->nv_ct; i++)
	{
		bzero(tmp_buffer, sizeof(tmp_buffer));
		wordlist=NULL;
		name = form->nameval[i].name;
		
		if (strcmp(name, "profile_name") == 0)
		{
			// to tell profile is duplication with other
			// todo
			if (form->nameval[i].value == NULL)
				return;
			
			strcpy((char *)selectedProfileSetting->Profile, form->nameval[i].value);
		}

		if (strcmp(name, "Ssid") == 0)
		{
			strcpy((char *)selectedProfileSetting->SSID, form->nameval[i].value);
			selectedProfileSetting->SsidLen = strlen((char *)selectedProfileSetting->SSID);
		}

		if (strcmp(name, "network_type") == 0)
		{
			int networktype = atoi(form->nameval[i].value);
			selectedProfileSetting->NetworkType = networktype;
		}

		if (strcmp(name, "power_saving_mode") == 0)
		{
			if ( strcmp(form->nameval[i].value, "0") ==0) //CAM
				selectedProfileSetting->PSmode = Ndis802_11PowerModeCAM;
			else
				selectedProfileSetting->PSmode = Ndis802_11PowerModeMAX_PSP;
		}

		if (strcmp(name, "channel") == 0)
		{
			if (selectedProfileSetting->NetworkType == Ndis802_11IBSS)
				selectedProfileSetting->Channel = atoi(form->nameval[i].value);
			else
				selectedProfileSetting->Channel = 0;
		}

		if (strcmp(name, "b_premable_type") == 0)
		{
			if( strcmp(form->nameval[i].value, "0") ==0)
				selectedProfileSetting->PreamType = Rt802_11PreambleAuto;
			else
				selectedProfileSetting->PreamType = Rt802_11PreambleLong;
		}

		if (strcmp(name, "rts_threshold") == 0)
		{
			rts_flag = 1;
			
			// if rts_threshold have a value : on , it is checked, else rts_threshold will not send "rts_threshold"
			selectedProfileSetting->RTSCheck = 1;
		}
		
		if (strcmp(name, "fragment_threshold") == 0)
		{
			fragment_flag = 1;
			selectedProfileSetting->FragmentCheck= 1;
		}
		
		if (strcmp(name, "rts_thresholdvalue") == 0)
		{
			selectedProfileSetting->RTS = atoi(form->nameval[i].value);
		}

		if (strcmp(name, "fragment_thresholdvalue") == 0)
		{
			selectedProfileSetting->Fragment = atoi(form->nameval[i].value);
		}

		//Security Policy
		if (strcmp(name, "security_infra_mode") == 0 || strcmp(name, "security_adhoc_mode") == 0)
		{
			securitymode = atoi(form->nameval[i].value);

			selectedProfileSetting->Authentication = securitymode;

#ifdef WPA_SUPPLICANT_SUPPORT
			if ( selectedProfileSetting->Authentication == Ndis802_11AuthModeWPA
				|| selectedProfileSetting->Authentication == Ndis802_11AuthModeWPA2)
			{
				selectedProfileSetting->KeyMgmt = Rtwpa_supplicantKeyMgmtWPAEAP;
			}
			else if ( selectedProfileSetting->Authentication == Ndis802_11AuthModeMax) //802.1x
				selectedProfileSetting->KeyMgmt = Rtwpa_supplicantKeyMgmtIEEE8021X;
			else 
				selectedProfileSetting->KeyMgmt = Rtwpa_supplicantKeyMgmtNONE;
#endif
		}
		
		if( strcmp(name, "wep_key_1") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->Key1, "0");
			else
				sprintf((char *)selectedProfileSetting->Key1, "%s", form->nameval[i].value);
		}

		if( strcmp(name, "wep_key_2") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->Key2, "0");
			else
				sprintf((char *)selectedProfileSetting->Key2, "%s", form->nameval[i].value);
		}

		if( strcmp(name, "wep_key_3") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->Key3, "0");
			else				
				sprintf((char *)selectedProfileSetting->Key3, "%s", form->nameval[i].value);
		}

		if( strcmp(name, "wep_key_4") == 0)
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->Key4, "0");
			else	
				sprintf((char *)selectedProfileSetting->Key4, "%s", form->nameval[i].value);
		}

		if( strcmp(name, "wep_key_entry_method") == 0)
		{
			int keytype = atoi(form->nameval[i].value);
			
			selectedProfileSetting->Key1Type = keytype;
			selectedProfileSetting->Key2Type = keytype;	
			selectedProfileSetting->Key3Type = keytype;
			selectedProfileSetting->Key4Type = keytype;
		}

		if( strcmp(name, "wep_key_length") == 0)
		{
			int keylen = atoi(form->nameval[i].value);

			selectedProfileSetting->Key1Length = keylen;
			selectedProfileSetting->Key2Length = keylen;
			selectedProfileSetting->Key3Length = keylen;
			selectedProfileSetting->Key4Length = keylen;
		}

		if( strcmp(name, "wep_default_key") == 0)
		{
			selectedProfileSetting->KeyDefaultId= atoi(form->nameval[i].value);
		}

		if( strcmp(name, "cipher") == 0 )
		{
			int encry = atoi(form->nameval[i].value);

			if( encry == 0) //TKIP
				selectedProfileSetting->Encryption = Ndis802_11Encryption2Enabled;
			else //AES
				selectedProfileSetting->Encryption = Ndis802_11Encryption3Enabled;
		}

		if( strcmp(name, "passphrase") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->WpaPsk, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->WpaPsk, "%s", form->nameval[i].value);
			}
		}

#ifdef WPA_SUPPLICANT_SUPPORT
		if( strcmp(name, "cert_auth_type_from_1x") == 0 || strcmp(name, "cert_auth_type_from_wpa") == 0)
		{
			selectedProfileSetting->EAP = atoi(form->nameval[i].value);
		}

		if ( strcmp(name, "cert_tunnel_auth_peap") == 0 
			|| strcmp(name, "cert_tunnel_auth_ttls") == 0)
		{
			selectedProfileSetting->Tunnel = atoi(form->nameval[i].value);
		}
			
		if ( strcmp(name, "cert_id") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->Identity, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->Identity, "%s", form->nameval[i].value);
			}
		}

		if ( strcmp(name, "cert_password") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->Password, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->Password, "%s", form->nameval[i].value);
			}
		}

		if ( strcmp(name, "cert_client_cert_path") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->ClientCert, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->ClientCert, "%s", form->nameval[i].value);
				use_client_cert=TRUE;
			}
		}

		if ( strcmp(name, "cert_private_key_path") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->PrivateKey, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->PrivateKey, "%s", form->nameval[i].value);
			}
		}

		if ( strcmp(name, "cert_private_key_password") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->PrivateKeyPassword, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->PrivateKeyPassword, "%s", form->nameval[i].value);
			}
		}

		if ( strcmp(name, "cert_ca_cert_path") == 0 )
		{
			if (form->nameval[i].value == NULL)
				strcpy((char *)selectedProfileSetting->CACert, "0");
			else
			{
				sprintf((char *)selectedProfileSetting->CACert, "%s", form->nameval[i].value);
				use_ca_cert=TRUE;
			}
		}
#endif				
	}

	if( selectedProfileSetting->Authentication <= Ndis802_11AuthModeShared )
	{
		if( strlen((char *)selectedProfileSetting->Key1) > 1 || strlen((char *)selectedProfileSetting->Key2) > 1 ||
			strlen((char *)selectedProfileSetting->Key4) > 1 || strlen((char *)selectedProfileSetting->Key3) > 1)
		{
			selectedProfileSetting->Encryption = Ndis802_11WEPEnabled;
		}
		else
		{
			selectedProfileSetting->Encryption = Ndis802_11WEPDisabled;
		}
	}
	else if ( selectedProfileSetting->Authentication == Ndis802_11AuthModeMax) //802.1x
	{
		selectedProfileSetting->Encryption = Ndis802_11WEPEnabled;
	}

	freeform((char *)form);

#ifdef WPA_SUPPLICANT_SUPPORT
	if (use_client_cert == FALSE)
	{
		strcpy((char *)selectedProfileSetting->ClientCert, "0");
		strcpy((char *)selectedProfileSetting->PrivateKey, "0");
		strcpy((char *)selectedProfileSetting->PrivateKeyPassword, "0");
	}

	if (use_ca_cert == FALSE)
		strcpy((char *)selectedProfileSetting->CACert, "0");
#endif

	if ( !rts_flag )
	{
		// ***  rts check **//
		selectedProfileSetting->RTSCheck = 0;

		// ***  rts value **//
		selectedProfileSetting->RTS = 2347;
	}

	if ( !fragment_flag )
	{
		// ***  fragment check**//
		selectedProfileSetting->FragmentCheck = 0;

		// ***  fragment value**//
		selectedProfileSetting->Fragment = 2346;
	}

	if ( selectedProfileSetting->NetworkType == Ndis802_11Infrastructure )
	{
		// Adhoc mode
		selectedProfileSetting->AdhocMode = 0;

		//Channel
		selectedProfileSetting->Channel = 0;

		//11b premable type
		selectedProfileSetting->PreamType = Rt802_11PreambleLong;
	}

	if( selectedProfileSetting->NetworkType >= Ndis802_11AuthModeOpen)
	{
		switch ( securitymode )
		{
			case Ndis802_11AuthModeOpen: //OPEN
			case Ndis802_11AuthModeShared: //Shared

				noWPAPSKModeforEditProfile();
				no8021xModeforEditProfile();
				break;			

			case Ndis802_11AuthModeWPAPSK: //WPA-PSK
			case Ndis802_11AuthModeWPA2PSK: //WPA2-PSK
				noWepModeforEditProfile();
				no8021xModeforEditProfile();
				break;

#ifdef WPA_SUPPLICANT_SUPPORT
			case Ndis802_11AuthModeWPA:
			case Ndis802_11AuthModeWPA2:
				noWepModeforEditProfile();

			case Ndis802_11AuthModeMax: //802.1x
			{
				noWPAPSKModeforEditProfile();

				int eap = selectedProfileSetting->EAP;
				switch( eap )
				{
					case Rtwpa_supplicantEAPPEAP:
					case Rtwpa_supplicantEAPTTLS:
						if ( strlen((char *)selectedProfileSetting->ClientCert) == 0 )
							no8021xClientCertforEditProfile();

						if ( strlen((char *)selectedProfileSetting->CACert) == 0 )
							no8021xCACertforEditProfile();
							
						if( selectedProfileSetting->Authentication == Ndis802_11AuthModeMax)
							noWepModeforEditProfile();
						break;
						
					case Rtwpa_supplicantEAPTLS:
						//Password
						no8021xPasswordforEditProfile();
						
						//Tunnel
						no8021xTunnelforEditProfile();						

						if ( strlen((char *)selectedProfileSetting->CACert) == 0 )
							no8021xCACertforEditProfile();
						
						if( selectedProfileSetting->Authentication== Ndis802_11AuthModeMax)
							noWepModeforEditProfile();
						break;
						
					case Rtwpa_supplicantEAPMD5:
						//Tunnel
						no8021xTunnelforEditProfile();

						//Client Cert
						no8021xClientCertforEditProfile();

						//CA Cert
						if ( strlen((char *)selectedProfileSetting->CACert) == 0 )
							no8021xCACertforEditProfile();

						break;
						
					default:
						break;
				}
			}
			break;
#endif
				
			default:
				break;
		}
	}


	if (selectedProfileSetting->Active)
	{
		//edit_profile_apply
		NDIS_802_11_SSID Ssid;
		memset(&Ssid, 0x00, sizeof(NDIS_802_11_SSID));
		strcpy((char *)Ssid.Ssid ,(char *)selectedProfileSetting->SSID);
		Ssid.SsidLength = selectedProfileSetting->SsidLen;


#ifdef WPA_SUPPLICANT_SUPPORT

		if (selectedProfileSetting->Authentication == Ndis802_11AuthModeWPA ||
			selectedProfileSetting->Authentication == Ndis802_11AuthModeWPA2 ||
			selectedProfileSetting->Authentication == Ndis802_11AuthModeMax )//802.1x
		{
			char tmp_key[27];
			if (selectedProfileSetting->KeyDefaultId == 1) // 1~4
				strcpy(tmp_key, (char *)selectedProfileSetting->Key1);
			else if (selectedProfileSetting->KeyDefaultId == 2)
				strcpy(tmp_key, (char *)selectedProfileSetting->Key2);
			else if (selectedProfileSetting->KeyDefaultId == 3)
				strcpy(tmp_key, (char *)selectedProfileSetting->Key3);
			else if (selectedProfileSetting->KeyDefaultId == 4)
				strcpy(tmp_key, (char *)selectedProfileSetting->Key4);

			conf_WPASupplicant((char*)selectedProfileSetting->SSID, selectedProfileSetting->KeyMgmt, selectedProfileSetting->EAP, (char*)selectedProfileSetting->Identity, (char*)selectedProfileSetting->Password, (char*)selectedProfileSetting->CACert, (char*)selectedProfileSetting->ClientCert, (char*)selectedProfileSetting->PrivateKey, (char*)selectedProfileSetting->PrivateKeyPassword, tmp_key, selectedProfileSetting->KeyDefaultId-1, selectedProfileSetting->Encryption, selectedProfileSetting->Tunnel, selectedProfileSetting->Tunnel);
		}
		else
#endif
		sta_connection(selectedProfileSetting->NetworkType, selectedProfileSetting->Authentication, selectedProfileSetting->Encryption, selectedProfileSetting->KeyDefaultId, &Ssid, NULL, (char *)selectedProfileSetting->WpaPsk, (char *)selectedProfileSetting->Key1, (char *)selectedProfileSetting->Key2, (char *)selectedProfileSetting->Key3, (char *)selectedProfileSetting->Key4, selectedProfileSetting->PreamType, selectedProfileSetting->RTSCheck, selectedProfileSetting->RTS, selectedProfileSetting->FragmentCheck, selectedProfileSetting->Fragment, selectedProfileSetting->PSmode, selectedProfileSetting->Channel);

		Active_flag = 1;
		sleep(1);
	}

	currentProfileSetting = headerProfileSetting;
	do
	{
		currentProfileSetting = currentProfileSetting->Next;

		if( currentProfileSetting != NULL)
			strcat(tmp_buffer, ";");
		
	}while( currentProfileSetting != NULL);
	
	// setp 2, write all profile into nvram
	writeProfileToNvram();

	selectedProfileSetting = NULL;
}

void cgi_sta_site_survey_connection_apply(char *data, FILE *out)
{
	struct httpform *form=NULL;
	char *name=NULL;
	int  i=0, tmp_auth=0, tmp_encry=0, tmp_defaultkeyid=0, tmp_networktype=0;
	char tmp_ssid[32], tmp_wpapsk[64+1], tmp_key1[27], tmp_key2[27], tmp_key3[27], tmp_key4[27], tmp_bssid[13];

#ifdef WPA_SUPPLICANT_SUPPORT
	int tmp_keymgmt = Rtwpa_supplicantKeyMgmtNONE, tmp_eap = Rtwpa_supplicantEAPNONE, tmp_tunnel = Rtwpa_supplicantTUNNENONE;
	char tmp_identity[IDENTITY_LENGTH], tmp_cacert[CERT_PATH_LENGTH], tmp_clientcert[CERT_PATH_LENGTH], tmp_privatekey[PRIVATE_KEY_PATH_LENGTH], tmp_privatekeypassword[32], tmp_password[32];

#endif
	bzero(tmp_ssid, sizeof(tmp_ssid));
	bzero(tmp_bssid, sizeof(tmp_bssid));
	bzero(tmp_wpapsk, sizeof(tmp_wpapsk));
	bzero(tmp_key1, sizeof(tmp_key1));
	bzero(tmp_key2, sizeof(tmp_key2));
	bzero(tmp_key3, sizeof(tmp_key3));
	bzero(tmp_key4, sizeof(tmp_key4));
	
#ifdef WPA_SUPPLICANT_SUPPORT
	bzero(tmp_identity, sizeof(tmp_identity));
	bzero(tmp_cacert, sizeof(tmp_cacert));
	bzero(tmp_clientcert, sizeof(tmp_clientcert));
	bzero(tmp_privatekey, sizeof(tmp_privatekey));
	bzero(tmp_privatekeypassword, sizeof(tmp_privatekeypassword));
	bzero(tmp_password, sizeof(tmp_password));
#endif
	tmp_auth  = Ndis802_11AuthModeOpen;
	tmp_encry = Ndis802_11WEPDisabled;

	form=parseargs(data);
	for(i=0; i < form->nv_ct; i++)
	{
		name = form->nameval[i].name;
		if (strcmp(name, "Ssid") == 0)
		{
			sprintf(tmp_ssid, "%s", form->nameval[i].value);
		}

		if (strcmp(name, "network_type") == 0)
		{
			tmp_networktype = atoi(form->nameval[i].value);
		}

		if (strcmp(name, "bssid") == 0)
		{
			strcpy(tmp_bssid, form->nameval[i].value);
		}

		//Security Policy
		if (strcmp(name, "security_infra_mode") == 0 || strcmp(name, "security_adhoc_mode") == 0)
		{
			tmp_auth = atoi(form->nameval[i].value);

#ifdef WPA_SUPPLICANT_SUPPORT
			if ( tmp_auth == Ndis802_11AuthModeWPA
				|| tmp_auth == Ndis802_11AuthModeWPA2)
			{
				tmp_keymgmt = Rtwpa_supplicantKeyMgmtWPAEAP;
			}
			else if ( tmp_auth == Ndis802_11AuthModeMax) //802.1x
				tmp_keymgmt= Rtwpa_supplicantKeyMgmtIEEE8021X;
			else 
				tmp_keymgmt = Rtwpa_supplicantKeyMgmtNONE;
#endif			
		}

		if( strcmp(name, "wep_key_1") == 0)
		{
			
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_key1, "");
				continue;
			}
			sprintf(tmp_key1, "%s", form->nameval[i].value);
			
			// Auth mode OPEN might use encryption type: none or wep
			// if set wep key, the encry must be WEPEnable
			tmp_encry = Ndis802_11WEPEnabled;
		}

		if( strcmp(name, "wep_key_2") == 0)
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_key2, "");
				continue;
			}
			sprintf(tmp_key2, "%s", form->nameval[i].value);

			// Auth mode OPEN might use encryption type: none or wep
			// if set wep key, the encry must be WEPEnable
			tmp_encry = Ndis802_11WEPEnabled;
		}

		if( strcmp(name, "wep_key_3") == 0)
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_key3, "");
				continue;
			}
			sprintf(tmp_key3, "%s", form->nameval[i].value);

			// Auth mode OPEN might use encryption type: none or wep
			// if set wep key, the encry must be WEPEnable
			tmp_encry = Ndis802_11WEPEnabled;
		}

		if( strcmp(name, "wep_key_4") == 0)
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_key4, "");
				continue;
			}
			sprintf(tmp_key4, "%s", form->nameval[i].value);

			// Auth mode OPEN might use encryption type: none or wep
			// if set wep key, the encry must be WEPEnable
			tmp_encry = Ndis802_11WEPEnabled;
		}

		if( strcmp(name, "wep_default_key") == 0)
		{
			tmp_defaultkeyid = atoi(form->nameval[i].value);
		}

		if( strcmp(name, "cipher") == 0 )
		{
			int encry = atoi(form->nameval[i].value);
			
			if( encry == 0) //TKIP
				tmp_encry= Ndis802_11Encryption2Enabled;
			else //AES
				tmp_encry = Ndis802_11Encryption3Enabled;
		}

		if( strcmp(name, "passphrase") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_wpapsk, "");
				continue;
			}
			sprintf(tmp_wpapsk, "%s", form->nameval[i].value);
		}

#ifdef WPA_SUPPLICANT_SUPPORT
		if( strcmp(name, "cert_auth_type_from_1x") == 0 || strcmp(name, "cert_auth_type_from_wpa") == 0)
		{
			tmp_eap = (RT_WPA_SUPPLICANT_EAP) atoi(form->nameval[i].value);
		}

		if ( strcmp(name, "cert_tunnel_auth_peap") == 0 
			|| strcmp(name, "cert_tunnel_auth_ttls") == 0)
		{
			tmp_tunnel = (RT_WPA_SUPPLICANT_TUNNEL) atoi(form->nameval[i].value);
		}
			
		if ( strcmp(name, "cert_id") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_identity, "");
				continue;
			}

			sprintf(tmp_identity, "%s", form->nameval[i].value);
		}

		if ( strcmp(name, "cert_password") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_password, "");
				continue;
			}

			sprintf(tmp_password, "%s", form->nameval[i].value);
		}

		if ( strcmp(name, "cert_client_cert_path") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_clientcert, "");
				continue;
			}

			sprintf(tmp_clientcert, "%s", form->nameval[i].value);
		}

		if ( strcmp(name, "cert_private_key_path") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_privatekey, "");
				continue;
			}

			sprintf(tmp_privatekey, "%s", form->nameval[i].value);
		}

		if ( strcmp(name, "cert_private_key_password") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_privatekeypassword, "");
				continue;
			}

			sprintf(tmp_privatekeypassword, "%s", form->nameval[i].value);
		}

		if ( strcmp(name, "cert_ca_cert_path") == 0 )
		{
			if (form->nameval[i].value == NULL)
			{
				strcpy(tmp_cacert, "");
				continue;
			}

			sprintf(tmp_cacert, "%s", form->nameval[i].value);
		}
#endif

	}
	if( tmp_auth <= Ndis802_11AuthModeShared )
	{
		if( strlen((char *)tmp_key1) > 1 || strlen((char *)tmp_key2) > 1 ||
			strlen((char *)tmp_key3) > 1 || strlen((char *)tmp_key4) > 1)
		{
			tmp_encry= Ndis802_11WEPEnabled;
		}
		else
		{
			tmp_encry = Ndis802_11WEPDisabled;
		}
	}
	else if ( tmp_auth == Ndis802_11AuthModeMax) //802.1x
	{
		tmp_encry = Ndis802_11WEPEnabled;
	}
	freeform((char *)form);

	RT_802_11_PREAMBLE                      tmp_preamtype = Rt802_11PreambleAuto;
	NDIS_802_11_RTS_THRESHOLD               tmp_rts = MAX_RTS_THRESHOLD;
	NDIS_802_11_FRAGMENTATION_THRESHOLD     tmp_fragment = 2346;
	NDIS_802_11_POWER_MODE                  tmp_psmode = Ndis802_11PowerModeCAM;
	NDIS_802_11_SSID						SSID;
	NDIS_802_11_MAC_ADDRESS					Bssid;
	
	// Set SSID
	memset(&SSID, 0x00, sizeof(NDIS_802_11_SSID));
	SSID.SsidLength = strlen(tmp_ssid);
	memcpy(SSID.Ssid, (const void *)tmp_ssid, SSID.SsidLength);

	// Set BSSID
	memset(Bssid, 0x00, sizeof(Bssid));
	AtoH(tmp_bssid, Bssid, 6);

	//site_survey_connect
#ifdef WPA_SUPPLICANT_SUPPORT
	if (tmp_auth == Ndis802_11AuthModeWPA ||
		tmp_auth == Ndis802_11AuthModeWPA2 ||
		tmp_auth == Ndis802_11AuthModeMax )//802.1x
	{
		char tmp_key[27];
		if (tmp_defaultkeyid == 1) // 1~4
			strcpy(tmp_key, tmp_key1);
		else if (tmp_defaultkeyid == 2)
			strcpy(tmp_key, tmp_key2);
		else if (tmp_defaultkeyid == 3)
			strcpy(tmp_key, tmp_key3);
		else if (tmp_defaultkeyid == 4)
			strcpy(tmp_key, tmp_key4);

		tmp_defaultkeyid -=1;
		conf_WPASupplicant(tmp_ssid, tmp_keymgmt, tmp_eap, tmp_identity, tmp_password, tmp_cacert, tmp_clientcert, tmp_privatekey, tmp_privatekeypassword, tmp_key, tmp_defaultkeyid, tmp_encry, tmp_tunnel, tmp_auth);
	}
	else
#endif
		sta_connection(tmp_networktype, tmp_auth, tmp_encry, tmp_defaultkeyid, &SSID, Bssid, tmp_wpapsk, tmp_key1, tmp_key2, tmp_key3, tmp_key4, tmp_preamtype, 0, tmp_rts, 0, tmp_fragment, tmp_psmode, 0);  //tmp_channel 0 is auto.
		
	Connection_flag = 1;

}

#ifdef WPA_SUPPLICANT_SUPPORT
void exec_WPASupplicant(char* ssid, NDIS_802_11_WEP_STATUS encryp, NDIS_802_11_AUTHENTICATION_MODE auth, RT_WPA_SUPPLICANT_KEY_MGMT keymgmt, int keyidx, char* wepkey)
{
	// auth mode
	int s, ret;
	unsigned char wpa_supplicant_support = 2, ieee8021x_support=1;
	NDIS_802_11_SSID Ssid;
	char *install_dir;
	char wpaconf[120];

	fprintf(stderr, "exec_WPASupplicant()\n");
	memset(&Ssid, 0x00, sizeof(NDIS_802_11_SSID));
	strcpy((char *)Ssid.Ssid ,ssid);
	Ssid.SsidLength = strlen(ssid);
	
	s = socket(AF_INET, SOCK_DGRAM, 0);
	if (auth == Ndis802_11AuthModeMax)
		auth = Ndis802_11AuthModeOpen;

	if ( keymgmt == Rtwpa_supplicantKeyMgmtNONE)
	{
		wpa_supplicant_support = 0;
		ieee8021x_support = 0;

		ret = OidSetInformation(OID_802_11_SET_IEEE8021X, s, (char *)dev_name, &ieee8021x_support, sizeof(ieee8021x_support));
		if (ret < 0)
			fprintf(stderr, "Set OID_802_11_SET_IEEE8021X has error =%d, ieee8021x_support=%d\n", ret, ieee8021x_support);

		ret = OidSetInformation(RT_OID_WPA_SUPPLICANT_SUPPORT, s, (char *)dev_name, &wpa_supplicant_support, sizeof(wpa_supplicant_support));
		if (ret < 0)
			fprintf(stderr, "Set RT_OID_WPA_SUPPLICANT_SUPPORT has error =%d, wpa_supplicant_support=%d\n", ret, wpa_supplicant_support);
	}
	else
	{
		ret = OidSetInformation(OID_802_11_SET_IEEE8021X, s, (char *)dev_name, &ieee8021x_support, sizeof(ieee8021x_support));
		if (ret < 0)
			fprintf(stderr, "Set OID_802_11_SET_IEEE8021X has error =%d, ieee8021x_support=%d\n", ret, ieee8021x_support);
		
		ret = OidSetInformation(RT_OID_WPA_SUPPLICANT_SUPPORT, s, (char *)dev_name, &wpa_supplicant_support, sizeof(wpa_supplicant_support));
		if (ret < 0)
			fprintf(stderr, "Set RT_OID_WPA_SUPPLICANT_SUPPORT has error =%d, wpa_supplicant_support=%d\n", ret, wpa_supplicant_support);
	}
	
	if( WpaSupplicant_flag )
	{
		install_dir = getenv("INSTALL_DIR");

		if (install_dir == NULL)
			system("/etc/boa/wpa_cli reconfigure");
		else
		{
			memset(wpaconf, 0x00, sizeof(wpaconf));
			sprintf(wpaconf, "%s/etc/boa/wpa_cli reconfigure", install_dir);
			system(wpaconf);
		}		
	}
	
	ret = OidSetInformation(OID_802_11_AUTHENTICATION_MODE, s, (char *)dev_name, &auth, sizeof(auth));
	if (ret < 0)
		fprintf(stderr, "Set OID_802_11_AUTHENTICATION_MODE has error =%d, auth=%d\n", ret, auth);

   	// encryp mode
	 ret = OidSetInformation(OID_802_11_ENCRYPTION_STATUS, s, (char *)dev_name, &encryp, sizeof(encryp));
	if (ret < 0)
		fprintf(stderr, "Set OID_802_11_ENCRYPTION_STATUS has error =%d, encry=%d\n", ret, encryp);

	if ( encryp == Ndis802_11WEPEnabled )
	{
		//MD5
		PNDIS_802_11_WEP	pWepKey = NULL;
		unsigned long		lBufLen;
		int 				nKeyLen;

		nKeyLen = strlen(wepkey);
		if(nKeyLen == 0)
		{
			NDIS_802_11_REMOVE_KEY	removeKey;
			int j=0;
			removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
			removeKey.KeyIndex = keyidx;
			for(j = 0; j < 6; j++)
				removeKey.BSSID[j] = 0xff;
			
			ret = OidSetInformation(OID_802_11_REMOVE_KEY, s, (char *)dev_name, &removeKey, removeKey.Length);
			if (ret < 0)
				fprintf(stderr, "Set OID_802_11_REMOVE_KEY has error =%d, \n", ret);
		}
		else if (strcmp(wepkey, "0"))
		{
			if(nKeyLen == 10)
				nKeyLen = 5;
			else if(nKeyLen == 26)
				nKeyLen = 13;

			lBufLen = sizeof(NDIS_802_11_WEP) + nKeyLen - 1;
			// Allocate Resource
			pWepKey = (PNDIS_802_11_WEP)malloc(lBufLen);
			pWepKey->Length = lBufLen;
			pWepKey->KeyLength = nKeyLen;
			pWepKey->KeyIndex = keyidx;

			//if(keyidx == 1)
			pWepKey->KeyIndex |= 0x80000000;

			if(strlen(wepkey) == 5)
				memcpy(pWepKey->KeyMaterial, wepkey, 5);
			else if(strlen(wepkey) == 10)
				AtoH(wepkey, pWepKey->KeyMaterial, 5);
			else if(strlen(wepkey) == 13)
				memcpy(pWepKey->KeyMaterial, wepkey, 13);
			else if(strlen(wepkey) == 26)
				AtoH(wepkey, pWepKey->KeyMaterial, 13);

			OidSetInformation(OID_802_11_ADD_WEP, s, (char *)dev_name, pWepKey, pWepKey->Length);
			free(pWepKey);
		}
	}


	// set ssid for associate
	nvram_set("staConnectedSSID", (char *)&Ssid.Ssid);
	ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, &Ssid, sizeof(NDIS_802_11_SSID));
	if (ret < 0)
	{
		//must retry set ssid for 2870 sta scan in process
		ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, &Ssid, sizeof(NDIS_802_11_SSID));
		if (ret < 0)	
			fprintf(stderr, "Set OID_802_11_SSID has error =%d, pSsid->Ssid=%s\n", ret, Ssid.Ssid);
	}
	close(s);

	if( WpaSupplicant_flag == FALSE)
	{
		install_dir = getenv("INSTALL_DIR");

		memset(wpaconf, 0x00, sizeof(wpaconf));
		if (install_dir == NULL)
		{
			sprintf(wpaconf, "/etc/boa/wpa_supplicant -B -i%s -c/etc/boa/wpa_supplicant.conf -Dralink -d", (char *)dev_name);
		}
		else
		{
			sprintf(wpaconf, "%s/etc/boa/wpa_supplicant -B -i%s -c%s/etc/boa/wpa_supplicant.conf -Dralink -d", install_dir, (char *)dev_name, install_dir);
		}
		system(wpaconf);

		WpaSupplicant_flag = TRUE;
	}
}

void conf_WPASupplicant(char* ssid, RT_WPA_SUPPLICANT_KEY_MGMT keymgmt, RT_WPA_SUPPLICANT_EAP eap, char* identity, char* password, char* cacert, char* clientcert, char* privatekey, char* privatekeypassword, char* wepkey, int keyidx, NDIS_802_11_WEP_STATUS encryp, RT_WPA_SUPPLICANT_TUNNEL tunnel, NDIS_802_11_AUTHENTICATION_MODE auth)
{
	FILE *wsconf;
	char *install_dir;
	char wpaconf[60];

	install_dir = getenv("INSTALL_DIR");
	memset(wpaconf, 0x00, sizeof(wpaconf));

	if (install_dir == NULL)
		sprintf(wpaconf, "/etc/boa/wpa_supplicant.conf");
	else		
		sprintf(wpaconf, "%s/etc/boa/wpa_supplicant.conf", install_dir);
	
	wsconf = fopen(wpaconf, "w+");

	fprintf(wsconf, "ctrl_interface=/var/run/wpa_supplicant\n");
	fprintf(wsconf, "eapol_version=1\n");
	fprintf(wsconf, "ap_scan=0\n");
	fprintf(wsconf, "network={\n");
	fprintf(wsconf, "ssid=\"%s\"\n", ssid);

	if ( keymgmt == Rtwpa_supplicantKeyMgmtWPAEAP )
	{
		fprintf(wsconf, "key_mgmt=%s\n", "WPA-EAP");
		
		if ( auth == Ndis802_11AuthModeWPA)
			fprintf(wsconf, "proto=WPA\n");
		else if ( auth == Ndis802_11AuthModeWPA2)
			fprintf(wsconf, "proto=RSN\n");
		
		if ( encryp == Ndis802_11Encryption2Enabled )//tkip
		{			
			fprintf(wsconf, "pairwise=TKIP\n");
			fprintf(wsconf, "group=TKIP\n");
		}
		else if ( encryp == Ndis802_11Encryption3Enabled ) //aes
		{
			fprintf(wsconf, "pairwise=CCMP TKIP\n");
			fprintf(wsconf, "group=CCMP TKIP\n");
		}

	}
	else if ( keymgmt == Rtwpa_supplicantKeyMgmtIEEE8021X )
	{
		fprintf(wsconf, "key_mgmt=%s\n", "IEEE8021X");
		if (eap == Rtwpa_supplicantEAPTLS || eap == Rtwpa_supplicantEAPTTLS)
			fprintf(wsconf, "eapol_flags=3\n");
		else if (eap == Rtwpa_supplicantEAPMD5)
			fprintf(wsconf, "eapol_flags=0\n");
	}
	else if ( keymgmt == Rtwpa_supplicantKeyMgmtNONE)
	{
		fprintf(wsconf, "key_mgmt=%s\n", "NONE");
		fprintf(wsconf, "}\n");
		fclose(wsconf);
		exec_WPASupplicant(ssid, encryp, auth, keymgmt, keyidx, wepkey);
		return;
	}
	

	//id
	fprintf(wsconf, "identity=\"%s\"\n",identity);

	//CA cert
	if( strcmp(cacert, "0" ) != 0 && strcmp(cacert, "") !=0 ) //option
		fprintf(wsconf, "ca_cert=\"%s\"\n", cacert);

	//eap
	switch(eap)
	{
		case Rtwpa_supplicantEAPTLS:
			fprintf(wsconf, "eap=TLS\n");
			fprintf(wsconf, "client_cert=\"%s\"\n", clientcert);
			fprintf(wsconf, "private_key=\"%s\"\n", privatekey);
			fprintf(wsconf, "private_key_passwd=\"%s\"\n", privatekeypassword);
			break;
		case Rtwpa_supplicantEAPTTLS:
			fprintf(wsconf, "eap=TTLS\n");
			if( strcmp(clientcert, "0" ) != 0 && strcmp(clientcert, "") !=0 ) //option
			{
				fprintf(wsconf, "client_cert=\"%s\"\n", clientcert);
				fprintf(wsconf, "private_key=\"%s\"\n", privatekey);
				fprintf(wsconf, "private_key_passwd=\"%s\"\n", privatekeypassword);
			}
			fprintf(wsconf, "password=\"%s\"\n", password);
			if (tunnel == Rtwpa_supplicantTUNNELMSCHAPV2)
				fprintf(wsconf, "phase2=\"auth=MSCHAPV2\"\n");
			else if (tunnel == Rtwpa_supplicantTUNNELMSCHAP)
				fprintf(wsconf, "phase2=\"auth=MSCHAP\"\n");
			else if (tunnel == Rtwpa_supplicantTUNNELPAP)
				fprintf(wsconf, "phase2=\"auth=PAP\"\n");
			break;
			
		case Rtwpa_supplicantEAPPEAP:
			fprintf(wsconf, "eap=PEAP\n");
			if( strcmp(clientcert, "0" ) != 0 && strcmp(clientcert, "") !=0) //option
			{
				fprintf(wsconf, "client_cert=\"%s\"\n", clientcert);
				fprintf(wsconf, "private_key=\"%s\"\n", privatekey);
				fprintf(wsconf, "private_key_passwd=\"%s\"\n", privatekeypassword);
			}
			fprintf(wsconf, "password=\"%s\"\n", password);
			fprintf(wsconf, "phase1=\"peaplable=0\"\n");

			if (tunnel == Rtwpa_supplicantTUNNELMSCHAPV2)
				fprintf(wsconf, "phase2=\"auth=MSCHAPV2\"\n");

			break;
		case Rtwpa_supplicantEAPMD5:
			fprintf(wsconf, "eap=MD5\n");
			fprintf(wsconf, "password=\"%s\"\n", password);
			fprintf(wsconf, "wep_tx_keyidx=%d\n", keyidx);
			if (strlen(wepkey) == 5 || strlen(wepkey) == 13)
				fprintf(wsconf, "wep_key%d=\"%s\"\n", keyidx, wepkey);
			else
				fprintf(wsconf, "wep_key%d=%s\n", keyidx, wepkey);
			break;
		default:
			break;
	}

	fprintf(wsconf, "}\n");
	fclose(wsconf);
	exec_WPASupplicant(ssid, encryp, auth, keymgmt, keyidx, wepkey);
}

#endif

void sta_connection(int tmp_networktype, int tmp_auth, int tmp_encry, int tmp_defaultkeyid, PNDIS_802_11_SSID pSsid, NDIS_802_11_MAC_ADDRESS Bssid, char *tmp_wpapsk, char *tmp_key1, char *tmp_key2, char *tmp_key3, char *tmp_key4, RT_802_11_PREAMBLE tmp_preamtype, int tmp_rtscheck, NDIS_802_11_RTS_THRESHOLD tmp_rts, int tmp_fragmentcheck, NDIS_802_11_FRAGMENTATION_THRESHOLD tmp_fragment, NDIS_802_11_POWER_MODE tmp_psmode, int tmp_channel)
{
	int s, ret, nKeyLen=0, j, i;
	NDIS_802_11_REMOVE_KEY		removeKey;
	PNDIS_802_11_KEY			pKey = NULL;
	PNDIS_802_11_WEP			pWepKey = NULL;
	unsigned long				lBufLen;
	unsigned char				keyMaterial[40];
	NDIS_802_11_TX_POWER_LEVEL	lTransPower = MAX_TX_POWER_LEVEL;
	NDIS_802_11_CONFIGURATION	Configuration;
	char tmp_buf[4];

#ifdef WPA_SUPPLICANT_SUPPORT
	if (WpaSupplicant_flag)
	{
		char Null[1]="";
		conf_WPASupplicant((char *)pSsid->Ssid,  Rtwpa_supplicantKeyMgmtNONE, 0, Null, Null, Null, Null, Null, Null, Null, 0, Ndis802_11WEPDisabled, 0, Ndis802_11AuthModeOpen);
	}
#endif

	memset(tmp_buf, 0x00, sizeof(tmp_buf));
	nvram_set("staWpsEnable", "0");

	///fprintf(stderr, "sta_connection()\n");
	s = socket(AF_INET, SOCK_DGRAM, 0);

	//step 0: OID_802_11_INFRASTRUCTURE_MODE
	ret = OidSetInformation(OID_802_11_INFRASTRUCTURE_MODE, s, (char *)dev_name, &tmp_networktype, sizeof(int));
	if (ret < 0)
		fprintf(stderr, "Set OID_802_11_INFRASTRUCTURE_MODE has error =%d, networktype=%d\n", ret, tmp_networktype);

	//step 1:
	OidSetInformation(OID_802_11_TX_POWER_LEVEL, s, (char *)dev_name, &lTransPower, sizeof(NDIS_802_11_TX_POWER_LEVEL));

	if(!tmp_rtscheck)
		tmp_rts = 2347;
	OidSetInformation(OID_802_11_RTS_THRESHOLD, s, (char *)dev_name, &tmp_rts, sizeof(NDIS_802_11_RTS_THRESHOLD));


	if(tmp_fragmentcheck)
		OidSetInformation(OID_802_11_FRAGMENTATION_THRESHOLD, s, (char *)dev_name, &selectedProfileSetting->Fragment, sizeof(NDIS_802_11_FRAGMENTATION_THRESHOLD));
	else
	{
		tmp_fragment = 2346;
		OidSetInformation(OID_802_11_FRAGMENTATION_THRESHOLD, s, (char *)dev_name, &tmp_fragment, sizeof(NDIS_802_11_FRAGMENTATION_THRESHOLD));
	}
	
	if (tmp_networktype == Ndis802_11Infrastructure)
	{
		OidSetInformation(OID_802_11_POWER_MODE, s, (char *)dev_name, &tmp_psmode, sizeof(NDIS_802_11_POWER_MODE));
		OidSetInformation(RT_OID_802_11_PREAMBLE, s, (char *)dev_name, &tmp_preamtype, sizeof(RT_802_11_PREAMBLE));
	}
	else if (tmp_networktype == Ndis802_11IBSS)
	{
		unsigned long	lFreq = 0;
		OidQueryInformation(OID_802_11_CONFIGURATION, s, (char *)dev_name, &Configuration, sizeof(Configuration));

		for(i = 0; i < G_nChanFreqCount; i++)
		{
			if(tmp_channel == ChannelFreqTable[i].lChannel)
			{
				lFreq = ChannelFreqTable[i].lFreq;
				break;
			}
		}

		if(lFreq != Configuration.DSConfig)
		{
			Configuration.DSConfig = lFreq;
			ret = OidSetInformation(OID_802_11_CONFIGURATION, s, (char *)dev_name, &Configuration, sizeof(Configuration));
			if (ret < 0)
				fprintf(stderr, "Set OID_802_11_CONFIGURATION has error=%d\n",ret);
		}
	}


	//step 2: Security mode
	sprintf(tmp_buf, "%d", tmp_auth);
	nvram_set("staConnectedAuth", (char *)&tmp_buf);
    ret = OidSetInformation(OID_802_11_AUTHENTICATION_MODE, s, (char *)dev_name, &tmp_auth, sizeof(tmp_auth));
	if (ret < 0)
		fprintf(stderr, "Set OID_802_11_AUTHENTICATION_MODE has error =%d, auth=%d\n", ret, tmp_auth);

	sprintf(tmp_buf, "%d", tmp_encry);
	nvram_set("staConnectedEncryp", (char *)&tmp_buf);
    ret = OidSetInformation(OID_802_11_ENCRYPTION_STATUS, s, (char *)dev_name, &tmp_encry, sizeof(tmp_encry));
	if (ret < 0)
		fprintf(stderr, "Set OID_802_11_ENCRYPTION_STATUS has error =%d, encry=%d\n", ret, tmp_encry);


	if ( tmp_encry == Ndis802_11WEPEnabled )
	{
		//----------------------------------------------------------//
		//Key 1
		//----------------------------------------------------------//
	
		nKeyLen = strlen(tmp_key1);
		if(nKeyLen == 0)
		{
			removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
			removeKey.KeyIndex = 0;
			for(j = 0; j < 6; j++)
				removeKey.BSSID[j] = 0xff;
					ret = OidSetInformation(OID_802_11_REMOVE_KEY, s, (char *)dev_name, &removeKey, removeKey.Length);
			if (ret < 0)
				fprintf(stderr, "Set OID_802_11_REMOVE_KEY has error =%d, \n", ret);
		}
		else if (strcmp(tmp_key1, "0"))
		{
			if(nKeyLen == 10)
				nKeyLen = 5;
			else if(nKeyLen == 26)
				nKeyLen = 13;

			lBufLen = sizeof(NDIS_802_11_WEP) + nKeyLen - 1;
			// Allocate Resource
			pWepKey = (PNDIS_802_11_WEP)malloc(lBufLen);
			pWepKey->Length = lBufLen;
			pWepKey->KeyLength = nKeyLen;
			pWepKey->KeyIndex = 0;

			if(tmp_defaultkeyid == 1)
			{
				pWepKey->KeyIndex |= 0x80000000;
				nvram_set("staConnectedDefaultKeyId", "1");
			}

			if(strlen(tmp_key1) == 5)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key1, 5);
				nvram_set("staConnectedKey1Type", "1");
			}
			else if(strlen(tmp_key1) == 10)
			{
				AtoH(tmp_key1, pWepKey->KeyMaterial, 5);
				nvram_set("staConnectedKey1Type", "0");
			}
			else if(strlen(tmp_key1) == 13)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key1, 13);
				nvram_set("staConnectedKey1Type", "1");
			}
			else if(strlen(tmp_key1) == 26)
			{
				AtoH(tmp_key1, pWepKey->KeyMaterial, 13);
				nvram_set("staConnectedKey1Type", "0");
			}
			
			nvram_set("staConnectedKey1Str", tmp_key1);
			OidSetInformation(OID_802_11_ADD_WEP, s, (char *)dev_name, pWepKey, pWepKey->Length);
			free(pWepKey);
		}

        //----------------------------------------------------------//
        //Key 2
        //----------------------------------------------------------//
        nKeyLen = strlen(tmp_key2);
        if(nKeyLen == 0)
        {
            removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
            removeKey.KeyIndex = 1;
            for(j = 0; j < 6; j++)
                removeKey.BSSID[j] = 0xff;
            OidSetInformation(OID_802_11_REMOVE_KEY, s, (char *)dev_name, &removeKey, removeKey.Length);
        }
		else if (strcmp(tmp_key2, "0"))
        {
            if(nKeyLen == 10)
                nKeyLen = 5;
            else if(nKeyLen == 26)
                nKeyLen = 13;

            lBufLen = sizeof(NDIS_802_11_WEP) + nKeyLen - 1;
            // Allocate Resource
            pWepKey = (PNDIS_802_11_WEP)malloc(lBufLen);
            pWepKey->Length = lBufLen;
            pWepKey->KeyLength = nKeyLen;
            pWepKey->KeyIndex = 1;

            if(tmp_defaultkeyid == 2)
			{
				pWepKey->KeyIndex |= 0x80000000;
				nvram_set("staConnectedDefaultKeyId", "2");
			}

			if(strlen(tmp_key2) == 5)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key2, 5);
				nvram_set("staConnectedKey2Type", "1");
			}
			else if(strlen(tmp_key2) == 10)
			{
				AtoH(tmp_key2, pWepKey->KeyMaterial, 5);
				nvram_set("staConnectedKey2Type", "0");
			}
			else if(strlen(tmp_key2) == 13)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key2, 13);
				nvram_set("staConnectedKey2Type", "1");
			}
			else if(strlen(tmp_key2) == 26)
			{
				AtoH(tmp_key2, pWepKey->KeyMaterial, 13);
				nvram_set("staConnectedKey2Type", "0");
			}
			
			nvram_set("staConnectedKey2Str", tmp_key2);

            OidSetInformation(OID_802_11_ADD_WEP, s, (char *)dev_name, pWepKey, pWepKey->Length);

            free(pWepKey);
        }
        //----------------------------------------------------------//
        //Key 3
        //----------------------------------------------------------//
        nKeyLen = strlen(tmp_key3);
        if(nKeyLen == 0)
        {
            removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
            removeKey.KeyIndex = 2;
            for(j = 0; j < 6; j++)
                removeKey.BSSID[j] = 0xff;
            OidSetInformation(OID_802_11_REMOVE_KEY, s, (char *)dev_name, &removeKey, removeKey.Length);
        }
		else if (strcmp(tmp_key3, "0"))
        {
            if(nKeyLen == 10)
                nKeyLen = 5;
            else if(nKeyLen == 26)
                nKeyLen = 13;

            lBufLen = sizeof(NDIS_802_11_WEP) + nKeyLen - 1;
            // Allocate Resource
            pWepKey = (PNDIS_802_11_WEP)malloc(lBufLen);
            pWepKey->Length = lBufLen;
            pWepKey->KeyLength = nKeyLen;
            pWepKey->KeyIndex = 2;
            if(tmp_defaultkeyid == 3)
			{
				pWepKey->KeyIndex |= 0x80000000;
				nvram_set("staConnectedDefaultKeyId", "3");
			}

			if(strlen(tmp_key3) == 5)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key1, 5);
				nvram_set("staConnectedKey3Type", "3");
			}
			else if(strlen(tmp_key3) == 10)
			{
				AtoH(tmp_key3, pWepKey->KeyMaterial, 5);
				nvram_set("staConnectedKey3Type", "0");
			}
			else if(strlen(tmp_key3) == 13)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key3, 13);
				nvram_set("staConnectedKey3Type", "1");
			}
			else if(strlen(tmp_key3) == 26)
			{
				AtoH(tmp_key3, pWepKey->KeyMaterial, 13);
				nvram_set("staConnectedKey3Type", "0");
			}
			
			nvram_set("staConnectedKey3Str", tmp_key3);

			OidSetInformation(OID_802_11_ADD_WEP, s, (char *)dev_name, pWepKey, pWepKey->Length);
            free(pWepKey);
        }
        //----------------------------------------------------------//
        //Key 4
        //----------------------------------------------------------//
        nKeyLen = strlen(tmp_key4);
        if(nKeyLen == 0)
        {
            removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
            removeKey.KeyIndex = 3;
            for(j = 0; j < 6; j++)
                removeKey.BSSID[j] = 0xff;
            OidSetInformation(OID_802_11_REMOVE_KEY, s, (char *)dev_name, &removeKey, removeKey.Length);
        }
		else if (strcmp(tmp_key4, "0"))
        {
            if(nKeyLen == 10)
                nKeyLen = 5;
            else if(nKeyLen == 26)
                nKeyLen = 13;

            lBufLen = sizeof(NDIS_802_11_WEP) + nKeyLen - 1;
            // Allocate Resource
            pWepKey = (PNDIS_802_11_WEP)malloc(lBufLen);
            pWepKey->Length = lBufLen;
            pWepKey->KeyLength = nKeyLen;
            pWepKey->KeyIndex = 3;
            if(tmp_defaultkeyid == 4)
			{
				pWepKey->KeyIndex |= 0x80000000;
				nvram_set("staConnectedDefaultKeyId", "4");
			}

			if(strlen(tmp_key4) == 5)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key4, 5);
				nvram_set("staConnectedKey4Type", "1");
			}
			else if(strlen(tmp_key4) == 10)
			{
				AtoH(tmp_key4, pWepKey->KeyMaterial, 5);
				nvram_set("staConnectedKey4Type", "0");
			}
			else if(strlen(tmp_key4) == 13)
			{
				memcpy(pWepKey->KeyMaterial, tmp_key4, 13);
				nvram_set("staConnectedKey4Type", "1");
			}
			else if(strlen(tmp_key4) == 26)
			{
				AtoH(tmp_key4, pWepKey->KeyMaterial, 13);
				nvram_set("staConnectedKey4Type", "0");
			}
			
			nvram_set("staConnectedKey4Str", tmp_key4);

			OidSetInformation(OID_802_11_ADD_WEP, s, (char *)dev_name, pWepKey, pWepKey->Length);
			free(pWepKey);
        }
	}
	else if ( tmp_auth == Ndis802_11AuthModeWPAPSK || tmp_auth == Ndis802_11AuthModeWPA2PSK || tmp_auth == Ndis802_11AuthModeWPANone)
	{
        nKeyLen = 32;
		lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
		// Allocate Resouce
		pKey = (PNDIS_802_11_KEY)malloc(lBufLen); // Don't use GMEM_ZEROINIT to get random key
		pKey->Length = lBufLen;
		pKey->KeyLength = nKeyLen;
		pKey->KeyIndex = 0x80000000;

		nvram_set("staConnectedWpaPsk", tmp_wpapsk);
		if (strlen(tmp_wpapsk) == 64)
		{
			AtoH(tmp_wpapsk, keyMaterial, 32);
			memcpy(pKey->KeyMaterial, keyMaterial, 32);		
		}
		else
		{
			PasswordHash(tmp_wpapsk, pSsid->Ssid, pSsid->SsidLength, keyMaterial);
			memcpy(pKey->KeyMaterial, keyMaterial, 32);
		}
		OidSetInformation(RT_OID_802_11_ADD_WPA, s, (char *)dev_name, pKey, pKey->Length);
		free(pKey);
	}

	//step 3: SSID
	if ( tmp_networktype == Ndis802_11IBSS ) // Ad hoc use SSID
	{
		ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, pSsid, sizeof(NDIS_802_11_SSID));
		if (ret < 0)
		{
			//must retry set ssid for 2870 sta scan in process
			ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, pSsid, sizeof(NDIS_802_11_SSID));
			if (ret < 0)	
				fprintf(stderr, "Set OID_802_11_SSID has error =%d, pSsid->Ssid=%s\n", ret, pSsid->Ssid);
		}
		else
		{
			memcpy(&G_SSID, pSsid, sizeof(NDIS_802_11_SSID));
			nvram_set("staConnectedSSID", (char *)&pSsid->Ssid);
		}
	}
	else
	{
		ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, pSsid, sizeof(NDIS_802_11_SSID));
		if (ret < 0)
		{
			//must retry set ssid for 2870 sta scan in process
			ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, pSsid, sizeof(NDIS_802_11_SSID));
			if (ret < 0)	
				fprintf(stderr, "Set OID_802_11_SSID has error =%d, pSsid->Ssid=%s\n", ret, pSsid->Ssid);
		}
		else
		{
			memcpy(&G_SSID, pSsid, sizeof(NDIS_802_11_SSID));
			nvram_set("staConnectedSSID", (char *)&pSsid->Ssid);
		}
	}
	sleep(1);
	close(s);
	//fprintf(stderr, "sta_connection() end--\n");
}

void cgi_sta_advance_apply(char *data, FILE *out)
{
	struct httpform *form=NULL;
	char *name=NULL;
	char tmpString[8];
	int i, s, ret, country_region_a=0, country_region_bg=0;
	int bg_protection=0, tx_burst=0, short_slot_time=0, wireless_mode=0, tx_rate=0;
	int ht_extchannel=0, ht_mode=0, ht_bw=0, ht_gi=0, ht_stbc=0, ht_mcs=0; //11n, kathy
	unsigned long country_region=0;
	RT_802_11_STA_CONFIG	configStation;
	NDIS_802_11_RATES	aryRates;
	unsigned char  radio_status=0 ,b_tx_burst=0, b_short_slot_time=0;
	char wpaconf[80];
	char *install_dir=NULL;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	bzero(tmpString, sizeof(tmpString));

	form=parseargs(data);
	for(i=0; i < form->nv_ct; i++)
	{
		name = form->nameval[i].name;
		//fprintf(stderr, "name = %s\n", name);
		//fprintf(stderr, "i = %d/%d\n", i, form->nv_ct);
		//fprintf(stderr, "value = %s\n", form->nameval[i].value);

		if (strcmp(name, "radiohiddenButton") == 0)
		{
			radio_status = atoi(form->nameval[i].value);
			if (radio_status < 2)
			{
				OidSetInformation(RT_OID_802_11_RADIO, s, (char *)dev_name, &radio_status, sizeof(radio_status));
				if (radio_status == 1 )
				{
					ret = OidSetInformation(OID_802_11_BSSID_LIST_SCAN, s, (char *)dev_name, 0, 0);
					if (ret < 0)
						fprintf(stderr, "Set OID_802_11_BSSID_LIST_SCAN has error =%d, \n", ret);

					sleep(3);

					ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, &G_SSID, sizeof(NDIS_802_11_SSID));
					if (ret < 0)
					{
						ret = OidSetInformation(OID_802_11_SSID, s, (char *)dev_name, &G_SSID, sizeof(NDIS_802_11_SSID));
						if (ret < 0)
							fprintf(stderr, "Set OID_802_11_SSID has error =%d, \n", ret);
					}
				}

				return;
			}
		}
		
		if (strcmp(name, "wireless_mode") == 0)
		{
			wireless_mode = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staWirelessMode", tmpString);			
		}

		if (strcmp(name, "country_region_bg") == 0)
		{
			country_region_bg = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staCountryRegionBG", tmpString);
		}

		if (strcmp(name, "country_region_a") == 0)
		{
			country_region_a = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staCountryRegionA", tmpString);
		}

		if (strcmp(name, "bg_protection") == 0)
		{
			bg_protection = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staBGProtection", tmpString);
		}

		if (strcmp(name, "tx_rate") == 0)
		{
			tx_rate = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staTxRate", tmpString);
		}

		if (strcmp(name, "tx_burst") == 0)
		{
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staTxBurst", "1");
			tx_burst = 1;
			b_tx_burst = 1;
		}

		if (strcmp(name, "short_slot_time") == 0)
		{
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staShortSlotTime", "1");
			short_slot_time = 1;
			b_short_slot_time = 1;
		}

		// for 11n , rt2860 sta, kathy
		if (strcmp(name, "n_mode") == 0) //ht mode
		{
			ht_mode = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staHT_OpMode", tmpString);
		}

		if (strcmp(name, "n_bandwidth") == 0)
		{
			ht_bw = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staHT_BW", tmpString);
		}

		if (strcmp(name, "n_gi") == 0)
		{
			ht_gi = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staHT_GI", tmpString);
		}

		if (strcmp(name, "n_mcs") == 0)
		{
			ht_mcs = atoi(form->nameval[i].value);
			sprintf(tmpString, "%s", form->nameval[i].value);
			nvram_set("staHT_MCS", tmpString);
		}

	}
	freeform((char *)form);

	if( b_tx_burst == 0)
	{
		nvram_set("staTxBurst", "0");
		tx_burst = 0;
	}

	if ( b_short_slot_time == 0)
	{
		nvram_set("staShortSlotTime", "0");
		short_slot_time = 0;
	}

	//set wireless mode
	ret = OidSetInformation(RT_OID_802_11_PHY_MODE, s, (char *)dev_name, &wireless_mode, sizeof(wireless_mode));
	if(ret < 0)
		fprintf(stderr, "cgi_sta_advance_apply(): Set RT_OID_802_11_PHY_MODE has error =%d, \n", ret);

#ifdef RT2860
	// set 11n ht phy mode
	if (wireless_mode >= PHY_11N)
	{
		OID_BACAP_STRUC	BACap;
		OID_SET_HT_PHYMODE phymode;
		
		phymode.PhyMode = wireless_mode;
		phymode.ExtOffset = ht_extchannel;
		phymode.HtMode = ht_mode;
		phymode.TransmitNo = 2; //Now always use 2
		phymode.BW = ht_bw;
		phymode.SHORTGI = ht_gi;
		phymode.STBC = ht_stbc;
		phymode.MCS = ht_mcs;

		ret = OidSetInformation(RT_OID_802_11_SET_HT_PHYMODE, s, (char *)dev_name, &phymode, sizeof(phymode));
		if(ret < 0)
			fprintf(stderr, "cgi_sta_advance_apply(): Set RT_OID_802_11_SET_HT_PHYMODE has error =%d, \n", ret);


		BACap.AutoBA = TRUE;
		ret = OidSetInformation(RT_OID_802_11_SET_IMME_BA_CAP, s, (char *)dev_name, &BACap, sizeof(BACap));
		if(ret < 0)
			fprintf(stderr, "cgi_sta_advance_apply(): Set RT_OID_802_11_SET_IMME_BA_CAP has error =%d, \n", ret);

	}
	else
	{
		OID_BACAP_STRUC	BACap;
		
		BACap.AutoBA = FALSE;
		OidSetInformation(RT_OID_802_11_SET_IMME_BA_CAP, s, (char *)dev_name, &BACap, sizeof(BACap));
	}
#endif

	//set country region
	country_region = country_region_bg | (country_region_a << 8);
	ret = OidSetInformation(RT_OID_802_11_COUNTRY_REGION, s, (char *)dev_name, &country_region, sizeof(country_region));
	if(ret < 0)
		fprintf(stderr, "cgi_sta_advance_apply(): Set RT_OID_802_11_COUNTRY_REGION has error =%d, \n", ret);

	OidQueryInformation(RT_OID_802_11_STA_CONFIG, s, (char *)dev_name, &configStation, sizeof(configStation));
	
	configStation.EnableTurboRate = 0; //false
	configStation.EnableTxBurst = tx_burst;
	configStation.UseBGProtection = bg_protection;
	configStation.UseShortSlotTime = short_slot_time;
	
	OidSetInformation(RT_OID_802_11_STA_CONFIG, s, (char *)dev_name, &configStation, sizeof(configStation));

	// set rate
	memset(aryRates, 0x00, sizeof(NDIS_802_11_RATES));
	if (wireless_mode == PHY_11A || wireless_mode == PHY_11G)
	{
		switch (tx_rate)
		{
			case 0:
				aryRates[0] = 0x6c; // 54Mbps
				aryRates[1] = 0x60; // 48Mbps
				aryRates[2] = 0x48; // 36Mbps
				aryRates[3] = 0x30; // 24Mbps
				aryRates[4] = 0x24; // 18M
				aryRates[5] = 0x18; // 12M
				aryRates[6] = 0x12; // 9M
				aryRates[7] = 0x0c; // 6M
				break;
			case 1:
				aryRates[0] = 0x0c; // 6M
				break;
			case 2:
				aryRates[0] = 0x12; // 9M
				break;
			case 3:
				aryRates[0] = 0x18; // 12M
				break;
			case 4:
				aryRates[0] = 0x24; // 18M
				break;
			case 5:
				aryRates[0] = 0x30; // 24M
				break;
			case 6:
				aryRates[0] = 0x48; // 36M
				break;
			case 7:
				aryRates[0] = 0x60; // 48M
				break;
			case 8:
				aryRates[0] = 0x6c; // 54M
				break;
		}
	}
	else if ((wireless_mode == PHY_11BG_MIXED) || (wireless_mode == PHY_11B) ||
		(wireless_mode == PHY_11ABG_MIXED))
	{
		switch(tx_rate)
		{
			case 0:
				switch(wireless_mode)
				{
					case PHY_11BG_MIXED: // B/G Mixed
					case PHY_11ABG_MIXED: // A/B/G Mixed
						aryRates[0] = 0x6c; // 54Mbps
						aryRates[1] = 0x60; // 48Mbps
						aryRates[2] = 0x48; // 36Mbps
						aryRates[3] = 0x30; // 24Mbps
						aryRates[4] = 0x16; // 11Mbps
						aryRates[5] = 0x0b; // 5.5Mbps
						aryRates[6] = 0x04; // 2Mbps
						aryRates[7] = 0x02; // 1Mbps
						break;
					case PHY_11B: // B Only
						aryRates[0] = 0x16; // 11Mbps
						aryRates[1] = 0x0b; // 5.5Mbps
						aryRates[2] = 0x04; // 2Mbps
						aryRates[3] = 0x02; // 1Mbps
						break;
					case PHY_11A:
						break;   //Not be call, for avoid warning.
				}
				break;
			case 1:
				aryRates[0] = 0x02; // 1M
				break;
			case 2:
				aryRates[0] = 0x04; // 2M
				break;
			case 3:
				aryRates[0] = 0x0b; // 5.5M
				break;
			case 4:
				aryRates[0] = 0x16; // 11M
				break;
			case 5:
				aryRates[0] = 0x0c; // 6M
				break;
			case 6:
				aryRates[0] = 0x12; // 9M
				break;
			case 7:
				aryRates[0] = 0x18; // 12M
				break;
			case 8:
				aryRates[0] = 0x24; // 18M
				break;
			case 9:
				aryRates[0] = 0x30; // 24M
				break;
			case 10:
				aryRates[0] = 0x48; // 36M
				break;
			case 11:
				aryRates[0] = 0x60; // 48M
				break;
			case 12:
				aryRates[0] = 0x6c; // 54M
				break;
		}
	}
#ifdef RT2860	
	if (wireless_mode < PHY_11N)
#endif
		OidSetInformation(OID_802_11_DESIRED_RATES, s, (char *)dev_name, &aryRates, sizeof(NDIS_802_11_RATES));

	OidSetInformation(OID_802_11_BSSID_LIST_SCAN, s, (char *)dev_name, 0, 0);
	close(s);

	install_dir = getenv("INSTALL_DIR");

	if (install_dir == NULL)
	{
		char *pwd=NULL;
		pwd = getenv("PWD");
		memset(wpaconf, 0x00, sizeof(wpaconf));
		sprintf(wpaconf, "%s/../../nvram/make_config_file", pwd);
	}
	else
	{
		memset(wpaconf, 0x00, sizeof(wpaconf));
		sprintf(wpaconf, "%s/WebUI/nvram/make_config_file", install_dir);
	}
	system(wpaconf);
	
	reloadWirelessModule();
}

void cgi_sta_statisics_apply(char *data, FILE *out)
{
	int s;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	OidSetInformation(RT_OID_802_11_RESET_COUNTERS, s, (char *)dev_name, 0, 0);
	close(s);
}

void cgi_sta_link_status_apply(char *data, FILE *out)
{
	struct httpform *form=NULL;
	char *name=NULL;
	int i;

	form=parseargs(data);
	for(i=0; i < form->nv_ct; i++)
	{
		name = form->nameval[i].name;
		fprintf(stderr, "name = %s\n", name);
		fprintf(stderr, "i = %d/%d\n", i, form->nv_ct);
		
		if (strcmp(name, "dbm_checked") == 0)
		{
			G_bdBm_ischeck = 1;
		}
	}

	if( form->nv_ct <= 0 )
		G_bdBm_ischeck = 0;

	freeform((char *)form);
	fprintf(stderr, "G_bdBm_ischeck=%d\n",G_bdBm_ischeck);
}

int init_mbss_value(int idx, char* mbss_value)
{
   mBSSID[idx].enable = 1;
   sprintf(mBSSID[idx].SSID, "%s", mbss_value);
   mBSSID[idx].SecurityMode = 0;
   sprintf(mBSSID[idx].AuthMode, "%s", "OPEN");
   sprintf(mBSSID[idx].EncrypType, "%s", "NONE");
   sprintf(mBSSID[idx].WPAPSK, "%s", "0");
   mBSSID[idx].DefaultKeyID = 1;
   mBSSID[idx].Key1Type = 0;
   sprintf(mBSSID[idx].Key1Str, "%s", "0");
   mBSSID[idx].Key2Type = 0;
   sprintf(mBSSID[idx].Key2Str, "%s", "0");
   mBSSID[idx].Key3Type = 0;
   sprintf(mBSSID[idx].Key3Str, "%s", "0");
   mBSSID[idx].Key4Type = 0;
   sprintf(mBSSID[idx].Key4Str, "%s", "0");
   mBSSID[idx].IEEE8021X = 0;
   mBSSID[idx].TxRate = 0;
   mBSSID[idx].HideSSID = 0;
   mBSSID[idx].PreAuth = 0;
   sprintf(mBSSID[idx].VlanName, "ralink-vlan%d", idx);
   mBSSID[idx].VlanId = 0;
   mBSSID[idx].VlanPriority = 0;

   return 1;
}

/* save_level 0: only change SSID and HideSSID 1: SSID Number change or Security change */
int save_mbss_value_to_flash(int save_level)
{
   int  idx;
   char tmp_buffer[260];
   
   /* SSID */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].SSID);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("SSID", tmp_buffer);

   /* TxRate */
/*
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].TxRate);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("TxRate", tmp_buffer);
*/

   /* HideSSID */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].HideSSID);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("HideSSID", tmp_buffer);

   /* VlanName */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].VlanName);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("VLANName", tmp_buffer);

   /* Vlan ID */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].VlanId);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("VLANID", tmp_buffer);

   /* Vlan Priority */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].VlanPriority);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("VLANPriority", tmp_buffer);

   if (save_level == 0) {
      nvram_commit();
      return 1;
   }

   /* SecurityMode */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].SecurityMode);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("SecurityMode", tmp_buffer);

   /* AuthMode */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].AuthMode);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("AuthMode", tmp_buffer);

   /* EncrypType */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].EncrypType);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("EncrypType", tmp_buffer);

   /* WPAPSK */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         if (strcmp(mBSSID[idx].WPAPSK, "") == 0)
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", "0");
         else
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].WPAPSK);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("WPAPSK", tmp_buffer);

   /* DefaultKeyID */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].DefaultKeyID);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("DefaultKeyID", tmp_buffer);

   /* Key1Type */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].Key1Type);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key1Type", tmp_buffer);

   /* Key1Str */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         if (strcmp(mBSSID[idx].Key1Str, "") == 0)
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", "0");
         else
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].Key1Str);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key1Str", tmp_buffer);

   /* Key2Type */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].Key2Type);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key2Type", tmp_buffer);

   /* Key2Str */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         if (strcmp(mBSSID[idx].Key2Str, "") == 0)
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", "0");
         else
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].Key2Str);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key2Str", tmp_buffer);

   /* Key3Type */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].Key3Type);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key3Type", tmp_buffer);

   /* Key3Str */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         if (strcmp(mBSSID[idx].Key3Str, "") == 0)
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", "0");
         else
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].Key3Str);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key3Str", tmp_buffer);

   /* Key4Type */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].Key4Type);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key4Type", tmp_buffer);

   /* Key4Str */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         if (strcmp(mBSSID[idx].Key4Str, "") == 0)
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", "0");
         else
            sprintf(tmp_buffer+strlen(tmp_buffer),"%s", mBSSID[idx].Key4Str);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("Key4Str", tmp_buffer);

   /* IEEE8021X */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].IEEE8021X);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("IEEE8021X", tmp_buffer);

   /* PreAuth */
   bzero(tmp_buffer, sizeof(char)*260);
   for (idx = 0; idx < 4; idx++) {
      if (mBSSID[idx].enable == 1) {
         sprintf(tmp_buffer+strlen(tmp_buffer),"%d", mBSSID[idx].PreAuth);
         sprintf(tmp_buffer+strlen(tmp_buffer),"%c", ';');
      }
   }
   tmp_buffer[strlen(tmp_buffer) - 1] = '\0';
   nvram_bufset("PreAuth", tmp_buffer);

   nvram_commit();

   return 1;
}

// kathy , for STA Web UI , 2006-1004
//1234567890123456789012345678901234567890123456789012345678901234
